/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sc_fudraw.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 19:18:21 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/


#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------------

// auto strip #include <bf_svx/editeng.hxx>	// EditEngine::IsSimpleCharInput
// auto strip #include <bf_svx/outlobj.hxx>
// auto strip #include <bf_svx/svdobj.hxx>
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #include <bf_svx/svdouno.hxx>
// auto strip #include <bf_svx/svdview.hxx>
// auto strip #include <bf_sfx2/dispatch.hxx>

#include "bf_sc.hrc"
#include "fudraw.hxx"
// auto strip #include "futext.hxx"
// auto strip #include "tabvwsh.hxx"
// auto strip #include "drwlayer.hxx"
// auto strip #include "scresid.hxx"

// #97016#
// auto strip #ifndef SC_DOCSHELL_HXX
// auto strip #include "docsh.hxx"
// auto strip #endif
namespace binfilter {

/*************************************************************************
|*
|* Basisklasse fuer alle Drawmodul-spezifischen Funktionen
|*
\************************************************************************/

/*N*/ FuDraw::FuDraw(ScTabViewShell* pViewSh, Window* pWin, SdrView* pView,
/*N*/ 			   SdrModel* pDoc, SfxRequest& rReq) :
/*N*/ 	FuPoor		(pViewSh, pWin, pView, pDoc, rReq),
/*N*/ 	aNewPointer ( POINTER_ARROW ),
/*N*/ 	aOldPointer ( POINTER_ARROW )
/*N*/ {
/*N*/ }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

/*N*/ FuDraw::~FuDraw()
/*N*/ {
/*N*/ }

/*************************************************************************
|*
|* Modifier-Tasten auswerten
|*
\************************************************************************/

//STRIP001 void FuDraw::DoModifiers(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	//	Shift	= Ortho und AngleSnap
//STRIP001 	//	Control	= Snap (Toggle)
//STRIP001 	//	Alt		= zentrisch
//STRIP001 
//STRIP001 	BOOL bShift	= rMEvt.IsShift();
//STRIP001 	BOOL bCtrl	= rMEvt.IsMod1();
//STRIP001 	BOOL bAlt	= rMEvt.IsMod2();
//STRIP001 
//STRIP001 	ScViewData* pViewData = pViewShell->GetViewData();
//STRIP001 	const ScViewOptions& rOpt = pViewData->GetOptions();
//STRIP001 	const ScGridOptions& rGrid = rOpt.GetGridOptions();
//STRIP001 	BOOL bGridOpt = rGrid.GetUseGridSnap();
//STRIP001 
//STRIP001 	BOOL bOrtho		= bShift;
//STRIP001 	BOOL bAngleSnap	= bShift;
//STRIP001 	BOOL bGridSnap	= ( bGridOpt != bCtrl );		// andere Snap's nicht unterstuetzt
//STRIP001 	BOOL bCenter	= bAlt;
//STRIP001 
//STRIP001 	if (pView->IsOrtho() != bOrtho)
//STRIP001 		pView->SetOrtho(bOrtho);
//STRIP001 	if (pView->IsAngleSnapEnabled() != bAngleSnap)
//STRIP001 		pView->SetAngleSnapEnabled(bAngleSnap);

/*	Control fuer Snap beisst sich beim Verschieben mit "kopieren" !!!

	if (pView->IsGridSnap() != bGridSnap)
		pView->SetGridSnap(bGridSnap);
	if (pView->IsSnapEnabled() != bGridSnap)
		pView->SetSnapEnabled(bGridSnap);
*/
//STRIP001 	if (pView->IsCreate1stPointAsCenter() != bCenter)
//STRIP001 		pView->SetCreate1stPointAsCenter(bCenter);
//STRIP001 	if (pView->IsResizeAtCenter() != bCenter)
//STRIP001 		pView->SetResizeAtCenter(bCenter);
//STRIP001 }

//STRIP001 void FuDraw::ResetModifiers()
//STRIP001 {
//STRIP001 	ScViewData* pViewData = pViewShell->GetViewData();
//STRIP001 	const ScViewOptions& rOpt = pViewData->GetOptions();
//STRIP001 	const ScGridOptions& rGrid = rOpt.GetGridOptions();
//STRIP001 	BOOL bGridOpt = rGrid.GetUseGridSnap();
//STRIP001 
//STRIP001 	if (pView->IsOrtho())
//STRIP001 		pView->SetOrtho(FALSE);
//STRIP001 	if (pView->IsAngleSnapEnabled())
//STRIP001 		pView->SetAngleSnapEnabled(FALSE);
//STRIP001 
//STRIP001 	if (pView->IsGridSnap() != bGridOpt)
//STRIP001 		pView->SetGridSnap(bGridOpt);
//STRIP001 	if (pView->IsSnapEnabled() != bGridOpt)
//STRIP001 		pView->SetSnapEnabled(bGridOpt);
//STRIP001 
//STRIP001 	if (pView->IsCreate1stPointAsCenter())
//STRIP001 		pView->SetCreate1stPointAsCenter(FALSE);
//STRIP001 	if (pView->IsResizeAtCenter())
//STRIP001 		pView->SetResizeAtCenter(FALSE);
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonDown-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuDraw::MouseButtonDown(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	DoModifiers( rMEvt );
//STRIP001 	return FALSE;
//STRIP001 }

/*************************************************************************
|*
|* MouseMove-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuDraw::MouseMove(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	//	#106438# evaluate modifiers only if in a drawing layer action
//STRIP001 	//	(don't interfere with keyboard shortcut handling)
//STRIP001 	if (pView->IsAction())
//STRIP001 		DoModifiers( rMEvt );
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }

/*************************************************************************
|*
|* MouseButtonUp-event
|*
\************************************************************************/

//STRIP001 BOOL __EXPORT FuDraw::MouseButtonUp(const MouseEvent& rMEvt)
//STRIP001 {
//STRIP001 	// #95491# remember button state for creation of own MouseEvents
//STRIP001 	SetMouseButtonCode(rMEvt.GetButtons());
//STRIP001 
//STRIP001 	ResetModifiers();
//STRIP001 	return FALSE;
//STRIP001 }

/*************************************************************************
|*
|* Tastaturereignisse bearbeiten
|*
|* Wird ein KeyEvent bearbeitet, so ist der Return-Wert TRUE, andernfalls
|* FALSE.
|*
\************************************************************************/

//STRIP001 BOOL lcl_KeyEditMode( SdrObject* pObj, ScTabViewShell* pViewShell, const KeyEvent* pInitialKey )
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 	if ( pObj && pObj->ISA(SdrTextObj) && !pObj->ISA(SdrUnoObj) )
//STRIP001 	{
//STRIP001 		// start text edit - like FuSelection::MouseButtonUp,
//STRIP001 		// but with bCursorToEnd instead of mouse position
//STRIP001 
//STRIP001 		OutlinerParaObject* pOPO = pObj->GetOutlinerParaObject();
//STRIP001 		BOOL bVertical = ( pOPO && pOPO->IsVertical() );
//STRIP001 		USHORT nTextSlotId = bVertical ? SID_DRAW_TEXT_VERTICAL : SID_DRAW_TEXT;
//STRIP001 
//STRIP001 		// don't switch shells if text shell is already active
//STRIP001 		FuPoor* pPoor = pViewShell->GetViewData()->GetView()->GetDrawFuncPtr();
//STRIP001 		if ( !pPoor || pPoor->GetSlotID() != nTextSlotId )
//STRIP001 		{
//STRIP001 			pViewShell->GetViewData()->GetDispatcher().
//STRIP001 				Execute(nTextSlotId, SFX_CALLMODE_SYNCHRON | SFX_CALLMODE_RECORD);
//STRIP001 		}
//STRIP001 
//STRIP001 		// get the resulting FuText and set in edit mode
//STRIP001 		pPoor = pViewShell->GetViewData()->GetView()->GetDrawFuncPtr();
//STRIP001 		if ( pPoor && pPoor->GetSlotID() == nTextSlotId )	 //	no RTTI
//STRIP001 		{
//STRIP001 			FuText* pText = (FuText*)pPoor;
//STRIP001 			pText->SetInEditMode( pObj, NULL, TRUE, pInitialKey );
//STRIP001 			//! set cursor to end of text
//STRIP001 		}
//STRIP001 		bReturn = TRUE;
//STRIP001 	}
//STRIP001 	return bReturn;
//STRIP001 }

//STRIP001 BOOL __EXPORT FuDraw::KeyInput(const KeyEvent& rKEvt)
//STRIP001 {
//STRIP001 	BOOL bReturn = FALSE;
//STRIP001 
//STRIP001 	switch ( rKEvt.GetKeyCode().GetCode() )
//STRIP001 	{
//STRIP001 		case KEY_ESCAPE:

	/* 18.12.95: TextShell beibehalten nicht mehr gewuenscht...
	 *
	 *			if ( pView->IsAction() )
	 *			{
	 *				pView->BrkAction();
	 *				pWindow->ReleaseMouse();
	 *				bReturn = TRUE;
	 *			}
	 *			else if ( pView->IsTextEdit() )
	 *			{
	 *				pView->EndTextEdit();
	 *				pView->SetCreateMode();
	 *				pViewShell->GetScDrawView()->InvalidateDrawTextAttrs();
	 *				bReturn = TRUE;
	 *			}
	 *			else
	 */

//STRIP001 			if ( pViewShell->IsDrawTextShell() || aSfxRequest.GetSlot() == SID_DRAW_NOTEEDIT )
//STRIP001 			{
//STRIP001 				// in normale Draw-Shell, wenn Objekt selektiert, sonst Zeichnen aus
//STRIP001 				pViewShell->GetViewData()->GetDispatcher().
//STRIP001 					Execute(aSfxRequest.GetSlot(), SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD);
//STRIP001 				bReturn = TRUE;
//STRIP001 			}
//STRIP001 			else if ( pViewShell->IsDrawSelMode() )
//STRIP001 			{
//STRIP001 				pView->UnmarkAll();
//STRIP001 				pViewShell->GetViewData()->GetDispatcher().
//STRIP001 					Execute(SID_OBJECT_SELECT, SFX_CALLMODE_SLOT | SFX_CALLMODE_RECORD);
//STRIP001 				bReturn = TRUE;
//STRIP001 			}
//STRIP001 			else if ( pView->HasMarkedObj() )
//STRIP001 			{
//STRIP001 				// #97016# III
//STRIP001 				const SdrHdlList& rHdlList = pView->GetHdlList();
//STRIP001 				SdrHdl* pHdl = rHdlList.GetFocusHdl();
//STRIP001 
//STRIP001 				if(pHdl)
//STRIP001 				{
//STRIP001 					((SdrHdlList&)rHdlList).ResetFocusHdl();
//STRIP001 				}
//STRIP001 				else
//STRIP001 				{
//STRIP001 					pView->UnmarkAll();
//STRIP001 				}
//STRIP001 				
//STRIP001 				//	Beim Bezier-Editieren ist jetzt wieder das Objekt selektiert
//STRIP001 				if (!pView->HasMarkedObj())
//STRIP001 					pViewShell->SetDrawShell( FALSE );
//STRIP001 
//STRIP001 				bReturn = TRUE;
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case KEY_DELETE:					//! ueber Accelerator
//STRIP001 			pView->DeleteMarked();
//STRIP001 			bReturn = TRUE;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case KEY_RETURN:
//STRIP001 		{
//STRIP001 			if( rKEvt.GetKeyCode().GetModifier() == 0 )
//STRIP001 			{
//STRIP001 	            // #98256# activate OLE object on RETURN for selected object
//STRIP001 				// #98198# put selected text object in edit mode
//STRIP001 				const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 				if( !pView->IsTextEdit() && 1 == rMarkList.GetMarkCount() )
//STRIP001 				{
//STRIP001 					BOOL bOle = pViewShell->GetViewFrame()->ISA(SfxInPlaceFrame);
//STRIP001 	                SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 	    			if( pObj && pObj->ISA( SdrOle2Obj ) && !bOle )
//STRIP001 			        {
//STRIP001 	                    pView->HideMarkHdl(NULL);
//STRIP001 	                    pViewShell->ActivateObject( static_cast< SdrOle2Obj* >( pObj ), 0 );
//STRIP001 
//STRIP001 						// consumed
//STRIP001 						bReturn = TRUE;
//STRIP001 			        }
//STRIP001 					else if ( lcl_KeyEditMode( pObj, pViewShell, NULL ) )		// start text edit for suitable object
//STRIP001 						bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		case KEY_F2:
//STRIP001 		{
//STRIP001 			if( rKEvt.GetKeyCode().GetModifier() == 0 )
//STRIP001 			{
//STRIP001 				// #98198# put selected text object in edit mode
//STRIP001 				// (this is not SID_SETINPUTMODE, but F2 hardcoded, like in Writer)
//STRIP001 				const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 				if( !pView->IsTextEdit() && 1 == rMarkList.GetMarkCount() )
//STRIP001 				{
//STRIP001 	                SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 					if ( lcl_KeyEditMode( pObj, pViewShell, NULL ) )			// start text edit for suitable object
//STRIP001 						bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		// #97016#
//STRIP001 		case KEY_TAB:
//STRIP001 		{
//STRIP001 			// in calc do NOT start draw object selection using TAB/SHIFT-TAB when
//STRIP001 			// there is not yet a object selected
//STRIP001 			if(pView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				KeyCode aCode = rKEvt.GetKeyCode();
//STRIP001 
//STRIP001 				if ( !aCode.IsMod1() && !aCode.IsMod2() )
//STRIP001 				{
//STRIP001 					// changeover to the next object
//STRIP001 					if(!pView->MarkNextObj( !aCode.IsShift() ))
//STRIP001 					{
//STRIP001 						// #97016# No next object: go over open end and
//STRIP001 						// get first from the other side
//STRIP001 						pView->UnmarkAllObj();
//STRIP001 						pView->MarkNextObj(!aCode.IsShift());
//STRIP001 					}
//STRIP001 
//STRIP001 					// #97016# II
//STRIP001 					if(pView->HasMarkedObj())
//STRIP001 						pView->MakeVisible(pView->GetAllMarkedRect(), *pWindow);
//STRIP001 
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 
//STRIP001 				// #98994# handle Mod1 and Mod2 to get travelling running on different systems
//STRIP001 				if(rKEvt.GetKeyCode().IsMod1() || rKEvt.GetKeyCode().IsMod2())
//STRIP001 				{
//STRIP001 					// #97016# II do something with a selected handle?
//STRIP001 					const SdrHdlList& rHdlList = pView->GetHdlList();
//STRIP001 					sal_Bool bForward(!rKEvt.GetKeyCode().IsShift());
//STRIP001 
//STRIP001 					((SdrHdlList&)rHdlList).TravelFocusHdl(bForward);
//STRIP001 
//STRIP001 					// guarantee visibility of focused handle
//STRIP001 					SdrHdl* pHdl = rHdlList.GetFocusHdl();
//STRIP001 
//STRIP001 					if(pHdl)
//STRIP001 					{
//STRIP001 						Point aHdlPosition(pHdl->GetPos());
//STRIP001 						Rectangle aVisRect(aHdlPosition - Point(100, 100), Size(200, 200));
//STRIP001 						pView->MakeVisible(aVisRect, *pWindow);
//STRIP001 					}
//STRIP001 
//STRIP001 					// consumed
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		// #97016#
//STRIP001 		case KEY_END:
//STRIP001 		{
//STRIP001 			// in calc do NOT select the last draw object when
//STRIP001 			// there is not yet a object selected
//STRIP001 			if(pView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				KeyCode aCode = rKEvt.GetKeyCode();
//STRIP001 
//STRIP001 				if ( aCode.IsMod1() )
//STRIP001 				{
//STRIP001 					// #97016# mark last object
//STRIP001 					pView->UnmarkAllObj();
//STRIP001 					pView->MarkNextObj(FALSE);
//STRIP001 
//STRIP001 					// #97016# II
//STRIP001 					if(pView->HasMarkedObj())
//STRIP001 						pView->MakeVisible(pView->GetAllMarkedRect(), *pWindow);
//STRIP001 
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		// #97016#
//STRIP001 		case KEY_HOME:
//STRIP001 		{
//STRIP001 			// in calc do NOT select the first draw object when
//STRIP001 			// there is not yet a object selected
//STRIP001 			if(pView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				KeyCode aCode = rKEvt.GetKeyCode();
//STRIP001 
//STRIP001 				if ( aCode.IsMod1() )
//STRIP001 				{
//STRIP001 					// #97016# mark first object
//STRIP001 					pView->UnmarkAllObj();
//STRIP001 					pView->MarkNextObj(TRUE);
//STRIP001 
//STRIP001 					// #97016# II
//STRIP001 					if(pView->HasMarkedObj())
//STRIP001 						pView->MakeVisible(pView->GetAllMarkedRect(), *pWindow);
//STRIP001 
//STRIP001 					bReturn = TRUE;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		// #97016#
//STRIP001 		case KEY_UP:
//STRIP001 		case KEY_DOWN:
//STRIP001 		case KEY_LEFT:
//STRIP001 		case KEY_RIGHT:
//STRIP001 		{
//STRIP001 			// in calc do cursor travelling of draw objects only when
//STRIP001 			// there is a object selected yet
//STRIP001 			if(pView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				long nX = 0;
//STRIP001 				long nY = 0;
//STRIP001 				USHORT nCode = rKEvt.GetKeyCode().GetCode();
//STRIP001 
//STRIP001 				if (nCode == KEY_UP)
//STRIP001 				{
//STRIP001 					// Scroll nach oben
//STRIP001 					nX = 0;
//STRIP001 					nY =-1;
//STRIP001 				}
//STRIP001 				else if (nCode == KEY_DOWN)
//STRIP001 				{
//STRIP001 					// Scroll nach unten
//STRIP001 					nX = 0;
//STRIP001 					nY = 1;
//STRIP001 				}
//STRIP001 				else if (nCode == KEY_LEFT)
//STRIP001 				{
//STRIP001 					// Scroll nach links
//STRIP001 					nX =-1;
//STRIP001 					nY = 0;
//STRIP001 				}
//STRIP001 				else if (nCode == KEY_RIGHT)
//STRIP001 				{
//STRIP001 					// Scroll nach rechts
//STRIP001 					nX = 1;
//STRIP001 					nY = 0;
//STRIP001 				}
//STRIP001 
//STRIP001 				ScViewData* pViewData = pViewShell->GetViewData();
//STRIP001 				BOOL bReadOnly = pViewData ? pViewData->GetDocShell()->IsReadOnly() : FALSE;
//STRIP001 
//STRIP001 				if(!rKEvt.GetKeyCode().IsMod1() && !bReadOnly)
//STRIP001 				{
//STRIP001 					if(rKEvt.GetKeyCode().IsMod2())
//STRIP001 					{
//STRIP001 						// #97016# move in 1 pixel distance
//STRIP001 						Size aLogicSizeOnePixel = (pWindow) ? pWindow->PixelToLogic(Size(1,1)) : Size(100, 100);
//STRIP001 						nX *= aLogicSizeOnePixel.Width();
//STRIP001 						nY *= aLogicSizeOnePixel.Height();
//STRIP001 					}
//STRIP001 					else
//STRIP001 					{
//STRIP001 						// old, fixed move distance
//STRIP001 						nX *= 100;
//STRIP001 						nY *= 100;
//STRIP001 					}
//STRIP001 
//STRIP001 					// is there a movement to do?
//STRIP001 					if(0 != nX || 0 != nY)
//STRIP001 					{
//STRIP001 						// #97016# II
//STRIP001 						const SdrHdlList& rHdlList = pView->GetHdlList();
//STRIP001 						SdrHdl* pHdl = rHdlList.GetFocusHdl();
//STRIP001 
//STRIP001 						if(0L == pHdl)
//STRIP001 						{
//STRIP001 							// #107086# only take action when move is allowed
//STRIP001 							if(pView->IsMoveAllowed())
//STRIP001 							{
//STRIP001 								// #90129# restrict movement to WorkArea
//STRIP001 								const Rectangle& rWorkArea = pView->GetWorkArea();
//STRIP001 
//STRIP001 								if(!rWorkArea.IsEmpty())
//STRIP001 								{
//STRIP001 									Rectangle aMarkRect(pView->GetMarkedObjRect());
//STRIP001 									aMarkRect.Move(nX, nY);
//STRIP001 
//STRIP001 									if(!aMarkRect.IsInside(rWorkArea))
//STRIP001 									{
//STRIP001 										if(aMarkRect.Left() < rWorkArea.Left())
//STRIP001 										{
//STRIP001 											nX += rWorkArea.Left() - aMarkRect.Left();
//STRIP001 										}
//STRIP001 
//STRIP001 										if(aMarkRect.Right() > rWorkArea.Right())
//STRIP001 										{
//STRIP001 											nX -= aMarkRect.Right() - rWorkArea.Right();
//STRIP001 										}
//STRIP001 
//STRIP001 										if(aMarkRect.Top() < rWorkArea.Top())
//STRIP001 										{
//STRIP001 											nY += rWorkArea.Top() - aMarkRect.Top();
//STRIP001 										}
//STRIP001 
//STRIP001 										if(aMarkRect.Bottom() > rWorkArea.Bottom())
//STRIP001 										{
//STRIP001 											nY -= aMarkRect.Bottom() - rWorkArea.Bottom();
//STRIP001 										}
//STRIP001 									}
//STRIP001 								}
//STRIP001 
//STRIP001 								// now move the selected draw objects
//STRIP001 								pView->MoveAllMarked(Size(nX, nY));
//STRIP001 
//STRIP001 								// #97016# II
//STRIP001 								pView->MakeVisible(pView->GetAllMarkedRect(), *pWindow);
//STRIP001 
//STRIP001 								bReturn = TRUE;
//STRIP001 							}
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							// move handle with index nHandleIndex
//STRIP001 							if(pHdl && (nX || nY))
//STRIP001 							{
//STRIP001 								// now move the Handle (nX, nY)
//STRIP001 								Point aStartPoint(pHdl->GetPos());
//STRIP001 								Point aEndPoint(pHdl->GetPos() + Point(nX, nY));
//STRIP001 								const SdrDragStat& rDragStat = pView->GetDragStat();
//STRIP001 
//STRIP001 								// start dragging
//STRIP001 								pView->BegDragObj(aStartPoint, 0, pHdl, 0);
//STRIP001 
//STRIP001 								if(pView->IsDragObj())
//STRIP001 								{
//STRIP001 									FASTBOOL bWasNoSnap = rDragStat.IsNoSnap();
//STRIP001 									BOOL bWasSnapEnabled = pView->IsSnapEnabled();
//STRIP001 
//STRIP001 									// switch snapping off
//STRIP001 									if(!bWasNoSnap)
//STRIP001 										((SdrDragStat&)rDragStat).SetNoSnap(TRUE);
//STRIP001 									if(bWasSnapEnabled)
//STRIP001 										pView->SetSnapEnabled(FALSE);
//STRIP001 
//STRIP001 									pView->MovAction(aEndPoint);
//STRIP001 									pView->EndDragObj();
//STRIP001 								
//STRIP001 									// restore snap
//STRIP001 									if(!bWasNoSnap)
//STRIP001 										((SdrDragStat&)rDragStat).SetNoSnap(bWasNoSnap);
//STRIP001 									if(bWasSnapEnabled)
//STRIP001 										pView->SetSnapEnabled(bWasSnapEnabled);
//STRIP001 								}
//STRIP001 
//STRIP001 								// make moved handle visible
//STRIP001 								Rectangle aVisRect(aEndPoint - Point(100, 100), Size(200, 200));
//STRIP001 								pView->MakeVisible(aVisRect, *pWindow);
//STRIP001 
//STRIP001 								bReturn = TRUE;
//STRIP001 							}
//STRIP001 						}
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 
//STRIP001 		// #97016#
//STRIP001 		case KEY_SPACE:
//STRIP001 		{
//STRIP001 			// in calc do only something when draw objects are selected
//STRIP001 			if(pView->HasMarkedObj())
//STRIP001 			{
//STRIP001 				const SdrHdlList& rHdlList = pView->GetHdlList();
//STRIP001 				SdrHdl* pHdl = rHdlList.GetFocusHdl();
//STRIP001 
//STRIP001 				if(pHdl)
//STRIP001 				{
//STRIP001 					if(pHdl->GetKind() == HDL_POLY)
//STRIP001 					{
//STRIP001 						// rescue ID of point with focus
//STRIP001 						sal_uInt16 nPol(pHdl->GetPolyNum());
//STRIP001 						sal_uInt16 nPnt(pHdl->GetPointNum());
//STRIP001 						
//STRIP001 						if(pView->IsPointMarked(*pHdl))
//STRIP001 						{
//STRIP001 							if(rKEvt.GetKeyCode().IsShift())
//STRIP001 							{
//STRIP001 								pView->UnmarkPoint(*pHdl);
//STRIP001 							}
//STRIP001 						}
//STRIP001 						else
//STRIP001 						{
//STRIP001 							if(!rKEvt.GetKeyCode().IsShift())
//STRIP001 							{
//STRIP001 								pView->UnmarkAllPoints();
//STRIP001 							}
//STRIP001 
//STRIP001 							pView->MarkPoint(*pHdl);
//STRIP001 						}
//STRIP001 			
//STRIP001 						if(0L == rHdlList.GetFocusHdl())
//STRIP001 						{
//STRIP001 							// restore point with focus
//STRIP001 							SdrHdl* pNewOne = 0L;
//STRIP001 
//STRIP001 							for(sal_uInt32 a(0); !pNewOne && a < rHdlList.GetHdlCount(); a++)
//STRIP001 							{
//STRIP001 								SdrHdl* pAct = rHdlList.GetHdl(a);
//STRIP001 								
//STRIP001 								if(pAct 
//STRIP001 									&& pAct->GetKind() == HDL_POLY 
//STRIP001 									&& pAct->GetPolyNum() == nPol
//STRIP001 									&& pAct->GetPointNum() == nPnt)
//STRIP001 								{
//STRIP001 									pNewOne = pAct;
//STRIP001 								}
//STRIP001 							}
//STRIP001 
//STRIP001 							if(pNewOne)
//STRIP001 							{
//STRIP001 								((SdrHdlList&)rHdlList).SetFocusHdl(pNewOne);
//STRIP001 							}
//STRIP001 						}
//STRIP001 
//STRIP001 						bReturn = TRUE;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bReturn)
//STRIP001 	{
//STRIP001 		bReturn = FuPoor::KeyInput(rKEvt);
//STRIP001 	}
//STRIP001 
//STRIP001 	if (!bReturn)
//STRIP001 	{
//STRIP001 		// #98198# allow direct typing into a selected text object
//STRIP001 
//STRIP001 		const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 		if( !pView->IsTextEdit() && 1 == rMarkList.GetMarkCount() && EditEngine::IsSimpleCharInput(rKEvt) )
//STRIP001 		{
//STRIP001             SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 
//STRIP001 			// start text edit for suitable object, pass key event to OutlinerView
//STRIP001 			if ( lcl_KeyEditMode( pObj, pViewShell, &rKEvt ) )
//STRIP001 				bReturn = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	return (bReturn);
//STRIP001 }

// #97016# II
//STRIP001 void FuDraw::SelectionHasChanged()
//STRIP001 {
//STRIP001 	const SdrHdlList& rHdlList = pView->GetHdlList();
//STRIP001 	((SdrHdlList&)rHdlList).ResetFocusHdl();
//STRIP001 }

/*************************************************************************
|*
|* Vor dem Scrollen Selektionsdarstellung ausblenden
|*
\************************************************************************/

//STRIP001 void FuDraw::ScrollStart()
//STRIP001 {
//STRIP001 //		HideShownXor in Gridwin
//STRIP001 }

/*************************************************************************
|*
|* Nach dem Scrollen Selektionsdarstellung wieder anzeigen
|*
\************************************************************************/

//STRIP001 void FuDraw::ScrollEnd()
//STRIP001 {
//STRIP001 //		ShowShownXor in Gridwin
//STRIP001 }

/*************************************************************************
|*
|* Function aktivieren
|*
\************************************************************************/

//STRIP001 void FuDraw::Activate()
//STRIP001 {
//STRIP001 	FuPoor::Activate();
//STRIP001 }

/*************************************************************************
|*
|* Function deaktivieren
|*
\************************************************************************/

//STRIP001 void FuDraw::Deactivate()
//STRIP001 {
//STRIP001 	FuPoor::Deactivate();
//STRIP001 }

/*************************************************************************
|*
|* Maus-Pointer umschalten
|*
\************************************************************************/

//STRIP001 BOOL lcl_UrlHit( SdrView* pView, const Point& rPosPixel, Window* pWindow )
//STRIP001 {
//STRIP001 	SdrViewEvent aVEvt;
//STRIP001 	MouseEvent aMEvt( rPosPixel, 1, 0, MOUSE_LEFT );
//STRIP001 	SdrHitKind eHit = pView->PickAnything( aMEvt, SDRMOUSEBUTTONDOWN, aVEvt );
//STRIP001 
//STRIP001 	if ( eHit != SDRHIT_NONE && aVEvt.pObj != NULL )
//STRIP001 	{
//STRIP001 		if ( ScDrawLayer::GetIMapInfo( aVEvt.pObj ) && ScDrawLayer::GetHitIMapObject(
//STRIP001 								aVEvt.pObj, pWindow->PixelToLogic(rPosPixel), *pWindow ) )
//STRIP001 			return TRUE;
//STRIP001 
//STRIP001 		if ( aVEvt.eEvent == SDREVENT_EXECUTEURL )
//STRIP001 			return TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	return FALSE;
//STRIP001 }

//STRIP001 void FuDraw::ForcePointer(const MouseEvent* pMEvt)
//STRIP001 {
//STRIP001 	if ( !pView->IsAction() )
//STRIP001 	{
//STRIP001 		Point aPosPixel = pWindow->GetPointerPosPixel();
//STRIP001 		BOOL bAlt		= pMEvt && pMEvt->IsMod2();
//STRIP001 		Point aPnt		= pWindow->PixelToLogic( aPosPixel );
//STRIP001 		SdrHdl* pHdl	= pView->HitHandle(aPnt, *pWindow);
//STRIP001 		SdrObject* pObj;
//STRIP001 		SdrPageView* pPV;
//STRIP001 
//STRIP001 		if ( pView->IsTextEdit() )
//STRIP001 		{
//STRIP001 			pViewShell->SetActivePointer(Pointer(POINTER_TEXT));		// kann nicht sein ?
//STRIP001 		}
//STRIP001 		else if ( pHdl )
//STRIP001 		{
//STRIP001 			pViewShell->SetActivePointer(
//STRIP001 				pView->GetPreferedPointer( aPnt, pWindow ) );
//STRIP001 		}
//STRIP001 		else if ( pView->IsMarkedHit(aPnt) )
//STRIP001 		{
//STRIP001 			pViewShell->SetActivePointer( Pointer(POINTER_MOVE) );
//STRIP001 		}
//STRIP001 		else if ( !bAlt && ( !pMEvt || !pMEvt->GetButtons() )
//STRIP001 						&& lcl_UrlHit( pView, aPosPixel, pWindow ) )
//STRIP001 		{
//STRIP001 			//	kann mit ALT unterdrueckt werden
//STRIP001 			pWindow->SetPointer( Pointer( POINTER_REFHAND ) );			// Text-URL / ImageMap
//STRIP001 		}
//STRIP001 		else if ( !bAlt && pView->PickObj(aPnt, pObj, pPV, SDRSEARCH_PICKMACRO) )
//STRIP001 		{
//STRIP001 			//	kann mit ALT unterdrueckt werden
//STRIP001 			SdrObjMacroHitRec aHitRec;	//! muss da noch irgendwas gesetzt werden ????
//STRIP001 			pViewShell->SetActivePointer( pObj->GetMacroPointer(aHitRec) );
//STRIP001 		}
//STRIP001 		else if ( IsDetectiveHit( aPnt ) )
//STRIP001 			pViewShell->SetActivePointer( Pointer( POINTER_DETECTIVE ) );
//STRIP001 		else
//STRIP001 			pViewShell->SetActivePointer( aNewPointer );			//! in Gridwin?
//STRIP001 	}
//STRIP001 }





}
