/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sc_drawvie3.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 21:24:48 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

// INCLUDE ---------------------------------------------------------------

// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #include <bf_svx/svdoole2.hxx>
// auto strip #include <bf_sfx2/app.hxx>
// auto strip #include <bf_sfx2/viewfrm.hxx>

#include "drawview.hxx"
#include "drwlayer.hxx"
// auto strip #include "viewdata.hxx"
// auto strip #include "dbfunc.hxx"
// auto strip #include "document.hxx"
// auto strip #include "userdat.hxx"
#include "tabvwsh.hxx"
#include "docsh.hxx"
namespace binfilter {

//STRIP001 void ScIMapDlgSet( const Graphic& rGraphic, const ImageMap* pImageMap,
//STRIP001 					const TargetList* pTargetList, void* pEditingObj );		// imapwrap
//STRIP001 USHORT ScIMapChildWindowId();

// STATIC DATA -----------------------------------------------------------

/*N*/ ScDrawView::ScDrawView( OutputDevice* pOut, ScViewData* pData ) :
/*N*/ 	FmFormView( pData->GetDocument()->GetDrawLayer(), pOut ),
/*N*/ 	pViewData( pData ),
/*N*/ 	pDev( pOut ),
/*N*/ 	pDoc( pData->GetDocument() ),
/*N*/ 	nTab( pData->GetTabNo() ),
/*N*/ 	pDropMarker( NULL ),
/*N*/ 	pDropMarkObj( NULL ),
/*N*/ 	bDisableHdl( FALSE ),
/*N*/ 	bInConstruct( TRUE )
/*N*/ {
/*N*/ 	Construct();
/*N*/ }

//STRIP001 ScDrawView::ScDrawView( OutputDevice* pOut, ScDocument* pDocument, USHORT nTable ) :
//STRIP001 	FmFormView( pDocument->GetDrawLayer(), pOut ),
//STRIP001 	pViewData( NULL ),
//STRIP001 	pDev( pOut ),
//STRIP001 	pDoc( pDocument ),
//STRIP001 	nTab( nTable ),
//STRIP001 	pDropMarker( NULL ),
//STRIP001 	pDropMarkObj( NULL ),
//STRIP001 	bDisableHdl( FALSE ),
//STRIP001 	bInConstruct( TRUE )
//STRIP001 {
//STRIP001 	Construct();
//STRIP001 }

// Verankerung setzen

//STRIP001 void ScDrawView::SetAnchor( ScAnchorType eType )
//STRIP001 {
//STRIP001 	SdrObject* pObj = NULL;
//STRIP001 	if( HasMarkedObj() )
//STRIP001 	{
//STRIP001 		const SdrMarkList* pMark = &GetMarkList();
//STRIP001 		ULONG nCount = pMark->GetMarkCount();
//STRIP001 		for( ULONG i=0; i<nCount; i++ )
//STRIP001 		{
//STRIP001 			pObj = pMark->GetMark(i)->GetObj();
//STRIP001 			ScDrawLayer::SetAnchor( pObj, eType );
//STRIP001 		}
//STRIP001 
//STRIP001 		if ( pViewData )
//STRIP001 			pViewData->GetDocShell()->SetDrawModified();
//STRIP001 	}
//STRIP001 }

//STRIP001 ScAnchorType ScDrawView::GetAnchor() const
//STRIP001 {
//STRIP001 	BOOL bPage = FALSE;
//STRIP001 	BOOL bCell = FALSE;
//STRIP001 	const SdrObject* pObj = NULL;
//STRIP001 	if( HasMarkedObj() )
//STRIP001 	{
//STRIP001 		const SdrMarkList* pMark = &GetMarkList();
//STRIP001 		ULONG nCount = pMark->GetMarkCount();
//STRIP001 		Point p0;
//STRIP001 		for( ULONG i=0; i<nCount; i++ )
//STRIP001 		{
//STRIP001 			pObj = pMark->GetMark(i)->GetObj();
//STRIP001 			if( ScDrawLayer::GetAnchor( pObj ) == SCA_CELL )
//STRIP001 				bCell =TRUE;
//STRIP001 			else
//STRIP001 				bPage = TRUE;
//STRIP001 		}
//STRIP001 	}
//STRIP001 	if( bPage && !bCell )
//STRIP001 		return SCA_PAGE;
//STRIP001 	if( !bPage && bCell )
//STRIP001 		return SCA_CELL;
//STRIP001 	return SCA_DONTKNOW;
//STRIP001 }

/*N*/ void __EXPORT ScDrawView::SFX_NOTIFY( SfxBroadcaster& rBC, const TypeId& rBCType,
/*N*/ 									 const SfxHint& rHint, const TypeId& rHintType )
/*N*/ {
/*N*/ 	if (rHint.ISA(ScTabDeletedHint))						// Tabelle geloescht
/*N*/ 	{
/*?*/ 		USHORT nDelTab = ((ScTabDeletedHint&)rHint).GetTab();
/*?*/ 		if (nDelTab <= MAXTAB)
/*?*/ 			{DBG_BF_ASSERT(0, "STRIP");} //STRIP001 HidePagePgNum(nDelTab);
/*N*/ 	}
/*N*/ 	else if (rHint.ISA(ScTabSizeChangedHint))				// Groesse geaendert
/*N*/ 	{
/*N*/ 		if ( nTab == ((ScTabSizeChangedHint&)rHint).GetTab() )
/*N*/ 			UpdateWorkArea();
/*N*/ 	}
/*N*/ 	else
/*N*/ 		FmFormView::SFX_NOTIFY( rBC,rBCType,rHint,rHintType );
/*N*/ }

//STRIP001 void ScDrawView::UpdateIMap( SdrObject* pObj )
//STRIP001 {
//STRIP001 	if ( pViewData &&
//STRIP001 		 pViewData->GetViewShell()->GetViewFrame()->HasChildWindow( ScIMapChildWindowId() ) &&
//STRIP001 		 pObj && ( pObj->ISA(SdrGrafObj) || pObj->ISA(SdrOle2Obj) ) )
//STRIP001 	{
//STRIP001 		Graphic		aGraphic;
//STRIP001 		TargetList	aTargetList;
//STRIP001 		ScIMapInfo* pIMapInfo = ScDrawLayer::GetIMapInfo( pObj );
//STRIP001 		const ImageMap* pImageMap = NULL;
//STRIP001 		if ( pIMapInfo )
//STRIP001 			pImageMap = &pIMapInfo->GetImageMap();
//STRIP001 
//STRIP001 		// Target-Liste besorgen
//STRIP001 		pViewData->GetViewShell()->GetViewFrame()->GetTargetList( aTargetList );
//STRIP001 
//STRIP001 		// Grafik vom Objekt besorgen
//STRIP001 		if ( pObj->ISA( SdrGrafObj ) )
//STRIP001 			aGraphic = ( (SdrGrafObj*) pObj )->GetGraphic();
//STRIP001 		else
//STRIP001 			aGraphic = ScDrawLayer::GetGraphicFromOle2Obj(
//STRIP001 						(const SdrOle2Obj*) pObj );
//STRIP001 
//STRIP001 		ScIMapDlgSet( aGraphic, pImageMap, &aTargetList, pObj );	// aus imapwrap
//STRIP001 
//STRIP001 		// TargetListe kann von uns wieder geloescht werden
//STRIP001 		String* pEntry = aTargetList.First();
//STRIP001 		while( pEntry )
//STRIP001 		{
//STRIP001 			delete pEntry;
//STRIP001 			pEntry = aTargetList.Next();
//STRIP001 		}
//STRIP001 	}
//STRIP001 }




}
