/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sc_pivotsh.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 21:31:44 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifdef PCH
// auto strip #include "ui_pch.hxx"
#endif

#pragma hdrstop

//------------------------------------------------------------------

// auto strip #include "scitems.hxx"
// auto strip #include <bf_svx/srchitem.hxx>
#include <bf_sfx2/app.hxx>
// auto strip #include <bf_sfx2/objface.hxx>
// auto strip #include <bf_sfx2/objsh.hxx>
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #include <svtools/whiter.hxx>
// auto strip #include <vcl/msgbox.hxx>

#include "bf_sc.hrc"
#include "pivotsh.hxx"
// auto strip #include "tabvwsh.hxx"
#include "docsh.hxx"
#include "scresid.hxx"
// auto strip #include "document.hxx"
// auto strip #include "dpobject.hxx"
// auto strip #include "dpshttab.hxx"
// auto strip #include "dbdocfun.hxx"
// auto strip #include "uiitems.hxx"
// auto strip #include "pfiltdlg.hxx"

//------------------------------------------------------------------------
namespace binfilter {

#define ScPivotShell
#include "scslots.hxx"

//------------------------------------------------------------------------

//STRIP001 TYPEINIT1( ScPivotShell, SfxShell );

/*N*/ SFX_IMPL_INTERFACE(ScPivotShell, SfxShell, ScResId(SCSTR_PIVOTSHELL))
/*N*/ {
/*N*/ 	SFX_POPUPMENU_REGISTRATION( ScResId(RID_POPUP_PIVOT) );
/*N*/ }


//------------------------------------------------------------------------

//STRIP001 ScPivotShell::ScPivotShell( ScTabViewShell* pViewSh ) :
//STRIP001 	SfxShell(pViewSh),
//STRIP001 	pViewShell( pViewSh )
//STRIP001 {
//STRIP001 	SetPool( &pViewSh->GetPool() );
//STRIP001 	SetUndoManager( pViewSh->GetViewData()->GetSfxDocShell()->GetUndoManager() );
//STRIP001 	SetHelpId( HID_SCSHELL_PIVOTSH );
//STRIP001 	SetName(String::CreateFromAscii(RTL_CONSTASCII_STRINGPARAM("Pivot")));
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 ScPivotShell::~ScPivotShell()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 void ScPivotShell::Execute( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	switch ( rReq.GetSlot() )
//STRIP001 	{
//STRIP001 		case SID_PIVOT_RECALC:
//STRIP001 			pViewShell->RecalcPivotTable();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case SID_PIVOT_KILL:
//STRIP001 			pViewShell->DeletePivotTable();
//STRIP001 			break;
//STRIP001 
//STRIP001         case SID_DP_FILTER:
//STRIP001         {
//STRIP001             ScDPObject* pDPObj = GetCurrDPObject();
//STRIP001             if( pDPObj )
//STRIP001             {
//STRIP001                 ScQueryParam aQueryParam;
//STRIP001                 USHORT nSrcTab = 0;
//STRIP001                 const ScSheetSourceDesc* pDesc = pDPObj->GetSheetDesc();
//STRIP001                 DBG_ASSERT( pDesc, "no sheet source for DP filter dialog" );
//STRIP001                 if( pDesc )
//STRIP001                 {
//STRIP001                     aQueryParam = pDesc->aQueryParam;
//STRIP001                     nSrcTab = pDesc->aSourceRange.aStart.Tab();
//STRIP001                 }
//STRIP001 
//STRIP001                 ScViewData* pViewData = pViewShell->GetViewData();
//STRIP001                 SfxItemSet aArgSet( pViewShell->GetPool(),
//STRIP001                     SCITEM_QUERYDATA, SCITEM_QUERYDATA );
//STRIP001                 aArgSet.Put( ScQueryItem( SCITEM_QUERYDATA, pViewData, &aQueryParam ) );
//STRIP001 
//STRIP001                 ScPivotFilterDlg* pDlg = new ScPivotFilterDlg(
//STRIP001                     pViewShell->GetDialogParent(), aArgSet, nSrcTab );
//STRIP001 
//STRIP001                 if( pDlg->Execute() == RET_OK )
//STRIP001                 {
//STRIP001                     ScSheetSourceDesc aNewDesc;
//STRIP001                     if( pDesc )
//STRIP001                         aNewDesc = *pDesc;
//STRIP001 
//STRIP001                     const ScQueryItem& rQueryItem = pDlg->GetOutputItem();
//STRIP001                     aNewDesc.aQueryParam = rQueryItem.GetQueryData();
//STRIP001 
//STRIP001                     ScDPObject aNewObj( *pDPObj );
//STRIP001                     aNewObj.SetSheetDesc( aNewDesc );
//STRIP001                     ScDBDocFunc aFunc( *pViewData->GetDocShell() );
//STRIP001                     aFunc.DataPilotUpdate( pDPObj, &aNewObj, TRUE, FALSE );
//STRIP001                     pViewData->GetView()->CursorPosChanged();       // shells may be switched
//STRIP001                 }
//STRIP001                 delete pDlg;
//STRIP001             }
//STRIP001         }
//STRIP001         break;
//STRIP001 	}
//STRIP001 }

//------------------------------------------------------------------------
//STRIP001 void __EXPORT ScPivotShell::GetState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	ScDocShell* pDocSh = pViewShell->GetViewData()->GetDocShell();
//STRIP001 	ScDocument* pDoc = pDocSh->GetDocument();
//STRIP001     BOOL bDisable = pDocSh->IsReadOnly() || pDoc->GetChangeTrack();
//STRIP001 
//STRIP001 	SfxWhichIter aIter(rSet);
//STRIP001 	USHORT nWhich = aIter.FirstWhich();
//STRIP001 	while (nWhich)
//STRIP001 	{
//STRIP001 		switch (nWhich)
//STRIP001 		{
//STRIP001 			case SID_PIVOT_RECALC:
//STRIP001 			case SID_PIVOT_KILL:
//STRIP001             {
//STRIP001                 //! move ReadOnly check to idl flags
//STRIP001                 if ( bDisable )
//STRIP001                 {
//STRIP001                     rSet.DisableItem( nWhich );
//STRIP001                 }
//STRIP001             }
//STRIP001             break;
//STRIP001             case SID_DP_FILTER:
//STRIP001             {
//STRIP001                 ScDPObject* pDPObj = GetCurrDPObject();
//STRIP001                 if( bDisable || !pDPObj || !pDPObj->IsSheetData() )
//STRIP001                     rSet.DisableItem( nWhich );
//STRIP001             }
//STRIP001             break;
//STRIP001 		}
//STRIP001 		nWhich = aIter.NextWhich();
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 //------------------------------------------------------------------------
//STRIP001 
//STRIP001 ScDPObject* ScPivotShell::GetCurrDPObject()
//STRIP001 {
//STRIP001     const ScViewData& rViewData = *pViewShell->GetViewData();
//STRIP001     return rViewData.GetDocument()->GetDPAtCursor(
//STRIP001         rViewData.GetCurX(), rViewData.GetCurY(), rViewData.GetTabNo() );
//STRIP001 }
//STRIP001 
}
