/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sch_attrib.cxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 22:14:46 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#pragma hdrstop

#define ITEMID_FONTLIST 	SID_ATTR_CHAR_FONTLIST
#define ITEMID_ESCAPEMENT	SID_ATTR_CHAR_ESCAPEMENT
#define ITEMID_CASEMAP		SID_ATTR_CHAR_CASEMAP
#define ITEMID_NUMBERINFO	SID_ATTR_NUMBERFORMAT_INFO

#include "bf_svx/xoutx.hxx"
#ifndef _SFX_OBJSH_HXX //autogen
#include <bf_sfx2/objsh.hxx>
#endif

#ifndef _ZFORLIST_DECLARE_TABLE
#define _ZFORLIST_DECLARE_TABLE
#endif
#include <svtools/zforlist.hxx>
#include <bf_svx/numfmt.hxx>
#include <bf_svx/dialogs.hrc>
#include <bf_svx/chardlg.hxx>
#include <bf_svx/tabline.hxx>

#include "schresid.hxx"
#include "attrib.hrc"
#include "schdll.hxx"
#include "chtmodel.hxx"
#include "schattr.hxx"
#include "attrib.hxx"

#include "tplabel.hxx"
#include "tplabel.hrc"
#include "tpscaley.hxx"
#include "tpscaley.hrc"

#include <bf_svx/numinf.hxx>
namespace binfilter {

/************************************************************************/

//STRIP001 const USHORT nNoArrowDlg			= 1100;
//STRIP001 const USHORT nNoArrowNoShadowDlg	= 1101;

/*************************************************************************
|*
|* Liefert die Ressourcen-Id fuer den angegebenen Attributs-Typ
|*
\************************************************************************/

//STRIP001 USHORT SchAttribTabDlg::GetResId(AttrType eType)
//STRIP001 {
//STRIP001 	switch (eType)
//STRIP001 	{
//STRIP001 		case ATTR_TITLE:			return TAB_TITLE;
//STRIP001 		case ATTR_LEGEND:			return TAB_LEGEND;
//STRIP001 		case ATTR_DATA_ROW:			return TAB_DATA_ROW;
//STRIP001 		case ATTR_DATA_LINE:		return TAB_DATA_LINE;
//STRIP001 		case ATTR_DATA_POINT:		return TAB_DATA_POINT;
//STRIP001 		case ATTR_AXIS:				return TAB_AXIS;
//STRIP001 		case ATTR_X_AXIS_2D:
//STRIP001 		case ATTR_X_AXIS_3D:		return TAB_X_AXIS;
//STRIP001 		case ATTR_Y_AXIS_2D:
//STRIP001 		case ATTR_Y_AXIS_3D:		return TAB_Y_AXIS;
//STRIP001 		case ATTR_Z_AXIS:			return TAB_Z_AXIS;
//STRIP001 		case ATTR_GRID:				return TAB_GRID;
//STRIP001 		case ATTR_LINE:             return TAB_LINE;
//STRIP001 		case ATTR_DIAGRAM_AREA:		return TAB_DIAGRAM_AREA;
//STRIP001 		case ATTR_DIAGRAM_WALL:		return TAB_DIAGRAM_WALL;
//STRIP001 		case ATTR_DIAGRAM_FLOOR:	return TAB_DIAGRAM_FLOOR;
//STRIP001 		case ATTR_DIAGRAM_STOCK_LOSS: return TAB_DIAGRAM_STOCK_LOSS;
//STRIP001 		case ATTR_DIAGRAM_STOCK_PLUS: return TAB_DIAGRAM_STOCK_PLUS;
//STRIP001 
//STRIP001 		default:					return 0;
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* Konstruktor des Tab-Dialogs: Fuegt die Seiten zum Dialog hinzu
|*
\************************************************************************/

//STRIP001 SchAttribTabDlg::SchAttribTabDlg(Window* pParent, AttrType eType,
//STRIP001 								 const SfxItemSet* pAttr,
//STRIP001 								 const SfxObjectShell* pDocShell,
//STRIP001 								 const ChartModel* pModel,
//STRIP001 								 int   nID,
//STRIP001 								 int   nType,
//STRIP001 								 const SfxItemSet* pSymbolAttr,
//STRIP001 								 Graphic aGraphic) :
//STRIP001 	SfxTabDialog(pParent, SchResId(GetResId(eType)), pAttr),
//STRIP001 	pColorTab(pModel->GetColorTable()),
//STRIP001 	maSymbolGraphic(aGraphic),
//STRIP001 	pDashList(pModel->GetDashList()),
//STRIP001 	pLineEndList(pModel->GetLineEndList()),
//STRIP001 	pGradientList(pModel->GetGradientList()),
//STRIP001 	pHatchingList(pModel->GetHatchList()),
//STRIP001 	pBitmapList(pModel->GetBitmapList()),
//STRIP001 	nPageType(0),
//STRIP001 	nDlgType(2),
//STRIP001 	nPos(0),
//STRIP001 	mpSymbolAttr(pSymbolAttr),
//STRIP001 	nColorTableState(CT_NONE),
//STRIP001 	nBitmapListState(CT_NONE),
//STRIP001 	nGradientListState(CT_NONE),
//STRIP001 	nHatchingListState(CT_NONE),
//STRIP001 	eAttrType(eType),
//STRIP001 	rDocShell(*pDocShell)
//STRIP001 {
//STRIP001 	pMyModel = (ChartModel*) pModel;
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 	switch (eAttrType)
//STRIP001 	{
//STRIP001 		case ATTR_TITLE:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_ALIGNMENT, SchAlignmentTabPage::Create, NULL);
//STRIP001 			/*if (//(nID == CHOBJID_DIAGRAM_TITLE_X_AXIS) || (nID == CHOBJID_DIAGRAM_TITLE_Z_AXIS) ||
//STRIP001 				(nID == CHOBJID_TITLE_MAIN) || (nID == CHOBJID_TITLE_SUB))
//STRIP001 				RemoveTabPage (TP_ALIGNMENT);*/
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_LEGEND:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_LEGEND_POS, SchLegendPosTabPage::Create, NULL);
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_DATA_ROW:
//STRIP001 		case ATTR_DATA_POINT:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_DATA_DESCR, SchDataDescrTabPage::Create, NULL);
//STRIP001 			AddTabPage(TP_STAT, SchStatisticTabPage::Create, NULL);
//STRIP001 			//	Layout tab only for 3D bar and column charts.
//STRIP001 			if (pMyModel->Is3DChart() && (pMyModel->IsBar() || pMyModel->IsCol(0)))
//STRIP001 				AddTabPage(TP_LAYOUT,SchLayoutTabPage::Create, NULL);
//STRIP001 			else
//STRIP001 				RemoveTabPage(TP_LAYOUT);
//STRIP001 			AddTabPage(TP_OPTIONS,SchOptionTabPage::Create, NULL);
//STRIP001 			if ((((const SfxInt32Item &)pAttr->Get (SCHATTR_DUMMY1)).GetValue () == CHOBJID_DIAGRAM_DATA) ||
//STRIP001 				!pMyModel->IsStatisticChart())
//STRIP001 				RemoveTabPage (TP_STAT);
//STRIP001 			if(eAttrType==ATTR_DATA_POINT)
//STRIP001 			{
//STRIP001 				RemoveTabPage(TP_OPTIONS);
//STRIP001 			}
//STRIP001 
//STRIP001 			if(!pMyModel->CanAxis(CHART_AXIS_SECONDARY_Y))
//STRIP001 				RemoveTabPage(TP_OPTIONS);
//STRIP001 
//STRIP001 			if(pMyModel->ChartStyle() == CHSTYLE_3D_PIE)
//STRIP001 			{
//STRIP001 //				RemoveTabPage (RID_SVXPAGE_LINE);
//STRIP001 				RemoveTabPage(TP_LAYOUT);
//STRIP001 			}
//STRIP001 
//STRIP001 			nDlgType = nNoArrowNoShadowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_DATA_LINE:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_DATA_DESCR, SchDataDescrTabPage::Create, NULL);
//STRIP001 			//if (pMyModel->IsStatisticChart())
//STRIP001 			AddTabPage(TP_STAT, SchStatisticTabPage::Create, NULL);
//STRIP001 			AddTabPage(TP_OPTIONS,SchOptionTabPage::Create, NULL);
//STRIP001 			if (!pMyModel->IsStatisticChart())
//STRIP001 				RemoveTabPage (TP_STAT);
//STRIP001 			if(!pMyModel->CanAxis(CHART_AXIS_SECONDARY_Y))
//STRIP001 				RemoveTabPage(TP_OPTIONS);
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 
//STRIP001 		case ATTR_AXIS:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_X_AXIS_2D:
//STRIP001 		case ATTR_X_AXIS_3D:
//STRIP001 		{
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
//STRIP001 			AddTabPage(TP_SCALE_Y, SchScaleYAxisTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_NUMBERFORMAT, SvxNumberFormatTabPage::Create, NULL);
//STRIP001 
//STRIP001 			if (! pModel->IsXYChart ())
//STRIP001 			{
//STRIP001 				RemoveTabPage (TP_SCALE_Y);
//STRIP001 				RemoveTabPage (RID_SVXPAGE_NUMBERFORMAT);
//STRIP001 			}
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			((SfxItemSet * const) pAttr)->ClearItem (SCHATTR_AXISTYPE);
//STRIP001 			((SfxItemSet *) pAttr)->Put (SfxInt32Item (SCHATTR_AXISTYPE, CHART_AXIS_X));
//STRIP001 
//STRIP001 			nAxisType = 1;
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case ATTR_Y_AXIS_2D:
//STRIP001 		case ATTR_Y_AXIS_3D:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_SCALE_Y, SchScaleYAxisTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_NUMBERFORMAT, SvxNumberFormatTabPage::Create, NULL);
//STRIP001 			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			((SfxItemSet * const) pAttr)->ClearItem (SCHATTR_AXISTYPE);
//STRIP001 			((SfxItemSet *) pAttr)->Put (SfxInt32Item (SCHATTR_AXISTYPE, CHART_AXIS_Y));
//STRIP001 
//STRIP001 			nAxisType = 2;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_Z_AXIS:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_NAME, SvxCharNamePage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_CHAR_EFFECTS, SvxCharEffectsPage::Create, NULL);
//STRIP001 			AddTabPage(TP_AXIS_LABEL, SchAxisLabelTabPage::Create, NULL);
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			((SfxItemSet * const) pAttr)->ClearItem (SCHATTR_AXISTYPE);
//STRIP001 			((SfxItemSet *) pAttr)->Put (SfxInt32Item (SCHATTR_AXISTYPE, CHART_AXIS_Z));
//STRIP001 
//STRIP001 			nAxisType = 3;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_GRID:
//STRIP001 		case ATTR_LINE:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			nDlgType = nNoArrowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_DIAGRAM_STOCK_LOSS:
//STRIP001 		case ATTR_DIAGRAM_STOCK_PLUS:
//STRIP001 		case ATTR_DIAGRAM_AREA:
//STRIP001 		case ATTR_DIAGRAM_FLOOR:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
//STRIP001 			nDlgType = nNoArrowNoShadowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 		case ATTR_DIAGRAM_WALL:
//STRIP001 			AddTabPage(RID_SVXPAGE_LINE, SvxLineTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_AREA, SvxAreaTabPage::Create, NULL);
//STRIP001 			AddTabPage(RID_SVXPAGE_TRANSPARENCE, SvxTransparenceTabPage::Create, NULL);
//STRIP001 			nDlgType = nNoArrowNoShadowDlg;
//STRIP001 			break;
//STRIP001 
//STRIP001 	}
//STRIP001 }

/*************************************************************************
|*
|* Destruktor
|*
\************************************************************************/

//STRIP001 SchAttribTabDlg::~SchAttribTabDlg()
//STRIP001 {
//STRIP001 }

/*************************************************************************
|*
|*
|*
\************************************************************************/

//STRIP001 void SchAttribTabDlg::PageCreated(USHORT nId, SfxTabPage &rPage)
//STRIP001 {
//STRIP001 	switch (nId)
//STRIP001 	{
//STRIP001 		case TP_LAYOUT:
//STRIP001 		break;
//STRIP001 		case RID_SVXPAGE_LINE:
//STRIP001 			((SvxLineTabPage&)rPage).SetColorTable(pColorTab);
//STRIP001 			((SvxLineTabPage&)rPage).SetDashList(pDashList);
//STRIP001 			((SvxLineTabPage&)rPage).SetLineEndList(pLineEndList);
//STRIP001 			((SvxLineTabPage&)rPage).SetPageType(&nPageType);
//STRIP001 			((SvxLineTabPage&)rPage).SetDlgType(&nDlgType);
//STRIP001 			((SvxLineTabPage&)rPage).Construct();
//STRIP001 			((SvxLineTabPage&)rPage).ActivatePage(*GetInputSetImpl());
//STRIP001 			if(mpSymbolAttr)//unfein, aber wenn man schon die Attribute setzt, wird es wohl ne Linie
//STRIP001 			{               //mit Symbolen sein.
//STRIP001 				((SvxLineTabPage&)rPage).ShowSymbolControls(TRUE);
//STRIP001 				((SvxLineTabPage&)rPage).SetSymbolList(pMyModel->GetSdrObjList());
//STRIP001 				((SvxLineTabPage&)rPage).SetSymbolAttr(mpSymbolAttr);
//STRIP001 				((SvxLineTabPage&)rPage).SetAutoSymbolGraphic(&maSymbolGraphic);
//STRIP001 			}
//STRIP001 			break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_AREA:
//STRIP001 			((SvxAreaTabPage&)rPage).SetColorTable(pColorTab);
//STRIP001 			((SvxAreaTabPage&)rPage).SetGradientList(pGradientList);
//STRIP001 			((SvxAreaTabPage&)rPage).SetHatchingList(pHatchingList);
//STRIP001 			((SvxAreaTabPage&)rPage).SetBitmapList(pBitmapList);
//STRIP001 			((SvxAreaTabPage&)rPage).SetPageType(&nPageType);
//STRIP001 			((SvxAreaTabPage&)rPage).SetDlgType(&nDlgType);
//STRIP001 			((SvxAreaTabPage&)rPage).SetGrdChgd(&nGradientListState);
//STRIP001 			((SvxAreaTabPage&)rPage).SetHtchChgd(&nHatchingListState);
//STRIP001 			((SvxAreaTabPage&)rPage).SetBmpChgd(&nBitmapListState);
//STRIP001 			((SvxAreaTabPage&)rPage).SetColorChgd(&nColorTableState);
//STRIP001 			((SvxAreaTabPage&)rPage).Construct();
//STRIP001 			((SvxAreaTabPage&)rPage).ActivatePage(*GetInputSetImpl());
//STRIP001 			break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_TRANSPARENCE:
//STRIP001 			( (SvxTransparenceTabPage&) rPage ).SetPageType( &nPageType );
//STRIP001 			( (SvxTransparenceTabPage&) rPage ).SetDlgType( &nDlgType );
//STRIP001 			( (SvxTransparenceTabPage&) rPage ).Construct();
//STRIP001 			break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_CHAR_NAME:
//STRIP001 			((SvxCharNamePage&)rPage).
//STRIP001 				SetFontList(*(const SvxFontListItem*)
//STRIP001 							 rDocShell.GetItem(SID_ATTR_CHAR_FONTLIST));
//STRIP001 			break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_CHAR_EFFECTS:
//STRIP001 			((SvxCharEffectsPage&) rPage).DisableControls( DISABLE_CASEMAP );
//STRIP001 			break;
//STRIP001 
//STRIP001 		case TP_AXIS_LABEL:
//STRIP001 		{
//STRIP001 			OrderMode eMode;
//STRIP001 			switch( eAttrType )
//STRIP001 			{
//STRIP001 				case ATTR_X_AXIS_2D:
//STRIP001 					eMode = CHORDMODE_X_AXIS;
//STRIP001 					break;
//STRIP001 
//STRIP001 				case ATTR_Y_AXIS_2D:
//STRIP001 					eMode = CHORDMODE_Y_AXIS;
//STRIP001 					break;
//STRIP001 
//STRIP001 				default:
//STRIP001 					eMode = CHORDMODE_NONE;
//STRIP001 					break;
//STRIP001 			}
//STRIP001 			((SchAxisLabelTabPage&)rPage).SetOrderMode( eMode );
//STRIP001 			((SchAxisLabelTabPage&)rPage).AllowTextOverlap( TRUE );
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case TP_ALIGNMENT:
//STRIP001 		{
//STRIP001 			OrderMode eMode;
//STRIP001 			switch (eAttrType)
//STRIP001 			{
//STRIP001 				case ATTR_X_AXIS_2D:
//STRIP001 					eMode = CHORDMODE_X_AXIS;
//STRIP001 					break;
//STRIP001 
//STRIP001 				case ATTR_Y_AXIS_2D:
//STRIP001 					eMode = CHORDMODE_Y_AXIS;
//STRIP001 					break;
//STRIP001 
//STRIP001 				default:
//STRIP001 					eMode = CHORDMODE_NONE;
//STRIP001 					break;
//STRIP001 			}
//STRIP001 			((SchAlignmentTabPage&)rPage).SetOrderMode(eMode);
//STRIP001 			((SchAlignmentTabPage&)rPage).SetTextCanOverlap(/*pMyModel->IsReal3D()*/TRUE);
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case TP_SCALE_Y:
//STRIP001             {
//STRIP001                 SchScaleYAxisTabPage & rAxisTabPage = static_cast< SchScaleYAxisTabPage & >( rPage );
//STRIP001 
//STRIP001                 // #101318# use own number formatter with higher precision for
//STRIP001                 // rendering the values in the dialog.
//STRIP001                 rAxisTabPage.SetNumFormatter( pMyModel->GetOwnNumberFormatter() );
//STRIP001                 rAxisTabPage.SetModel( pMyModel );
//STRIP001             }
//STRIP001             break;
//STRIP001 
//STRIP001 		case RID_SVXPAGE_NUMBERFORMAT:
//STRIP001 			((SvxNumberFormatTabPage&)rPage).SetNumberFormatList(pMyModel->GetNumFormatter());
//STRIP001 			break;
//STRIP001 	}
//STRIP001 }


}
