/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: dlggraut.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/07 22:48:24 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SCH_DLGGRAUT_HXX
#define _SCH_DLGGRAUT_HXX
//------------------------------------------------------------------
//
// dieses Define dient nur zum Testen und darf auf keinen Fall aktiv bleiben
// Bei Umstellungen alle Files nach SIG_CHARTMODELDEFSCHDOC durchsuchen
// #define ChartModel SchChartDocument
//------------------------------------------------------------------
#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SFXITEMSET_HXX //autogen
#include <svtools/itemset.hxx>
#endif
#ifndef _SV_TIMER_HXX //autogen
#include <vcl/timer.hxx>
#endif
#ifndef _SV_FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _SV_BUTTON_HXX //autogen
#include <vcl/button.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
#ifndef _SV_DIALOG_HXX //autogen
#include <vcl/dialog.hxx>
#endif
#ifndef _SVX_CHRTITEM_HXX //autogen
#include <bf_svx/chrtitem.hxx>
#endif
#ifndef _SFXAPP_HXX
#include <bf_sfx2/app.hxx>
#endif
namespace binfilter {


class SchControlList;
class SchChartView;
class SchChartDocShell;
class ChartModel;
class SfxPreviewWin;
class SchMemChart;

#define SCH_MAX_PAGES	3

enum ChType
{
	CHTYPE_2D_LINE = 1,
	CHTYPE_2D_LINESYMB,
	CHTYPE_2D_AREA,
	CHTYPE_2D_COLUMN,
	CHTYPE_2D_BAR,
	CHTYPE_2D_PIE,
	CHTYPE_2D_XY,
	CHTYPE_3D_STRIPE,
	CHTYPE_3D_AREA,
	CHTYPE_3D_COLUMN,
	CHTYPE_3D_PIE,
	CHTYPE_3D_XYZ,
	CHTYPE_3D_BAR,
	CHTYPE_2D_NET,
	CHTYPE_2D_STOCK
};

enum ChVariant
{
	CHVARIANT_INVALID,
	CHVARIANT_2D_LINE = 1,
	CHVARIANT_2D_LINE_STACKED,
	CHVARIANT_2D_LINE_PERCENT,
	CHVARIANT_2D_LINESYMB,
	CHVARIANT_2D_LINESYMB_STACKED,
	CHVARIANT_2D_LINESYMB_PERCENT,
	CHVARIANT_2D_COLUMN,
	CHVARIANT_2D_COLUMN_STACKED,
	CHVARIANT_2D_COLUMN_PERCENT,
	CHVARIANT_2D_BAR,
	CHVARIANT_2D_BAR_STACKED,
	CHVARIANT_2D_BAR_PERCENT,
	CHVARIANT_2D_AREA,
	CHVARIANT_2D_AREA_STACKED,
	CHVARIANT_2D_AREA_PERCENT,
	CHVARIANT_2D_PIE,
	CHVARIANT_2D_PIE_SEGOFS_1,
	CHVARIANT_2D_PIE_SEGOFS_ALL,
	CHVARIANT_2D_XY_SYMB,
	CHVARIANT_2D_XY,
	CHVARIANT_3D_STRIPE,
	CHVARIANT_3D_COLUMN,
	CHVARIANT_3D_COLUMN_FLAT,
	CHVARIANT_3D_COLUMN_FLAT_STACKED,
	CHVARIANT_3D_COLUMN_FLAT_PERCENT,
	CHVARIANT_3D_AREA,
	CHVARIANT_3D_AREA_STACKED,
	CHVARIANT_3D_AREA_PERCENT,
	CHVARIANT_3D_PIE,
	CHVARIANT_3D_XYZ_SYMB,
	CHVARIANT_3D_XYZ,
	CHVARIANT_2D_DONUT1,
	CHVARIANT_2D_DONUT2,
	CHVARIANT_3D_BAR,
	CHVARIANT_3D_BAR_FLAT,
	CHVARIANT_3D_BAR_FLAT_STACKED,
	CHVARIANT_3D_BAR_FLAT_PERCENT,
	CHVARIANT_3D_SURFACE,
	CHVARIANT_2D_NET,
	CHVARIANT_2D_NETSYMB,
	CHVARIANT_2D_NET_STACK,
	CHVARIANT_2D_NETSYMB_STACK,
	CHVARIANT_2D_NET_PERCENT,
	CHVARIANT_2D_NETSYMB_PERCENT,
	CHVARIANT_2D_CUBIC_SPLINE,
	CHVARIANT_2D_CUBIC_SPLINE_SYMBOL,
	CHVARIANT_2D_B_SPLINE,
	CHVARIANT_2D_B_SPLINE_SYMBOL,
	CHVARIANT_2D_CUBIC_SPLINE_XY,
	CHVARIANT_2D_CUBIC_SPLINE_SYMBOL_XY,
	CHVARIANT_2D_B_SPLINE_XY,
	CHVARIANT_2D_B_SPLINE_SYMBOL_XY,
	CHVARIANT_2D_XY_LINE,
	CHVARIANT_2D_LINE_COLUMN,
	CHVARIANT_2D_LINE_STACKEDCOLUMN,
	CHVARIANT_2D_STOCK_1,
	CHVARIANT_2D_STOCK_2,
	CHVARIANT_2D_STOCK_3,
	CHVARIANT_2D_STOCK_4
};

//STRIP001 class SchDiagramAutoPilotDlg : public ModalDialog
//STRIP001 {
//STRIP001 private:
//STRIP001 	SchControlList		*arrPage[SCH_MAX_PAGES];
//STRIP001 	SchControlList		*pButtonList;
//STRIP001 	SfxObjectShellLock  pDocSh;
//STRIP001 	SfxItemSet*			pOutSet;
//STRIP001 
//STRIP001 	ChartModel    *pDoc;
//STRIP001 
//STRIP001 	BOOL bStored;
//STRIP001 	void StoreTextSettings();
//STRIP001 
//STRIP001 	SvxChartLegendPos   eLegendPos;
//STRIP001 
//STRIP001 // 	String aXAxisTitle;
//STRIP001 // 	String aYAxisTitle;
//STRIP001 // 	BOOL bXYTitleAutoChanged;
//STRIP001 // 	BOOL bXTitleAutoChanged;
//STRIP001 // 	BOOL bYTitleAutoChanged;
//STRIP001 
//STRIP001     SchMemChart         *pOriginalData,*pReducedData;
//STRIP001 
//STRIP001 	USHORT			nCurPageNr;
//STRIP001 	Timer			aPreviewDelay;
//STRIP001 	BOOL			bHasPrePage;
//STRIP001 	BOOL            bNoText;
//STRIP001 // 	BOOL            bXAxisChanged;
//STRIP001 // 	BOOL            bYAxisChanged;
//STRIP001 
//STRIP001 	BOOL            bReducedData;
//STRIP001 
//STRIP001 
/*    UINT32 	nValForm at;
	UINT32  nPercentValF ormat;
	UINT32  nDescrFor mat;
	UINT32  nPercentDe  scrFormat;
*/
//STRIP001 	BOOL    bShowMainTitle;
//STRIP001 	BOOL    bShowSubTitle;
//STRIP001 	BOOL    bShowXAxisTitle;
//STRIP001 	BOOL	bShowYAxisTitle;
//STRIP001 	BOOL	bShowZAxisTitle;
//STRIP001 	BOOL	bShowXDescr;
//STRIP001 	BOOL	bShowYDescr;
//STRIP001 	BOOL	bShowZDescr;
//STRIP001 	BOOL    bShowLegend;
//STRIP001 
//STRIP001 	void    RestoreTextSettings();
//STRIP001 	void    SetTextSettings(BOOL bON);
//STRIP001 
//STRIP001 
//STRIP001 	DECL_LINK(NoTextClickHdl, Button*);
//STRIP001 	DECL_LINK(PagerClickHdl, Button*);
//STRIP001 	DECL_LINK(ExecuteClickHdl, Button*);
//STRIP001 	DECL_LINK(EditLoseFocusHdl, Control*);
//STRIP001 	DECL_LINK(RadioButtonClickHdl, Button*);
//STRIP001 	DECL_LINK(CheckBoxClickHdl, CheckBox*);
//STRIP001 	DECL_LINK(SelectChartTypeHdl, void*);
//STRIP001 	DECL_LINK(SelectChartVariantHdl, void*);
//STRIP001 	DECL_LINK(PreviewDelayHdl, Timer*);
//STRIP001 
//STRIP001 
//STRIP001 	void            BuildChart();
//STRIP001 	void            construct(BOOL bDataInRows);
//STRIP001 	void			SetCurrentPage( USHORT nNewPageNr );
//STRIP001 	void			SelectVariantSet( USHORT nNewId, ChVariant eVariant );
//STRIP001 	void			InitFromModel();
//STRIP001 	void			SetupModel();
//STRIP001 	void			ScalePreview();
//STRIP001 	void			ExecuteVariant();
//STRIP001 	ChType			GetTypeFromStyle( SvxChartStyle eStyle );
//STRIP001 	void			EnableOverlap();
//STRIP001 	void			FillOutputItemSet();
//STRIP001 	ChVariant       TranslateFromModel (SvxChartStyle eStyle);
//STRIP001     void            NewAxisText( const ChType & eOldType, const ChType & eNewType,
//STRIP001                                  bool bChangeRowCol = false );
//STRIP001 	void            ChangeColRow ();
//STRIP001 
//STRIP001 	// Reduzierung der Daten zur schnelleren Darstellung:
//STRIP001 	void            SetDataToOrigin();
//STRIP001 	SchMemChart*    ReduceData(SchMemChart& rData);
//STRIP001 	void            ReduceDataAgain(BOOL bDontBuild=FALSE);
//STRIP001 	void            CopyDataText(SchMemChart *pTarget,SchMemChart *pSource);
//STRIP001 	void            CopyLegendText(SchMemChart *pTarget,SchMemChart *pSource,BOOL bCopyCols);
//STRIP001 	BOOL            GetReduceStyle(SvxChartStyle eStyle);
//STRIP001 
//STRIP001 	long			nShapeType;
//STRIP001 	BOOL			bYAutoOrigin;
//STRIP001 
//STRIP001     void            FillValueSets();
//STRIP001 
//STRIP001 protected:
//STRIP001 //	PAGE 1
//STRIP001 	FixedText*		pFT_1_CHARTTYPE;
//STRIP001 	ValueSet*		pCT_1_CHARTTYPE;
//STRIP001 
//STRIP001 //	PAGE 2
//STRIP001 	FixedText*		pFT_2_CHARTVARIANT;
//STRIP001 	ValueSet*		pCT_2_CHARTVARIANT;
//STRIP001 	CheckBox*		pCB_2_XGRID;
//STRIP001 	CheckBox*		pCB_2_YGRID;
//STRIP001 	CheckBox*		pCB_2_ZGRID;
//STRIP001 	FixedLine*		pFL_2_GRID;
//STRIP001 
//STRIP001 //	PAGE 3
//STRIP001 
//STRIP001 	FixedLine*		pFL_3_DISPLAY;
//STRIP001 	CheckBox*		pCB_3_TEXTTITLE;
//STRIP001 	Edit*			pET_3_TEXTTITLE;
//STRIP001     CheckBox*       pCB_3_LEGEND;
//STRIP001 	FixedText*		pFT_3_AXES;
//STRIP001 	CheckBox*		pCB_3_XTEXT;
//STRIP001 	Edit*			pET_3_TEXTRUBRIK;
//STRIP001 	CheckBox*		pCB_3_YTEXT;
//STRIP001 	Edit*			pET_3_TEXTSIZE;
//STRIP001 	CheckBox*		pCB_3_ZTEXT;
//STRIP001 	Edit*			pET_3_TEXTSECOND;
//STRIP001 
//STRIP001 //	all pages
//STRIP001 	SfxPreviewWin*	pCT_PREVIEW;
//STRIP001 	FixedLine		aFL_HORZLINE;
//STRIP001 	CheckBox        aCB_NOTEXT;
//STRIP001 	FixedText		aFT_DATAROWS;
//STRIP001 	RadioButton		aRB_DATAROWS;
//STRIP001 	RadioButton		aRB_DATACOLS;
//STRIP001 	HelpButton		aPB_HELP;
//STRIP001 	CancelButton	aPB_CANCEL;
//STRIP001 	PushButton		aPB_PREV;
//STRIP001 	PushButton		aPB_NEXT;
//STRIP001 	PushButton		aPB_EXECUTE;
//STRIP001 
//STRIP001 	String			aStrTitle;
//STRIP001 
//STRIP001     bool IsXAxisTitleDefault( bool bIsXYChart ) const;
//STRIP001 
//STRIP001 public:
//STRIP001 	SchDiagramAutoPilotDlg( Window* pParent, SchMemChart& rData,
//STRIP001 							const SfxItemSet& rInAttrs,
//STRIP001 							SfxItemSet& rOutAttrs, BOOL bPrePage = FALSE );
//STRIP001 	SchDiagramAutoPilotDlg( Window* pParent,
//STRIP001 							SfxObjectShellLock& rDocShellRef );
//STRIP001 	virtual ~SchDiagramAutoPilotDlg();
//STRIP001 
//STRIP001 	void ChangeChartData(SchMemChart& rData);
//STRIP001 
//STRIP001 	void SetLegendPos(SvxChartLegendPos  ePos){eLegendPos=ePos;};
//STRIP001 
//STRIP001     virtual void	DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 };

} //namespace binfilter
#endif //_SCH_DLGGRAUT_HXX

