/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: slidvish.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 01:08:28 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SD_SLIDVISH_HXX
#define _SD_SLIDVISH_HXX

#ifndef _SD_VIEWSHEL_HXX
#include "viewshel.hxx"
#endif
#ifndef _SD_SLIDVIEW_HXX
#include "slidview.hxx"
#endif
#ifndef _VIEWFAC_HXX //autogen
#include <bf_sfx2/viewfac.hxx>
#endif
#ifndef _SFXVIEWSH_HXX //autogen
#include <bf_sfx2/viewsh.hxx>
#endif
namespace binfilter {

class SdWindow;
class SdPage;
class SdUnoSlideView;

/*************************************************************************
|*
|*	  Beschreibung		SdSlideViewShell ist die ViewShell fuer den Diamodus
|*
\************************************************************************/

class SdSlideViewShell : public SdViewShell
{
//STRIP001 private:

//STRIP001 	SdSlideView*    pSlideView;
//STRIP001 	SdUnoSlideView*	pController;
//STRIP001 	Point		    aDisplayPos;
//STRIP001 	Size		    aDisplaySize;
//STRIP001     USHORT          nCurFocusPage;
//STRIP001 	BOOL		    bSetInitialZoomFactor;
//STRIP001 	BOOL		    bInitializeWinPos;

//STRIP001 	void            Construct(SdDrawDocument* pDoc);
//STRIP001     void            ImplDrawFocusRect( USHORT nPage, BOOL bVisible );

//STRIP001 protected:
	
//STRIP001     virtual void    InnerResizePixel(const Point &rPos, const Size &rSize);
//STRIP001 	virtual void    OuterResizePixel(const Point &rPos, const Size &rSize);
//STRIP001 	virtual Size    GetOptimalSizePixel() const;
//STRIP001 	virtual long    VirtHScrollHdl(ScrollBar* pHScroll);
//STRIP001 	virtual long    VirtVScrollHdl(ScrollBar* pVHScroll);

public:

	                TYPEINFO();

	                SFX_DECL_VIEWFACTORY(SdSlideViewShell);
	                SFX_DECL_INTERFACE(SD_IF_SDSLIDEVIEWSHELL);

					SdSlideViewShell(SfxViewFrame *pFrame, const SdSlideViewShell& rShell): SdViewShell(pFrame, rShell){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;SdSlideViewShell(SfxViewFrame *pFrame, const SdSlideViewShell& rShell);
					SdSlideViewShell(SfxViewFrame* pFrame, SfxViewShell* pOldShell): SdViewShell(pFrame, NULL ){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;SdSlideViewShell(SfxViewFrame* pFrame, SfxViewShell* pOldShell);
//STRIP001 	                ~SdSlideViewShell();

//STRIP001 	virtual void    Paint(const Rectangle& rRect, SdWindow* pWin);

    /** Set the position and size of the area which contains the GUI
        elements like rulers, sliders, and buttons as well as the document
        view.  Both size and position are expected to be in pixel
        coordinates.  The positions and sizes of the mentioned GUI elements
        are updated as well.

        <p> This method is implemented by first setting copying the given
        values to internal variables and then calling the
        <type>ArrangeGUIElements</type> method which performs the actual
        work of sizeing and arranging the UI elements accordingly.</p>
        @param rPos
            The position of the enclosing window relative to the document
            window.  This is only interesting if a Draw/Impress document
            view is embedded as OLE object into another document view.  For
            normal documents this position is (0,0).
        @param rSize
            The new size in pixel.
    */
//STRIP001 	virtual void    AdjustPosSizePixel(const Point &rPos, const Size &rSize);
                    
    /** Arrange and resize the GUI elements like rulers, sliders, and
        buttons as well as the actual document view according to the size of
        the enclosing window and current sizes of buttons, rulers, and
        sliders.
    */
//STRIP001     virtual void ArrangeGUIElements (void);
//STRIP001 	virtual void    AddWindow(SdWindow* pWin) { pSlideView->AddWin((OutputDevice*) pWin); }
//STRIP001 	virtual void    RemoveWindow(SdWindow* pWin) { pSlideView->DelWin((OutputDevice*) pWin); }
                    
//STRIP001 	virtual BOOL    KeyInput(const KeyEvent& rKEvt, SdWindow* pWin);
//STRIP001 	virtual void    MouseMove(const MouseEvent& rMEvt, SdWindow* pWin);
//STRIP001 	virtual void    MouseButtonUp(const MouseEvent& rMEvt, SdWindow* pWin);
//STRIP001 //STRIP001 	virtual void    MouseButtonDown(const MouseEvent& rMEvt, SdWindow* pWin);
//STRIP001 	virtual void    Command(const CommandEvent& rCEvt, SdWindow* pWin);

					virtual SdPage*	GetActualPage(){DBG_BF_ASSERT(0, "STRIP");return NULL;} //STRIP001 ;virtual SdPage*	GetActualPage();

//STRIP001 	String          GetPageRangeString();

					void            ExecCtrl(SfxRequest &rReq){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;	void            ExecCtrl(SfxRequest &rReq);
					void            GetCtrlState(SfxItemSet &rSet){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 void            GetCtrlState(SfxItemSet &rSet);
//STRIP001 	void            GetMenuState(SfxItemSet &rSet);
					void            GetAttrState(SfxItemSet &rSet){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;void            GetAttrState(SfxItemSet &rSet);

//STRIP001     void            SetPagesPerRow( USHORT nPagesPerRow );

					void            ExecStatusBar(SfxRequest& rReq){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;void            ExecStatusBar(SfxRequest& rReq);
					void            GetStatusBarState(SfxItemSet& rSet){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;void            GetStatusBarState(SfxItemSet& rSet);

					void            FuTemporary(SfxRequest &rReq){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;	void            FuTemporary(SfxRequest &rReq);
					void            FuPermanent(SfxRequest &rReq){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;void            FuPermanent(SfxRequest &rReq);
					void            FuSupport(SfxRequest &rReq){DBG_BF_ASSERT(0, "STRIP");} //STRIP001 ;void            FuSupport(SfxRequest &rReq);

//STRIP001 	virtual void    ReadFrameViewData(FrameView* pView);
//STRIP001 	virtual void    WriteFrameViewData();

//STRIP001 	virtual void	SetZoom(long nZoom);
//STRIP001 	virtual void	SetZoomRect(const Rectangle& rZoomRect);

//STRIP001 	virtual BOOL    HasSelection( BOOL bText = TRUE ) const;

    /** Draw the rectangle arround the specified slide that indicates whether
        the slide is selected or not.  When not selected the rectangle is
        painted in the background color (WindowColor from the style settings)
        and is therefore not visible.  A selected slide is painted with the
        WindowTextColor from the style settings.  Painting takes place in
        all associated windows.  The line- and fill color of the windows are
        restored to their original values after the rectangle is painted.
        @param nPage
            When the page number is invalid then the call is ignored.
    */
//STRIP001 	void			DrawSelectionRect( USHORT nPage );
//STRIP001     void			DrawFocusRect( USHORT nPage );

//STRIP001     virtual void    WriteUserDataSequence ( ::com::sun::star::uno::Sequence < ::com::sun::star::beans::PropertyValue >&, sal_Bool bBrowse = sal_False );
//STRIP001     virtual void    ReadUserDataSequence ( const ::com::sun::star::uno::Sequence < ::com::sun::star::beans::PropertyValue >&, sal_Bool bBrowse = sal_False );

//STRIP001 	virtual void    VisAreaChanged(const Rectangle& rRect);

//STRIP001     virtual ::com::sun::star::uno::Reference< ::com::sun::star::accessibility::XAccessible> CreateAccessibleDocumentView( SdWindow* pWindow );

//STRIP001     void            SelectionHasChanged();
//STRIP001     void            PageLayoutHasChanged();
//STRIP001     void            FocusHasChanged( USHORT nOldFocusPage, USHORT nNewFocusPage );
//STRIP001     void            PageVisibilityHasChanged( USHORT nPage, BOOL bVisible );
};

} //namespace binfilter
#endif // _SD_SLIDVISH_HXX
