/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_drgrfob.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 01:34:59 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#include <limits.h>
// auto strip #include <vcl/msgbox.hxx>
// auto strip #include <svtools/whiter.hxx>
// auto strip #include <svtools/itempool.hxx>
#ifndef _SFXAPP_HXX
#include <bf_sfx2/app.hxx>
#endif
// auto strip #ifndef _SFX_SHELL_HXX //autogen
// auto strip #include <bf_sfx2/shell.hxx>
// auto strip #endif
#ifndef _SVXIDS_HRC
#include <bf_svx/svxids.hrc>
#endif
// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _BASEDLGS_HXX
// auto strip #include <bf_sfx2/basedlgs.hxx>
// auto strip #endif
// auto strip #ifndef _SVDOPATH_HXX //autogen
// auto strip #include <bf_svx/svdograf.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_GRFFLT_HXX //autogen
// auto strip #include <bf_svx/grfflt.hxx>
// auto strip #endif
// auto strip #ifndef _AEITEM_HXX //autogen
// auto strip #include <svtools/aeitem.hxx>
// auto strip #endif
// auto strip #ifndef _SVX_GRAFCTRL_HXX
// auto strip #include <bf_svx/grafctrl.hxx>
// auto strip #endif

#pragma hdrstop

#include "app.hrc"
#include "res_bmp.hrc"
#include "glob.hrc"
#include "strings.hrc"
#include "docshell.hxx"
#include "viewshel.hxx"
// auto strip #include "sdwindow.hxx"
#include "drawview.hxx"
#include "sdresid.hxx"
// auto strip #include "drawdoc.hxx"
#include "drgrfob.hxx"

namespace binfilter {
#define SdDrawGrafObjectBar

SFX_DECL_TYPE( 13 );
#include "sdslots.hxx"

// -----------------------
// - SdDrawGrafObjectBar -
// -----------------------

/*N*/ SFX_IMPL_INTERFACE( SdDrawGrafObjectBar, SfxShell, SdResId( STR_GRAFOBJECTBARSHELL ) )
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OBJECT, SdResId( RID_DRAW_GRAF_TOOLBOX ) );
/*N*/ }

// -----------------------------------------------------------------------------

TYPEINIT1( SdDrawGrafObjectBar, SfxShell );

// -----------------------------------------------------------------------------

/*N*/ SdDrawGrafObjectBar::SdDrawGrafObjectBar( SdViewShell* pSdViewShell, SdView* pSdView ) :
/*N*/ 	SfxShell			( pSdViewShell ),
/*N*/ 	pView				( pSdView ),
/*N*/ 	pViewSh				( pSdViewShell ),
/*N*/ 	nMappedSlotFilter	( SID_GRFFILTER_INVERT )
/*N*/ {
/*N*/ 	SdDrawDocShell* pDocShell = pViewSh->GetDocSh();
/*N*/ 
/*N*/ 	SetPool( &pDocShell->GetPool() );
/*N*/ 	SetUndoManager( pDocShell->GetUndoManager() );
/*N*/ 	SetRepeatTarget( pView );
/*N*/ 	SetHelpId( SD_IF_SDDRAWGRAFOBJECTBAR );
/*N*/ 	SetName( String( RTL_CONSTASCII_USTRINGPARAM( "Graphic objectbar" )));
/*N*/ }

// -----------------------------------------------------------------------------

/*N*/ SdDrawGrafObjectBar::~SdDrawGrafObjectBar()
/*N*/ {
/*N*/ 	SetRepeatTarget( NULL );
/*N*/ }

// -----------------------------------------------------------------------------

//STRIP001 void SdDrawGrafObjectBar::GetAttrState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	if( pView )
//STRIP001 		SvxGrafAttrHelper::GetGrafAttrState( rSet, *pView );
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdDrawGrafObjectBar::Execute( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	if( pView )
//STRIP001 	{
//STRIP001 		SvxGrafAttrHelper::ExecuteGrafAttr( rReq, *pView );
//STRIP001 		Invalidate();
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdDrawGrafObjectBar::GetFilterState( SfxItemSet& rSet )
//STRIP001 {
//STRIP001 	const SdrMarkList&	rMarkList = pView->GetMarkList();
//STRIP001 	BOOL				bEnable = FALSE;
//STRIP001 
//STRIP001 	if( rMarkList.GetMarkCount() == 1 )
//STRIP001 	{
//STRIP001 		SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 
//STRIP001 		if( pObj && pObj->ISA( SdrGrafObj ) && ( ( (SdrGrafObj*) pObj )->GetGraphicType() == GRAPHIC_BITMAP ) )
//STRIP001 			bEnable = TRUE;
//STRIP001 	}
//STRIP001 
//STRIP001 	if( !bEnable )
//STRIP001 		SvxGraphicFilter::DisableGraphicFilterSlots( rSet );
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdDrawGrafObjectBar::ExecuteFilter( SfxRequest& rReq )
//STRIP001 {
//STRIP001 	const SdrMarkList& rMarkList = pView->GetMarkList();
//STRIP001 
//STRIP001 	if( rMarkList.GetMarkCount() == 1 )
//STRIP001 	{
//STRIP001 		SdrObject* pObj = rMarkList.GetMark( 0 )->GetObj();
//STRIP001 
//STRIP001 		if( pObj && pObj->ISA( SdrGrafObj ) && ( (SdrGrafObj*) pObj )->GetGraphicType() == GRAPHIC_BITMAP )
//STRIP001 		{
//STRIP001 			GraphicObject aFilterObj( ( (SdrGrafObj*) pObj )->GetGraphicObject() );
//STRIP001 
//STRIP001 			if( SVX_GRAPHICFILTER_ERRCODE_NONE == 
//STRIP001 				SvxGraphicFilter::ExecuteGrfFilterSlot( rReq, aFilterObj ) )
//STRIP001 			{
//STRIP001 				SdrPageView* pPageView = pView->GetPageViewPvNum( 0 );
//STRIP001 
//STRIP001 				if( pPageView )
//STRIP001 				{
//STRIP001 					SdrGrafObj*	pFilteredObj = (SdrGrafObj*) pObj->Clone();
//STRIP001 					String		aStr( pView->GetMarkDescription() );
//STRIP001 
//STRIP001 					aStr.Append( sal_Unicode(' ') );
//STRIP001 					aStr.Append( String( SdResId( STR_UNDO_GRAFFILTER ) ) );
//STRIP001 					pView->BegUndo( aStr );
//STRIP001 					pFilteredObj->SetGraphicObject( aFilterObj );
//STRIP001 					pView->ReplaceObject( pObj, *pPageView, pFilteredObj );
//STRIP001 					pView->EndUndo();
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	Invalidate();
//STRIP001 }

}
