/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sd_presvish.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 01:42:36 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// auto strip #ifndef _SFXREQUEST_HXX //autogen
// auto strip #include <bf_sfx2/request.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_TOPFRM_HXX
// auto strip #include <bf_sfx2/topfrm.hxx>
// auto strip #endif
// auto strip #ifndef _SFX_DISPATCH_HXX
// auto strip #include <bf_sfx2/dispatch.hxx>
// auto strip #endif

#include <bf_svx/svxids.hrc>
#include <bf_sfx2/app.hxx>
// auto strip #include "frmview.hxx"
#include "sdresid.hxx"
#include "docshell.hxx"
#include "presvish.hxx"
// auto strip #include "fuslshow.hxx"
// auto strip #include "sdattr.hxx"
// auto strip #include "sdpage.hxx"
// auto strip #include "drawdoc.hxx"
// auto strip #include "drawview.hxx"
#include "app.hrc"
#include "strings.hrc"
#include "glob.hrc"

namespace binfilter {
#define SdPresViewShell
#include "sdslots.hxx"

// -------------------
// - SdPresViewShell -
// -------------------

/*N*/ SFX_IMPL_INTERFACE( SdPresViewShell, SdDrawViewShell, SdResId( STR_PRESVIEWSHELL ) )
/*N*/ {
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_TOOLS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_FULLSCREEN | SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_DRAW_TOOLBOX));
/*N*/     SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_APPLICATION | SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_CLIENT | SFX_VISIBILITY_VIEWER | SFX_VISIBILITY_READONLYDOC,
/*N*/             					SdResId(RID_DRAW_VIEWER_TOOLBOX) );
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_OPTIONS | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_DRAW_OPTIONS_TOOLBOX));
/*N*/ 	SFX_OBJECTBAR_REGISTRATION( SFX_OBJECTBAR_COMMONTASK | SFX_VISIBILITY_STANDARD |
/*N*/ 								SFX_VISIBILITY_SERVER,
/*N*/ 								SdResId(RID_DRAW_COMMONTASK_TOOLBOX));
/*N*/ }

// -----------------------------------------------------------------------------

/*N*/ SFX_IMPL_VIEWFACTORY( SdPresViewShell, SdResId( STR_DEFAULTVIEW ) )
/*N*/ {
/*N*/ 	SFX_VIEW_REGISTRATION( SdDrawDocShell );
/*N*/ }

// -----------------------------------------------------------------------------

/*N*/ TYPEINIT1( SdPresViewShell, SdDrawViewShell );

// -----------------------------------------------------------------------------

//STRIP001 SdPresViewShell::SdPresViewShell( SfxViewFrame* pFrame, SfxViewShell *pOldShell ) :
//STRIP001     SdDrawViewShell( pFrame, pOldShell ),
//STRIP001     mbShowStarted( sal_False )
//STRIP001 {
//STRIP001 	if( pDocSh && pDocSh->GetCreateMode() == SFX_CREATE_MODE_EMBEDDED )
//STRIP001         maOldVisArea = pDocSh->GetVisArea( ASPECT_CONTENT );
//STRIP001 }
//STRIP001 
//STRIP001 // -----------------------------------------------------------------------------
//STRIP001 
//STRIP001 SdPresViewShell::SdPresViewShell( SfxViewFrame* pFrame, const SdDrawViewShell& rShell ) :
//STRIP001     SdDrawViewShell( pFrame, rShell ),
//STRIP001     mbShowStarted( sal_False )
//STRIP001 {
//STRIP001 	if( pDocSh && pDocSh->GetCreateMode() == SFX_CREATE_MODE_EMBEDDED )
//STRIP001         maOldVisArea = pDocSh->GetVisArea( ASPECT_CONTENT );
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 SdPresViewShell::~SdPresViewShell()
//STRIP001 {
//STRIP001 	if( pDocSh && pDocSh->GetCreateMode() == SFX_CREATE_MODE_EMBEDDED && !maOldVisArea.IsEmpty() )
//STRIP001 		pDocSh->SetVisArea( maOldVisArea );
//STRIP001 
//STRIP001     if( GetViewFrame() && GetViewFrame()->GetTopFrame() )
//STRIP001     {
//STRIP001         WorkWindow* pWorkWindow = (WorkWindow*) GetViewFrame()->GetTopFrame()->GetWindow().GetParent();
//STRIP001 
//STRIP001         if( pWorkWindow )
//STRIP001             pWorkWindow->StartPresentationMode( FALSE, pFuSlideShow ? pFuSlideShow->IsAlwaysOnTop() : 0 );
//STRIP001     }
//STRIP001 
//STRIP001 	if( pFuSlideShow )
//STRIP001 	{
//STRIP001 		pFuSlideShow->Deactivate();
//STRIP001 		pFuSlideShow->Terminate();
//STRIP001 		pFuSlideShow->Destroy();
//STRIP001 		pFuSlideShow = NULL;
//STRIP001 	}
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPresViewShell::Activate( BOOL bIsMDIActivate )
//STRIP001 {
//STRIP001 	SfxViewShell::Activate( bIsMDIActivate );
//STRIP001 
//STRIP001 	if( bIsMDIActivate )
//STRIP001 	{
//STRIP001 		SdView*     pView = GetView();
//STRIP001 		SfxBoolItem aItem( SID_NAVIGATOR_INIT, TRUE );
//STRIP001 		
//STRIP001         GetViewFrame()->GetDispatcher()->Execute( SID_NAVIGATOR_INIT, SFX_CALLMODE_ASYNCHRON | SFX_CALLMODE_RECORD, &aItem, 0L );
//STRIP001 
//STRIP001 		if( pFuSlideShow && !pFuSlideShow->IsTerminated() )
//STRIP001 			pFuSlideShow->Activate();
//STRIP001 
//STRIP001 		if( pFuActual )
//STRIP001 			pFuActual->Activate();
//STRIP001 
//STRIP001 		if( pView )
//STRIP001 			pView->ShowMarkHdl( NULL );
//STRIP001 	}
//STRIP001 
//STRIP001 	if( bIsMDIActivate )
//STRIP001 		ReadFrameViewData( pFrameView );
//STRIP001 	pDocSh->Connect( this );
//STRIP001 
//STRIP001     if( pFuSlideShow && !mbShowStarted )
//STRIP001     {
//STRIP001         pFuSlideShow->StartShow();
//STRIP001         mbShowStarted = sal_True;
//STRIP001     }
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPresViewShell::Paint( const Rectangle& rRect, SdWindow* pWin )
//STRIP001 {
//STRIP001     // allow paints only if show is already started
//STRIP001     if( mbShowStarted )
//STRIP001         SdDrawViewShell::Paint( rRect, pWin );
//STRIP001 }

// -----------------------------------------------------------------------------

//STRIP001 void SdPresViewShell::CreateFullScreenShow( SdViewShell* pOriginShell, SfxRequest& rReq )
//STRIP001 {
//STRIP001     SFX_REQUEST_ARG( rReq, pAlwaysOnTop, SfxBoolItem, ATTR_PRESENT_ALWAYS_ON_TOP, FALSE );
//STRIP001 
//STRIP001     WorkWindow*     pWorkWindow = new WorkWindow( NULL, WB_HIDE | WB_CLIPCHILDREN );
//STRIP001     SdDrawDocument* pDoc = pOriginShell->GetDoc();
//STRIP001     SdPage*         pActualPage = pOriginShell->GetActualPage();
//STRIP001     BOOL            bAlwaysOnTop = ( ( SID_REHEARSE_TIMINGS != rReq.GetSlot() ) && pAlwaysOnTop ) ? pAlwaysOnTop->GetValue() : pDoc->GetPresAlwaysOnTop();
//STRIP001 
//STRIP001     pWorkWindow->StartPresentationMode( TRUE, bAlwaysOnTop ? PRESENTATION_HIDEALLAPPS : 0 );
//STRIP001     SfxTopFrame* pNewFrame = SfxTopFrame::Create( pDoc->GetDocSh(), pWorkWindow, 4, TRUE );
//STRIP001     pNewFrame->SetPresentationMode( TRUE );
//STRIP001 
//STRIP001     SdPresViewShell*    pShell = (SdPresViewShell*) pNewFrame->GetCurrentViewFrame()->GetViewShell();
//STRIP001     SfxUInt16Item       aId( SID_CONFIGITEMID, SID_NAVIGATOR );
//STRIP001     SfxBoolItem         aShowItem( SID_SHOWPOPUPS, FALSE );
//STRIP001     const USHORT        nCurSdPageNum = ( pActualPage->GetPageNum() - 1 ) / 2;
//STRIP001     FrameView*          pNewFrameView = pOriginShell->GetFrameView();
//STRIP001     
//STRIP001     pNewFrameView->Connect();
//STRIP001     pShell->GetFrameView()->Disconnect();
//STRIP001     pShell->pFrameView = pNewFrameView;
//STRIP001     pShell->ReadFrameViewData( pNewFrameView );
//STRIP001     pShell->SwitchPage( nCurSdPageNum );
//STRIP001     pShell->WriteFrameViewData();

//STRIP001     pShell->GetViewFrame()->GetDispatcher()->Execute( SID_SHOWPOPUPS, SFX_CALLMODE_SYNCHRON, &aShowItem, &aId, 0L );
//STRIP001     pShell->GetViewFrame()->Show();
//STRIP001     pShell->pFuSlideShow = new FuSlideShow( pShell, pShell->pWindow, pShell->pDrView, pShell->pDoc, rReq );
//STRIP001     pShell->GetActiveWindow()->GrabFocus();
//STRIP001 }
}
