/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sfx2_partwnd.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 03:00:53 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

// includes ******************************************************************

#ifndef _COM_SUN_STAR_AWT_XWINDOW_HPP_
#include <com/sun/star/awt/XWindow.hpp>
#endif
#ifndef _COM_SUN_STAR_TASK_XSTATUSINDICATOR_HPP_
#include <com/sun/star/task/XStatusIndicator.hpp>
#endif
#ifndef _COM_SUN_STAR_UNO_REFERENCE_H_
#include <com/sun/star/uno/Reference.h>
#endif
#ifndef _COM_SUN_STAR_UNO_SEQUENCE_HXX_
#include <com/sun/star/uno/Sequence.hxx>
#endif
#ifndef _COM_SUN_STAR_BEANS_PROPERTYVALUE_HPP_
#include <com/sun/star/beans/PropertyValue.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_URL_HPP_
#include <com/sun/star/util/URL.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XFRAME_HPP_
#include <com/sun/star/frame/XFrame.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_XCLOSEABLE_HPP_
#include <com/sun/star/util/XCloseable.hpp>
#endif
#ifndef _COM_SUN_STAR_UTIL_CLOSEVETOEXCEPTION_HPP_
#include <com/sun/star/util/CloseVetoException.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_XCOMPONENT_HPP_
#include <com/sun/star/lang/XComponent.hpp>
#endif
#ifndef _COM_SUN_STAR_LANG_DISPOSEDEXCEPTION_HPP_
#include <com/sun/star/lang/DisposedException.hpp>
#endif
#ifndef _COM_SUN_STAR_FRAME_XCONTROLLER_HPP_
#include <com/sun/star/frame/XController.hpp>
#endif
#ifndef _COM_SUN_STAR_AWT_POSSIZE_HPP_
#include <com/sun/star/awt/PosSize.hpp>
#endif
#ifndef _UNOTOOLS_PROCESSFACTORY_HXX
#include <comphelper/processfactory.hxx>
#endif

#include <toolkit/helper/vclunohelper.hxx>

#include "sfxsids.hrc"
#include "partwnd.hxx"
#include "bindings.hxx"
#include "dispatch.hxx"
#include "viewfrm.hxx"
#include "frame.hxx"
#include "sfxuno.hxx"

#ifndef _LEGACYBINFILTERMGR_HXX
#include <legacysmgr/legacy_binfilters_smgr.hxx>	//STRIP002 
#endif
namespace binfilter {

/*
// class SfxPartwinFrame_Impl ------------------------------------------

class SfxPartwinFrame_Impl : public SfxUnoFrame
{
public:
	SfxPopupStatusIndicator*		pIndicator;
	SfxPartDockWnd_Impl*			pBeamer;

	virtual void 	 SAL_CALL				initialize(const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow > & aPeer) throw ( ::com::sun::star::uno::RuntimeException );
	virtual SfxFrame*				CreateFrame( Window* pParent );
	virtual ::com::sun::star::uno::Reference< ::com::sun::star::task::XStatusIndicator >   SAL_CALL		getStatusIndicator(void) throw ( ::com::sun::star::uno::RuntimeException );
	void 							dispatch_Impl( const ::com::sun::star::util::URL& aURL, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& aArgs );
};

// -----------------------------------------------------------------------
::com::sun::star::uno::Reference< ::com::sun::star::task::XStatusIndicator > SAL_CALL SfxPartwinFrame_Impl::getStatusIndicator(void) throw ( ::com::sun::star::uno::RuntimeException )
{
	return pIndicator->GetInterface();
}

void SfxPartwinFrame_Impl::dispatch_Impl( const ::com::sun::star::util::URL& rURL, const ::com::sun::star::uno::Sequence< ::com::sun::star::beans::PropertyValue >& rArgs )
{
	if ( !pBeamer )
		return;

	if ( rURL.Protocol.compareToAscii(".uno:") == 0 )
	{
		if ( rURL.Path.compareToAscii("Reload") == 0)
		{
			SfxUnoFrame::dispatch_Impl( rURL, rArgs );
			if ( pBeamer->IsAutoHide_Impl() )
				pBeamer->AutoShow_Impl( sal_True );
			return;
		}
	}
	else
		SfxUnoFrame::dispatch_Impl( rURL, rArgs );

	if ( rURL.Complete.len() )
	{
		if ( pBeamer->IsAutoHide_Impl() )
			pBeamer->AutoShow_Impl( sal_True );
	}
	else
	{
		::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame >  xTmp( this );
		SfxApplication* pApp = SFX_APP();
        pApp->SetChildWindow( SID_BROWSER, sal_False );
        pApp->GetBindings().Invalidate( SID_BROWSER );
	}
}


// -----------------------------------------------------------------------
void SAL_CALL SfxPartwinFrame_Impl::initialize( const ::com::sun::star::uno::Reference< ::com::sun::star::awt::XWindow > & aWindow ) throw ( ::com::sun::star::uno::RuntimeException )
{
	setName( ::rtl::OUString::createFromAscii("_partwindow") );
	SetContainerWindow_Impl( aWindow );
}

// -----------------------------------------------------------------------
SfxFrame* SfxPartwinFrame_Impl::CreateFrame( Window* pParent )
{
	return NULL;
}

*/

//****************************************************************************
// SfxPartChildWnd_Impl
//****************************************************************************

/*N*/ SFX_IMPL_DOCKINGWINDOW( SfxPartChildWnd_Impl, SID_BROWSER );

/*?*/ SfxPartChildWnd_Impl::SfxPartChildWnd_Impl
/*?*/ (
/*?*/ 	Window* pParent,
/*?*/ 	sal_uInt16 nId,
/*?*/ 	SfxBindings* pBindings,
/*?*/ 	SfxChildWinInfo* pInfo
/*?*/ )
/*?*/ 	: SfxChildWindow( pParent, nId )
/*?*/ {DBG_BF_ASSERT(0, "STRIP"); //STRIP001 
//STRIP001 	// Window erzeugen
//STRIP001     pWindow = new SfxPartDockWnd_Impl( pBindings, this, pParent, WB_STDDOCKWIN | WB_CLIPCHILDREN | WB_SIZEABLE | WB_3DLOOK );
//STRIP001 	eChildAlignment = SFX_ALIGN_TOP;
//STRIP001 	if ( pInfo )
//STRIP001 		pInfo->nFlags |= SFX_CHILDWIN_FORCEDOCK;
//STRIP001 
//STRIP001 	((SfxDockingWindow*)pWindow)->SetFloatingSize( Size( 175, 175 ) );
//STRIP001 	pWindow->SetSizePixel( Size( 175, 175 ) );
//STRIP001 
//STRIP001 	( ( SfxDockingWindow* ) pWindow )->Initialize( pInfo );
/*?*/ }

/*N*/ SfxPartChildWnd_Impl::~SfxPartChildWnd_Impl()
/*?*/ {{DBG_BF_ASSERT(0, "STRIP"); }//STRIP001 
//STRIP001     ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > xFrame = GetFrame();
//STRIP001 
//STRIP001     // If xFrame=NULL release pMgr! Because this window lives longer then the manager!
//STRIP001     // In these case we got a xFrame->dispose() call from outside ... and has release our
//STRIP001     // frame reference in our own DisposingListener.
//STRIP001     // But don't do it, if xFrame already exist. Then dispose() must come from inside ...
//STRIP001     // and we need a valid pMgr for further operations ...
//STRIP001 
//STRIP001     SfxPartDockWnd_Impl* pWin = (SfxPartDockWnd_Impl*) pWindow;
//STRIP001 //    if( pWin != NULL && !xFrame.is() )
//STRIP001 //        pWin->ReleaseChildWindow_Impl();
//STRIP001 /*
//STRIP001     // Release frame and window.
//STRIP001     // If frame reference is valid here ... start dieing from inside by calling dispose().
//STRIP001     SetFrame( NULL );
//STRIP001     pWindow = NULL;
//STRIP001 */
//STRIP001     if ( pWin && xFrame == pWin->GetBindings().GetActiveFrame() )
//STRIP001         pWin->GetBindings().SetActiveFrame( NULL );
//STRIP001 /*
//STRIP001     if( xFrame.is() )
//STRIP001     {
//STRIP001         try
//STRIP001         {
//STRIP001             ::com::sun::star::uno::Reference< ::com::sun::star::util::XCloseable > xCloseable  ( xFrame, ::com::sun::star::uno::UNO_QUERY );
//STRIP001             ::com::sun::star::uno::Reference< ::com::sun::star::lang::XComponent > xDisposeable( xFrame, ::com::sun::star::uno::UNO_QUERY );
//STRIP001             if (xCloseable.is())
//STRIP001                 xCloseable->close(sal_True);
//STRIP001             else
//STRIP001             if (xDisposeable.is())
//STRIP001                 xDisposeable->dispose();
//STRIP001         }
//STRIP001         catch( ::com::sun::star::util::CloseVetoException& )
//STRIP001         {
//STRIP001         }
//STRIP001         catch( ::com::sun::star::lang::DisposedException& )
//STRIP001         {
//STRIP001         }
//STRIP001     }
//STRIP001  */
/*?*/ }

//STRIP001 sal_Bool SfxPartChildWnd_Impl::QueryClose()
//STRIP001 {
//STRIP001 	return ( (SfxPartDockWnd_Impl*)pWindow )->QueryClose();
//STRIP001 }
//STRIP001 
//STRIP001 //****************************************************************************
//STRIP001 // SfxPartDockWnd_Impl
//STRIP001 //****************************************************************************
//STRIP001 
//STRIP001 SfxPartDockWnd_Impl::SfxPartDockWnd_Impl
//STRIP001 (
//STRIP001 	SfxBindings* pBindings,
//STRIP001 	SfxChildWindow* pChildWin,
//STRIP001 	Window* pParent,
//STRIP001 	WinBits nBits
//STRIP001 )
//STRIP001     : SfxDockingWindow( pBindings, pChildWin, pParent, nBits )
//STRIP001 {
//STRIP001     ::com::sun::star::uno::Reference < ::com::sun::star::frame::XFrame > xFrame(
//STRIP001             ::legacy_binfilters::getLegacyProcessServiceFactory()->createInstance(
//STRIP001             DEFINE_CONST_UNICODE("com.sun.star.frame.Frame") ), ::com::sun::star::uno::UNO_QUERY );
//STRIP001     xFrame->initialize( VCLUnoHelper::GetInterface ( this ) );
//STRIP001     pChildWin->SetFrame( xFrame );
//STRIP001 	if ( pBindings->GetDispatcher() )
//STRIP001 	{
//STRIP001 		::com::sun::star::uno::Reference < ::com::sun::star::frame::XFramesSupplier >
//STRIP001 				xSupp ( pBindings->GetDispatcher()->GetFrame()->GetFrame()->GetFrameInterface(), ::com::sun::star::uno::UNO_QUERY );
//STRIP001 		if ( xSupp.is() )
//STRIP001             xSupp->getFrames()->append( xFrame );
//STRIP001 	}
//STRIP001     else
//STRIP001         DBG_ERROR("Bindings without Dispatcher!");
//STRIP001 }
//STRIP001 
//STRIP001 //****************************************************************************
//STRIP001 
//STRIP001 SfxPartDockWnd_Impl::~SfxPartDockWnd_Impl()
//STRIP001 {
//STRIP001 }
//STRIP001 
//STRIP001 //****************************************************************************
//STRIP001 
//STRIP001 Rectangle impl_Rectangle_Struct2Object( const ::com::sun::star::awt::Rectangle& aRectangleStruct )
//STRIP001 {
//STRIP001 	return Rectangle(aRectangleStruct.X,aRectangleStruct.Y,aRectangleStruct.Width,aRectangleStruct.Height);
//STRIP001 }
//STRIP001 
//STRIP001 void SfxPartDockWnd_Impl::Resize()
//STRIP001 
//STRIP001 /*	[Beschreibung]
//STRIP001 	Anpassung der Gr"osse der Controls an die neue Windowgr"osse
//STRIP001 */
//STRIP001 
//STRIP001 {
//STRIP001 	SfxDockingWindow::Resize();
//STRIP001 }
//STRIP001 
//STRIP001 //****************************************************************************
//STRIP001 
//STRIP001 sal_Bool SfxPartDockWnd_Impl::QueryClose()
//STRIP001 {
//STRIP001 	sal_Bool bClose = sal_True;
//STRIP001     SfxChildWindow* pChild = GetChildWindow_Impl();
//STRIP001     if( pChild )
//STRIP001     {
//STRIP001         ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > xFrame = pChild->GetFrame();
//STRIP001         if( xFrame.is() )
//STRIP001         {
//STRIP001             ::com::sun::star::uno::Reference< ::com::sun::star::frame::XController >  xCtrl = xFrame->getController();
//STRIP001             if( xCtrl.is() )
//STRIP001                 bClose = xCtrl->suspend( sal_True );
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001     return bClose;
//STRIP001 }
//STRIP001 
//STRIP001 //****************************************************************************
//STRIP001 
//STRIP001 long SfxPartDockWnd_Impl::Notify( NotifyEvent& rEvt )
//STRIP001 {
//STRIP001     if( rEvt.GetType() == EVENT_GETFOCUS )
//STRIP001     {
//STRIP001         SfxChildWindow* pChild = GetChildWindow_Impl();
//STRIP001         if( pChild )
//STRIP001         {
//STRIP001             ::com::sun::star::uno::Reference< ::com::sun::star::frame::XFrame > xFrame = pChild->GetFrame();
//STRIP001             if( xFrame.is() )
//STRIP001                 xFrame->activate();
//STRIP001         }
//STRIP001     }
//STRIP001 
//STRIP001 	return SfxDockingWindow::Notify( rEvt );
//STRIP001 }
//STRIP001 
//STRIP001 void SfxPartDockWnd_Impl::FillInfo( SfxChildWinInfo& rInfo ) const
//STRIP001 {
//STRIP001 	SfxDockingWindow::FillInfo( rInfo );
//STRIP001 	rInfo.bVisible = sal_False;
//STRIP001 }


}
