/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sfx2_fsetview.cxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 03:50:58 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SFXENUMITEM_HXX //autogen
#include <svtools/eitem.hxx>
#endif
#ifndef _SFXINTITEM_HXX //autogen
#include <svtools/intitem.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen
#include <svtools/stritem.hxx>
#endif
#ifndef _SPLITWIN_HXX //autogen
#include <vcl/splitwin.hxx>
#endif
#ifndef _DOCKWIN_HXX //autogen
#include <vcl/dockwin.hxx>
#endif
#ifndef _MSGBOX_HXX //autogen
#include <vcl/msgbox.hxx>
#endif
#ifndef _SV_MEDIT_HXX
#include <svtools/svmedit.hxx>
#endif
#pragma hdrstop

#include <fsetview.hxx>
#include <sfxresid.hxx>
#include <fsetobsh.hxx>
#include <view.hrc>
#include <mnumgr.hxx>
#include "hintpost.hxx"
#include "request.hxx"
#include "urlframe.hxx"
#include "genlink.hxx"
#include "framedlg.hxx"
#include "dispatch.hxx"
#include "docfile.hxx"
#include "objitem.hxx"
#include "objface.hxx"
#include "app.hxx"
#include "topfrm.hxx"

//=========================================================================

DBG_NAME(SfxFrameSetView_Impl)

#define SfxFrameSetView_Impl
namespace binfilter {
#include <sfxslots.hxx>

//=========================================================================

//STRIP001 TYPEINIT1(SfxFrameSetView_Impl, SfxFrameSetViewShell);
//STRIP001 
//STRIP001 SFX_IMPL_INTERFACE( SfxFrameSetView_Impl, SfxFrameSetViewShell, SfxResId( STR_FRAMESETVIEWSHELL ) )
//STRIP001 {
//STRIP001 	SFX_FEATURED_OBJECTBAR_REGISTRATION(
//STRIP001 			SFX_OBJECTBAR_OBJECT |
//STRIP001 			SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_STANDARD | SFX_VISIBILITY_READONLYDOC,
//STRIP001 			SfxResId(RID_FRAMESETEDIT_TOOLBOX), SFX_FEATURE_FRAMESET_DESIGNMODE );
//STRIP001 }
//STRIP001 
//STRIP001 SFX_IMPL_VIEWFACTORY( SfxFrameSetView_Impl, SfxResId( STR_FRAMESETVIEW ) )
//STRIP001 {
//STRIP001 	SFX_VIEW_REGISTRATION( SfxFrameSetObjectShell );
//STRIP001 }
//STRIP001 
//STRIP001 BOOL SfxFrameSetView_Impl::HasUIFeature( ULONG nFeature )
//STRIP001 {
//STRIP001 	return ( nFeature == SFX_FEATURE_FRAMESET_DESIGNMODE && IsInEditMode() );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxFrameSetView_Impl::SfxFrameSetView_Impl( SfxViewFrame *pFrame, const SfxFrameSetView_Impl& rWin )
//STRIP001 	: SfxFrameSetViewShell( pFrame, rWin )
//STRIP001 	, pSourceView( NULL )
//STRIP001 {
//STRIP001 	DBG_CTOR(SfxFrameSetView_Impl, 0);
//STRIP001 	SetName( DEFINE_CONST_UNICODE( "FrameSetView" ) );
//STRIP001 	StartListening( *pFrame );
//STRIP001 	SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 
//STRIP001 	if ( GetWindow() )
//STRIP001 		GetWindow()->SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxFrameSetView_Impl::SfxFrameSetView_Impl( SfxViewFrame *pFrame, SfxViewShell* pShell)
//STRIP001 	: SfxFrameSetViewShell( pFrame, pShell )
//STRIP001 	, pSourceView( NULL )
//STRIP001 {
//STRIP001 	DBG_CTOR(SfxFrameSetView_Impl, 0);
//STRIP001 	SetName( DEFINE_CONST_UNICODE( "FrameSetView" ) );
//STRIP001 	StartListening( *pFrame );
//STRIP001 	SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 
//STRIP001 	if ( GetWindow() )
//STRIP001 		GetWindow()->SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------
//STRIP001 
//STRIP001 SfxFrameSetView_Impl::~SfxFrameSetView_Impl()
//STRIP001 {
//STRIP001 	DBG_DTOR(SfxFrameSetView_Impl, 0);
//STRIP001 	if ( pSourceView )
//STRIP001 		EndListening( *pSourceView );
//STRIP001 	EndListening( *GetViewFrame() );
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxFrameSetView_Impl::SFX_NOTIFY( SfxBroadcaster& rBC,
//STRIP001 									const TypeId& rBCType,
//STRIP001 									const SfxHint& rHint,
//STRIP001 									const TypeId& rHintType )
//STRIP001 /* [Beschreibung]
//STRIP001  */
//STRIP001 {
//STRIP001 	if ( rHint.IsA(TYPE(SfxSimpleHint)) )
//STRIP001 	{
//STRIP001 		if ( &rBC == GetViewFrame()->GetObjectShell() ||
//STRIP001 			&rBC == GetViewFrame() )
//STRIP001 		{
//STRIP001 			SfxFrameSetObjectShell *pDoc =
//STRIP001 				((SfxFrameSetObjectShell*)GetViewFrame()->GetObjectShell());
//STRIP001 			switch( ( (SfxSimpleHint&) rHint ).GetId() )
//STRIP001 			{
//STRIP001 				// Wir horchen nur an FrameSetDocuments
//STRIP001 				case SFX_HINT_DOCCHANGED:
//STRIP001 				{
//STRIP001 					// Da sich der Aufbau auch v"ollig ge"andert haben kann,
//STRIP001 					// werfen wir alles von uns
//STRIP001 					SfxFrameSetDescriptor *pUndo = GetDescriptor()->Clone();
//STRIP001 					GetSplitWindow()->SetUpdateMode( FALSE );
//STRIP001 					GetViewFrame()->GetFrame()->CloseChildFrames();
//STRIP001 					ReFill( pDoc->GetFrameSetDescriptor() );
//STRIP001 					GetSplitWindow()->SetUpdateMode( TRUE );
//STRIP001 					SaveUndo( pUndo, pDoc->GetFrameSetDescriptor()->Clone(),
//STRIP001 							  DEFINE_CONST_UNICODE( "FrameSetView" ), TRUE );
//STRIP001 					break;
//STRIP001 				}
//STRIP001 				case SFX_HINT_TITLECHANGED:
//STRIP001 				case SFX_HINT_MODECHANGED:
//STRIP001 				{
//STRIP001 					if ( IsInEditMode() )
//STRIP001 					{
//STRIP001 						PrepareWindows( !GetViewFrame()->GetObjectShell()->IsReadOnly() );
//STRIP001 						break;
//STRIP001 					}
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else if ( &rBC == pSourceView )
//STRIP001 		{
//STRIP001 			switch( ( (SfxSimpleHint&) rHint ).GetId() )
//STRIP001 			{
//STRIP001 				// Wir horchen nur an FrameSetDocuments
//STRIP001 				case SFX_HINT_DYING:
//STRIP001 				{
//STRIP001 					pSourceView = NULL;
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SfxFrameSetView_Impl::Execute_Impl(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	if ( !GetWindow() && !rReq.IsAPI() )
//STRIP001 	{
//STRIP001 		// Alle Anfragen gehen an das Top-Frameset
//STRIP001 		SfxFrameSetViewShell *pShell = this;
//STRIP001 		while ( !pShell->GetWindow() )
//STRIP001 			pShell = pShell->GetParentFrameSet();
//STRIP001 		SfxFrameSetView_Impl *pView = PTR_CAST( SfxFrameSetView_Impl, pShell );
//STRIP001 		if ( pView )
//STRIP001 			pView->Execute_Impl( rReq );
//STRIP001 		return;
//STRIP001 	}
//STRIP001 
//STRIP001 	// Aktuellen Frame merken
//STRIP001 	SfxViewFrame *pViewFrame = GetViewFrame();
//STRIP001 	SfxFrame* pFrame = pViewFrame->GetFrame();
//STRIP001 	BOOL bEditMode = IsInEditMode();
//STRIP001 	BOOL bReadOnly = pViewFrame->GetObjectShell()->IsReadOnly();
//STRIP001 	const USHORT nId = rReq.GetSlot();
//STRIP001 /*
//STRIP001 	if ( nId == SID_EDIT_FRAMESET )
//STRIP001 	{
//STRIP001 		SFX_REQUEST_ARG(rReq, pShowItem, SfxBoolItem, nId, FALSE);
//STRIP001 		BOOL bShow = pShowItem ? pShowItem->GetValue() : !bEditMode;
//STRIP001 		if ( bShow && bReadOnly )
//STRIP001 		{
//STRIP001 			// EditMode soll angeschaltet werden, Dokument ist aber ReadOnly.
//STRIP001 			// Wenn m"oglich, gleich zum Bearbeiten "offnen, aber nur, wenn
//STRIP001 			// das ohne Reload m"oglich ist, sonst wird n"amlich diese
//STRIP001 			// ViewShell abgeschossen!
//STRIP001 			// Wenn das erfolgreich ist, schaltet das schon den Editmode an.
//STRIP001 			SfxBoolItem aItem( SID_EDIT_FRAMESET, TRUE );
//STRIP001 			SfxBoolItem aReloadItem( SID_EDITDOC, FALSE );
//STRIP001 			pViewFrame->GetDispatcher()->Execute( SID_EDITDOC, SFX_CALLMODE_SYNCHRON,
//STRIP001 				&aItem, &aReloadItem, 0L );
//STRIP001 			bEditMode = IsInEditMode();
//STRIP001 			if ( bEditMode == bShow )
//STRIP001 				// SID_EDIT_DOC hat auch gleich den EditMode umgeschaltet
//STRIP001 				return;
//STRIP001 		}
//STRIP001 	}
//STRIP001 */
//STRIP001 	// Da Framesets asynchron ihre Frames nachladen, mu\s evtl. noch das
//STRIP001 	// Nachladen erzwungen werden
//STRIP001 	SplitWindow* pWindow = GetSplitWindow();
//STRIP001 	const SfxFrameSetDescriptor *pDescriptor = GetDescriptor();
//STRIP001 
//STRIP001 //	if ( pDescriptor->GetFrame(0) && !pFrame->GetChildFrameCount() )
//STRIP001 		//	ForceInit();	Bugfix #55871#: GPF wenn beim Laden Task geclosed wird und Basic ist an
//STRIP001 
//STRIP001 	// Nur im EditMode und wenn das Dokument beschreibbar ist, k"onnen
//STRIP001 	// "Anderungen vorgenommen werden; ansonsten ist nur Speichern,
//STRIP001 	// Modeumschaltung oder SourceView m"oglich. Wird ein Request ohne EditMode
//STRIP001 	// angefordert, wird dieser vorher automatisch angeschaltet.
//STRIP001 	if ( nId != SID_EDIT_FRAMESET && nId != SID_SAVEDOC && nId != SID_SAVEASDOC
//STRIP001 		&& nId != SID_SOURCEVIEW && nId != SID_EDITDOC )
//STRIP001 //		&& !rReq.IsAPI() )
//STRIP001 	{
//STRIP001 		if ( rReq.IsAPI() )
//STRIP001 			bReadOnly = FALSE;
//STRIP001 		if ( bReadOnly )
//STRIP001 			return;
//STRIP001 		else
//STRIP001 		{
//STRIP001 			// EditMode starten, sonst gibt es Probleme mit Undo etc.
//STRIP001 			if ( !bEditMode && ( !rReq.IsAPI() /*|| GetWindow() */ ) )
//STRIP001 			{
//STRIP001 				SfxRequest aReq( SID_EDIT_FRAMESET, SFX_CALLMODE_SYNCHRON, GetPool() );
//STRIP001 				ExecuteSlot( aReq );
//STRIP001 				bEditMode = IsInEditMode();
//STRIP001 				if ( !bEditMode )
//STRIP001 					return;
//STRIP001 			}
//STRIP001 
//STRIP001 			// History zur"ucksetzen, da sich die Frames-Struktur "andern kann
//STRIP001 			pFrame->GetTopFrame()->ClearHistory();
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	// Den Frame ermitteln, der bearbeitet werden soll
//STRIP001 	// Ohne entsprechenden Parameter den aktuellen Frame nehmen
//STRIP001 	USHORT nItemId = GetCurItemId();
//STRIP001 	SfxFrame *pModifiedFrame = GetActiveFrame();
//STRIP001 	SFX_REQUEST_ARG( rReq, pNameItem, SfxStringItem, SID_FRAMETITLE, FALSE );
//STRIP001 	SFX_REQUEST_ARG( rReq, pIdItem, SfxUInt16Item, SID_MODIFY_FRAME, FALSE);
//STRIP001 
//STRIP001 	if ( pIdItem )
//STRIP001 	{
//STRIP001 		// SFX kann es auch direkt "uber Nummern
//STRIP001 		nItemId = pIdItem->GetValue();
//STRIP001 		pModifiedFrame = pFrame->SearchFrame_Impl( nItemId );
//STRIP001 	}
//STRIP001 	else if ( pNameItem )
//STRIP001 	{
//STRIP001 		// API spricht die Frames mit ihrem Namen an
//STRIP001 		String aName( pNameItem->GetValue() );
//STRIP001 		SfxFrame* pF = pFrame->SearchChildrenForName_Impl( pNameItem->GetValue() );
//STRIP001 		USHORT nNumeric = (USHORT) aName.ToInt32();
//STRIP001 		if ( !pF && nNumeric )
//STRIP001 			pF = pFrame->SearchFrame_Impl( nNumeric );
//STRIP001 
//STRIP001 		if ( pF && pF->GetParentFrame() != pFrame )
//STRIP001 			pF = NULL;
//STRIP001 
//STRIP001 		// Frame gefunden ?
//STRIP001 		if ( pF )
//STRIP001 		{
//STRIP001 			pModifiedFrame = pF;
//STRIP001 			nItemId = pF->GetFrameId_Impl();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			DBG_ERROR( "Framename nicht gefunden!" );
//STRIP001 			return;
//STRIP001 		}
//STRIP001 	}
//STRIP001 
//STRIP001 	switch( nId )
//STRIP001 	{
//STRIP001 		case SID_EDIT_FRAMESET:
//STRIP001 		{
//STRIP001 			// Parameter auswerten
//STRIP001 			SFX_REQUEST_ARG(rReq, pShowItem, SfxBoolItem, nId, FALSE);
//STRIP001 			BOOL bShow = pShowItem ? pShowItem->GetValue() : !IsInEditMode();
//STRIP001 			if ( bShow )
//STRIP001 			{
//STRIP001 				if ( !StartEditing() )
//STRIP001 					// Editieren abgebrochen
//STRIP001 					return;
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				BOOL bEnd = EndEditing();
//STRIP001 				if ( !bEnd )
//STRIP001 					// Weiter editieren
//STRIP001 					return;
//STRIP001 
//STRIP001 				// Die Sourceview nur im EditMode
//STRIP001 				if ( pSourceView )
//STRIP001 					pSourceView->GetViewFrame()->GetFrame()->DoClose();
//STRIP001 
//STRIP001 				/*
//STRIP001 				if ( !bEnd )
//STRIP001 				{
//STRIP001 					// Dokument verwerfen
//STRIP001 					pViewFrame->GetDispatcher()->Execute(
//STRIP001 						SID_CLOSEWIN, SFX_CALLMODE_ASYNCHRON, (const SfxPoolItem*) 0L );
//STRIP001 					rReq.Done();
//STRIP001 					return;
//STRIP001 				}
//STRIP001 				*/
//STRIP001 			}
//STRIP001 
//STRIP001 			// Editmode umschalten; ist das Dokument tats"achlich editierbar ?
//STRIP001 			bEditMode = !bEditMode;
//STRIP001 			if ( bReadOnly )
//STRIP001 				bEditMode = FALSE;
//STRIP001 
//STRIP001 			// Wenn editiert werden kann, sind alle Splitter verschiebbar und
//STRIP001 			// die Dockingwindows k"onnen D&D
//STRIP001 			PrepareWindows( bEditMode );
//STRIP001 			rReq.Done();
//STRIP001 			UIFeatureChanged();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_SPLIT_HORIZONTAL:
//STRIP001 		case SID_SPLIT_VERTICAL:
//STRIP001 		case SID_SPLIT_PARENT_HORIZONTAL:
//STRIP001 		case SID_SPLIT_PARENT_VERTICAL:
//STRIP001 		{
//STRIP001             rReq.AppendItem( SfxStringItem( SID_FRAMETITLE, pModifiedFrame->GetFrameName() ) );
//STRIP001 			SfxFrame *pRet = Split( nItemId, nId );
//STRIP001 			if ( pRet )
//STRIP001 				rReq.SetReturnValue( SfxObjectItem( 0, pRet->GetCurrentViewFrame() ) );
//STRIP001 			rReq.Done();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_FRAMESPACING:
//STRIP001 		{
//STRIP001 			SFX_REQUEST_ARG( rReq, pItem, SfxUInt16Item, nId, FALSE);
//STRIP001 			if ( pItem )
//STRIP001 				SetFrameSpacing( (long) pItem->GetValue() );
//STRIP001 			else
//STRIP001 				SetFrameSpacing( SPACING_NOT_SET );
//STRIP001 			rReq.Done();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_FRAME_CONTENT:
//STRIP001 		{
//STRIP001             rReq.AppendItem( SfxStringItem( SID_FRAMETITLE, pModifiedFrame->GetFrameName() ) );
//STRIP001 			SFX_REQUEST_ARG( rReq, pItem, SfxStringItem, nId, FALSE);
//STRIP001 			if ( nItemId && pItem )
//STRIP001 			{
//STRIP001 				SetFrameContent( nItemId, pItem->GetValue() );
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_FRAME_NAME:
//STRIP001 		{
//STRIP001             rReq.AppendItem( SfxStringItem( SID_FRAMETITLE, pModifiedFrame->GetFrameName() ) );
//STRIP001 			SFX_REQUEST_ARG( rReq, pItem, SfxStringItem, nId, FALSE);
//STRIP001 			if ( nItemId && pItem )
//STRIP001 			{
//STRIP001 				SetFrameName( nItemId, pItem->GetValue() );
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_MODIFY_FRAME:
//STRIP001 		{
//STRIP001 			DBG_ERRORFILE( "obsolete" );
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_DELETE_FRAME:
//STRIP001 		{
//STRIP001             rReq.AppendItem( SfxStringItem( SID_FRAMETITLE, pModifiedFrame->GetFrameName() ) );
//STRIP001 			if ( nItemId )
//STRIP001 			{
//STRIP001 				DeleteFrame( nItemId );
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_SOURCEVIEW:
//STRIP001 		{
//STRIP001 			if ( pSourceView )
//STRIP001 			{
//STRIP001 				pSourceView->GetViewFrame()->GetDispatcher()->Execute(
//STRIP001 					SID_CLOSEWIN,
//STRIP001 					SFX_CALLMODE_SYNCHRON );
//STRIP001 				rReq.Done();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				{
//STRIP001                     SfxFrame* pFrame = SfxTopFrame::Create( GetViewFrame()->GetObjectShell(), 1 );
//STRIP001                     pSourceView = PTR_CAST( SfxFrameSetSourceView_Impl, pFrame->GetCurrentViewFrame()->GetViewShell() );
//STRIP001 
//STRIP001 					// Wir horchen an der Sourceview, um  mitzubekommen, wenn sie dicht
//STRIP001 					// gemacht wird
//STRIP001 					StartListening( *pSourceView );
//STRIP001 				}
//STRIP001 			}
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_NEWWINDOW:
//STRIP001 		{
//STRIP001 			break;
//STRIP001 		}
//STRIP001 
//STRIP001 		case SID_SAVEDOC:
//STRIP001 		case SID_SAVEASDOC:
//STRIP001 		{
//STRIP001 			// Wenn direkt nach dem Start des EditModes "Save" aufgerufen wird,
//STRIP001 			// m"u\sen auch durch Browsen hervorgerufene "Anderungen an das
//STRIP001 			// Dokument weitergegeben werden
//STRIP001 			SfxFrameSetObjectShell *pDoc =
//STRIP001 				PTR_CAST( SfxFrameSetObjectShell, GetViewFrame()->GetObjectShell() );
//STRIP001 			EndListening( *pDoc );
//STRIP001 			pDoc->TakeDescriptor( (SfxFrameSetDescriptor*)pDescriptor );
//STRIP001 			StartListening( *pDoc );
//STRIP001 			pDoc->ExecuteSlot( rReq );
//STRIP001 			rReq.Done();
//STRIP001 			break;
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 //------------------------------------------------------------------
//STRIP001 
//STRIP001 void SfxFrameSetView_Impl::State_Impl(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	const USHORT *pRanges = rSet.GetRanges();
//STRIP001 	DBG_ASSERT(pRanges, "Set ohne Bereich");
//STRIP001 
//STRIP001     if ( !GetWindow()  )
//STRIP001 	{
//STRIP001 		// Alle Anfragen gehen an das Top-Frameset
//STRIP001 		SfxFrameSetViewShell *pShell = this;
//STRIP001 		while ( !pShell->GetWindow() )
//STRIP001 			pShell = pShell->GetParentFrameSet();
//STRIP001 		SfxFrameSetView_Impl *pView = PTR_CAST( SfxFrameSetView_Impl, pShell );
//STRIP001 		if ( pView )
//STRIP001 			pView->State_Impl( rSet );
//STRIP001 		return;
//STRIP001 	}
//STRIP001 
//STRIP001 	USHORT nItemId = GetCurItemId();
//STRIP001 	SfxFrameDescriptor* pD = ((SfxFrameSetDescriptor*)GetDescriptor())->SearchFrame( nItemId );
//STRIP001 
//STRIP001 	BOOL bEditMode = IsInEditMode();
//STRIP001 	SfxObjectShell *pDoc = GetViewFrame()->GetObjectShell();
//STRIP001 	BOOL bReadOnly = pDoc->IsReadOnly();
//STRIP001 	if ( pDoc->IsReadOnly() )
//STRIP001 		bEditMode = FALSE;
//STRIP001 
//STRIP001 	while ( *pRanges )
//STRIP001 	{
//STRIP001 		for ( USHORT nWhich = *pRanges++; nWhich <= *pRanges; ++nWhich )
//STRIP001 		{
//STRIP001 			switch( nWhich )
//STRIP001 			{
//STRIP001 				case SID_FRAMESPACING:
//STRIP001 				{
//STRIP001 					if ( !bReadOnly )
//STRIP001 					{
//STRIP001 						if ( GetDescriptor()->IsFrameSpacingSet() )
//STRIP001 						{
//STRIP001 							rSet.Put( SfxUInt16Item( nWhich, (USHORT) GetDescriptor()->GetFrameSpacing() ) );
//STRIP001 						}
//STRIP001 					}
//STRIP001 					else
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				case  SID_SOURCEVIEW:
//STRIP001 				{
//STRIP001 					rSet.Put( SfxBoolItem( nWhich, ( pSourceView != NULL ) ) );
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				case SID_EDIT_FRAMESET:
//STRIP001 				{
//STRIP001 					SFX_ITEMSET_ARG(
//STRIP001 						pDoc->GetMedium()->GetItemSet(), pItem, SfxBoolItem,
//STRIP001 						SID_EDITDOC, FALSE );
//STRIP001 					if ( pItem && !pItem->GetValue() )
//STRIP001 						rSet.DisableItem( SID_EDIT_FRAMESET );
//STRIP001 					else
//STRIP001 						rSet.Put( SfxBoolItem( nWhich, IsInEditMode() ) );
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				case SID_MODIFY_FRAME:
//STRIP001 				case SID_DELETE_FRAME:
//STRIP001 				case SID_SPLIT_HORIZONTAL:
//STRIP001 				case SID_SPLIT_VERTICAL:
//STRIP001 				{
//STRIP001 					if ( !nItemId || !pD || bReadOnly )
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				case SID_SPLIT_PARENT_HORIZONTAL:
//STRIP001 				case SID_SPLIT_PARENT_VERTICAL:
//STRIP001 				{
//STRIP001 					if ( !nItemId || !pD || bReadOnly )
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 					else
//STRIP001 					{
//STRIP001 						// Parameter aufbereiten
//STRIP001 						BOOL bHorizontalSplit = ( nWhich == SID_SPLIT_PARENT_HORIZONTAL );
//STRIP001 						if ( !pD->CanSplit( bHorizontalSplit, TRUE ) )
//STRIP001 							rSet.DisableItem( nWhich );
//STRIP001 					}
//STRIP001 
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				case SID_SAVEDOC:
//STRIP001 				{
//STRIP001 					if ( !pDoc->IsModified() )
//STRIP001 						rSet.DisableItem( nWhich );
//STRIP001 					else
//STRIP001 						rSet.Put(SfxStringItem(SID_SAVEDOC,
//STRIP001 							String(SfxResId(STR_SAVE_FRAMESET))));
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				case SID_SAVEASDOC:
//STRIP001 				{
//STRIP001 					rSet.Put(SfxStringItem(SID_SAVEASDOC,
//STRIP001 							String(SfxResId(STR_SAVE_FRAMESETAS))));
//STRIP001 					break;
//STRIP001 				}
//STRIP001 
//STRIP001 				case SID_FRAME_NAME:
//STRIP001 				case SID_FRAME_CONTENT:
//STRIP001 				{
//STRIP001 					if ( !bReadOnly && pD )
//STRIP001 					{
//STRIP001 						if ( nWhich == SID_FRAME_NAME )
//STRIP001 							rSet.Put( SfxStringItem( nWhich, pD->GetName() ) );
//STRIP001 						else
//STRIP001 							rSet.Put( SfxStringItem( nWhich,
//STRIP001 								pD->GetActualURL().GetMainURL( INetURLObject::NO_DECODE ) ) );
//STRIP001 					}
//STRIP001 					else
//STRIP001 						rSet.Put( SfxStringItem( nWhich, String() ) );
//STRIP001 					break;
//STRIP001 				}
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 DBG_NAME(SfxFrameSetSourceView_Impl)
//STRIP001 
//STRIP001 #define SfxFrameSetSourceView_Impl
//STRIP001 #include <sfxslots.hxx>
//STRIP001 
//STRIP001 //=========================================================================
//STRIP001 
//STRIP001 TYPEINIT1(SfxFrameSetSourceView_Impl, SfxViewShell);
//STRIP001 
//STRIP001 SFX_IMPL_INTERFACE( SfxFrameSetSourceView_Impl, SfxViewShell, SfxResId( 0 ) )
//STRIP001 {
//STRIP001 	SFX_OBJECTBAR_REGISTRATION(
//STRIP001 			SFX_OBJECTBAR_OBJECT |
//STRIP001 			SFX_VISIBILITY_DESKTOP | SFX_VISIBILITY_STANDARD ,
//STRIP001 			SfxResId(RID_FRAMESETEDIT_TOOLBOX) );
//STRIP001 }
//STRIP001 
//STRIP001 SFX_IMPL_VIEWFACTORY( SfxFrameSetSourceView_Impl, SfxResId( STR_FRAMESETVIEW ) )
//STRIP001 {
//STRIP001 	SFX_VIEW_REGISTRATION( SfxFrameSetObjectShell );
//STRIP001 }
//STRIP001 
//STRIP001 SfxFrameSetSourceView_Impl::SfxFrameSetSourceView_Impl( SfxViewFrame *pFrame,
//STRIP001 		const SfxFrameSetSourceView_Impl& rWin )
//STRIP001 	: SfxViewShell( pFrame, SFX_VIEW_MAXIMIZE_FIRST )
//STRIP001 	, bEditMode( FALSE )
//STRIP001 {
//STRIP001 	DBG_CTOR( SfxFrameSetSourceView_Impl, 0 );
//STRIP001 	SetName( DEFINE_CONST_UNICODE( "FrameSetSourceView" ) );
//STRIP001 	MultiLineEdit *pEdit = new MultiLineEdit( &pFrame->GetWindow(), WB_HSCROLL | WB_VSCROLL );
//STRIP001 	SetWindow( pEdit );
//STRIP001 	pEdit->SetText( ((SfxFrameSetObjectShell*)pFrame->GetObjectShell())->GetSource() );
//STRIP001 	StartListening( *pFrame->GetObjectShell() );
//STRIP001 	pEdit->SetModifyHdl( LINK ( this, SfxFrameSetSourceView_Impl, ChangeHdl ) );
//STRIP001 	pEdit->SetReadOnly( GetObjectShell()->IsReadOnly() );
//STRIP001 	StartListening( *pFrame );
//STRIP001 	SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 	GetWindow()->SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 }
//STRIP001 
//STRIP001 SfxFrameSetSourceView_Impl::SfxFrameSetSourceView_Impl( SfxViewFrame *pFrame,
//STRIP001 		SfxViewShell* pShell)
//STRIP001 	: SfxViewShell( pFrame, SFX_VIEW_MAXIMIZE_FIRST )
//STRIP001 	, bEditMode( FALSE )
//STRIP001 {
//STRIP001 	DBG_CTOR( SfxFrameSetSourceView_Impl, 0 );
//STRIP001 	SetName( DEFINE_CONST_UNICODE( "FrameSetSourceView" ) );
//STRIP001 	MultiLineEdit *pEdit = new MultiLineEdit( &pFrame->GetWindow(), WB_HSCROLL | WB_VSCROLL );
//STRIP001 	SetWindow( pEdit );
//STRIP001 	pEdit->SetText( ((SfxFrameSetObjectShell*)pFrame->GetObjectShell())->GetSource() );
//STRIP001 	StartListening( *pFrame->GetObjectShell() );
//STRIP001 	pEdit->SetModifyHdl( LINK ( this, SfxFrameSetSourceView_Impl, ChangeHdl ) );
//STRIP001 	pEdit->SetReadOnly( GetObjectShell()->IsReadOnly() );
//STRIP001 	StartListening( *pFrame );
//STRIP001 	SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 	GetWindow()->SetHelpId( _GetInterfaceIdImpl() );
//STRIP001 }
//STRIP001 
//STRIP001 SfxFrameSetSourceView_Impl::~SfxFrameSetSourceView_Impl()
//STRIP001 {
//STRIP001 	DBG_DTOR( SfxFrameSetSourceView_Impl, 0 );
//STRIP001 	Broadcast( SfxSimpleHint(SFX_HINT_DYING) );
//STRIP001 	EndListening( *GetViewFrame() );
//STRIP001 	delete GetWindow();
//STRIP001 	SetWindow( 0 );
//STRIP001 }
//STRIP001 
//STRIP001 void SfxFrameSetSourceView_Impl::Execute_Impl(SfxRequest& rReq)
//STRIP001 {
//STRIP001 	if ( rReq.GetSlot() == SID_MODIFY_FRAME )
//STRIP001 	{
//STRIP001 		((SfxFrameSetObjectShell*)GetViewFrame()->GetObjectShell())->
//STRIP001 			TakeSource( GetWindow()->GetText() );
//STRIP001 		bEditMode = FALSE;
//STRIP001 	}
//STRIP001 	else if ( rReq.GetSlot() == SID_SOURCEVIEW )
//STRIP001 	{
//STRIP001         GetViewFrame()->GetDispatcher()->Execute( SID_CLOSEWIN, SFX_CALLMODE_SYNCHRON );
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 void SfxFrameSetSourceView_Impl::State_Impl(SfxItemSet& rSet)
//STRIP001 {
//STRIP001 	if ( !bEditMode )
//STRIP001 		rSet.DisableItem( SID_MODIFY_FRAME );
//STRIP001 	rSet.Put( SfxBoolItem( SID_SOURCEVIEW, TRUE ) );
//STRIP001 }
//STRIP001 
//STRIP001 void SfxFrameSetSourceView_Impl::SFX_NOTIFY( SfxBroadcaster& rBC,
//STRIP001 									const TypeId& rBCType,
//STRIP001 									const SfxHint& rHint,
//STRIP001 									const TypeId& rHintType )
//STRIP001 /* [Beschreibung]
//STRIP001  */
//STRIP001 {
//STRIP001 	if ( rHint.IsA(TYPE(SfxSimpleHint)) && (
//STRIP001 		&rBC == GetViewFrame()->GetObjectShell() ||
//STRIP001 		&rBC == GetViewFrame() ) )
//STRIP001 	{
//STRIP001 		SfxFrameSetObjectShell *pDoc =
//STRIP001 			((SfxFrameSetObjectShell*)GetViewFrame()->GetObjectShell());
//STRIP001 		switch( ( (SfxSimpleHint&) rHint ).GetId() )
//STRIP001 		{
//STRIP001 			// Wir horchen nur an FrameSetDocuments
//STRIP001 			case SFX_HINT_DOCCHANGED:
//STRIP001 			{
//STRIP001 				GetWindow()->SetText( pDoc->GetSource() );
//STRIP001 				bEditMode = FALSE;
//STRIP001 				break;
//STRIP001 			}
//STRIP001 			case SFX_HINT_TITLECHANGED:
//STRIP001 			case SFX_HINT_MODECHANGED:
//STRIP001 			{
//STRIP001 				((MultiLineEdit*)GetWindow())->SetReadOnly( pDoc->IsReadOnly() );
//STRIP001 				break;
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 }
//STRIP001 
//STRIP001 IMPL_LINK( SfxFrameSetSourceView_Impl, ChangeHdl, Control*, pC )
//STRIP001 {
//STRIP001 	bEditMode = TRUE;
//STRIP001 	GetViewFrame()->GetBindings().Invalidate( SID_MODIFY_FRAME );
//STRIP001 	return 0;
//STRIP001 }
//STRIP001 
//STRIP001 
//STRIP001 USHORT SfxFrameSetSourceView_Impl::PrepareClose( BOOL bUI, BOOL bForBrowsing )
//STRIP001 {
//STRIP001 	if ( SfxViewShell::PrepareClose( bUI, bForBrowsing ) == TRUE )
//STRIP001 	{
//STRIP001 		if ( bEditMode )
//STRIP001 		{
//STRIP001 			USHORT nRet = QueryBox( GetWindow(), WB_YES_NO_CANCEL | WB_DEF_YES,
//STRIP001 				String( SfxResId( STR_SOURCEMODIFIED ) ) ).Execute();
//STRIP001 			switch ( nRet )
//STRIP001 			{
//STRIP001 				case RET_YES:
//STRIP001 					((SfxFrameSetObjectShell*)GetViewFrame()->GetObjectShell())->
//STRIP001 						TakeSource( GetWindow()->GetText() );
//STRIP001 					return TRUE;
//STRIP001 				case RET_NO:
//STRIP001 					return TRUE;
//STRIP001 				default:
//STRIP001 					return FALSE;
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 			return TRUE;
//STRIP001 	}
//STRIP001 	else
//STRIP001 		return FALSE;
//STRIP001 }
//STRIP001 
//STRIP001 void SfxFrameSetView_Impl::PrepareWindows( BOOL bEditMode, USHORT nSet )
//STRIP001 {
//STRIP001 	// Den Descriptor f"ur das Frameset holen
//STRIP001 	const SfxFrameSetDescriptor *pSet = GetDescriptor();
//STRIP001 	if ( nSet )
//STRIP001 		pSet = ((SfxFrameSetDescriptor*)pSet)->SearchFrame( nSet )->GetFrameSet();
//STRIP001 
//STRIP001 	// Alle Items darin richtig setzen
//STRIP001 	SplitWindow *pWindow = GetSplitWindow();
//STRIP001 	for ( USHORT nPos=0; nPos<pWindow->GetItemCount( nSet ); nPos++ )
//STRIP001 	{
//STRIP001 		// Den FrameDescriptor f"ur das Item holen
//STRIP001 		USHORT nId = pWindow->GetItemId( nPos, nSet );
//STRIP001 		SfxFrameDescriptor *pD = ((SfxFrameSetDescriptor*)pSet)->SearchFrame( nId );
//STRIP001 
//STRIP001 		// Im EditMode SWIB_FIXED ausschalten
//STRIP001 		SplitWindowItemBits nBits = pD->GetWinBits();
//STRIP001 		if ( bEditMode )
//STRIP001 			nBits = nBits & ~SWIB_FIXED;
//STRIP001 		pWindow->SetItemBits( nId, nBits );
//STRIP001 
//STRIP001 		// Im EditMode geht D&D "uber die DockingWindows, nicht "uber die
//STRIP001 		// darin liegenden Dokumente
//STRIP001 		DockingWindow *pDock = (DockingWindow*)pWindow->GetItemWindow( nId );
//STRIP001 		if ( pDock )
//STRIP001 		{
//STRIP001 			pDock->EnableDrop( bEditMode );
//STRIP001 			pDock->Invalidate();
//STRIP001 		}
//STRIP001 		else if ( !pD->GetFrameSet()->IsRootFrameSet() )
//STRIP001 		{
//STRIP001 			PrepareWindows( bEditMode, nId );
//STRIP001 		}
//STRIP001 	}
//STRIP001 }


}
