/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: galbrws2.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 05:51:41 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_GALBRWS2_HXX_
#define _SVX_GALBRWS2_HXX_

// auto strip #include <vcl/lstbox.hxx>
// auto strip #include <vcl/button.hxx>
// auto strip #include <vcl/fixed.hxx>
// auto strip #include <vcl/timer.hxx>
// auto strip #include <vcl/toolbox.hxx>
// auto strip #include <svtools/transfer.hxx>
// auto strip #include <svtools/lstner.hxx>
// auto strip #include "galbrws.hxx"
class Menu;
namespace binfilter {

// ----------------------
// - GalleryBrowserMode -
// ----------------------

enum GalleryBrowserMode
{
    GALLERYBROWSERMODE_NONE = 0,
    GALLERYBROWSERMODE_ICON = 1,
    GALLERYBROWSERMODE_LIST = 2,
    GALLERYBROWSERMODE_PREVIEW = 3
};

// -----------------
// - GalleryTravel -
// -----------------

enum GalleryBrowserTravel
{
    GALLERYBROWSERTRAVEL_CURRENT = 0,
    GALLERYBROWSERTRAVEL_FIRST = 1,
    GALLERYBROWSERTRAVEL_LAST = 2,
    GALLERYBROWSERTRAVEL_PREVIOUS = 3,
    GALLERYBROWSERTRAVEL_NEXT = 4
};

// ------------------------
// - GalleryItemTextFlags -
// ------------------------

#define GALLERY_ITEM_THEMENAME  0x00000001
#define GALLERY_ITEM_TITLE      0x00000002
#define GALLERY_ITEM_PATH       0x00000004

// ------------------
// - GalleryToolBox -
// ------------------

//STRIP001 class GalleryToolBox : public ToolBox
//STRIP001 {
//STRIP001 private:
//STRIP001 
//STRIP001     virtual void    KeyInput( const KeyEvent& rKEvt );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001                     GalleryToolBox( GalleryBrowser2* pParent );
//STRIP001                     ~GalleryToolBox();
//STRIP001 };

// -------------------
// - GalleryBrowser2 -
// -------------------

class Gallery;
class GalleryTheme;
class GalleryIconView;
class GalleryListView;
class GalleryPreview;
class SgaObject;

//STRIP001 class GalleryBrowser2 : public Control, public SfxListener
//STRIP001 {
//STRIP001 	friend class GalleryBrowser;
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001 	Gallery*			mpGallery;
//STRIP001 	GalleryTheme*		mpCurTheme;
//STRIP001 	GalleryIconView*	mpIconView;
//STRIP001 	GalleryListView*	mpListView;
//STRIP001 	GalleryPreview*		mpPreview;
//STRIP001     GalleryToolBox      maViewBox;
//STRIP001     FixedLine           maSeparator;
//STRIP001 	FixedText			maInfoBar;
//STRIP001 	Point				maDragStartPos;
//STRIP001 	ULONG				mnCurActionPos;
//STRIP001     GalleryBrowserMode  meMode;
//STRIP001     GalleryBrowserMode  meLastMode;
//STRIP001 	BOOL				mbCurActionIsLinkage;
//STRIP001 
//STRIP001     void                InitSettings();
//STRIP001 
//STRIP001 	void				ImplUpdateViews( USHORT nSelectionId );
//STRIP001 	void				ImplUpdateInfoBar();
//STRIP001     ULONG               ImplGetSelectedItemId( const Point* pSelPosPixel, Point& rSelPos );
//STRIP001     void                ImplSelectItemId( ULONG nItemId );
//STRIP001     void                ImplExecute( USHORT nId );
//STRIP001 
//STRIP001 	// Control
//STRIP001 	virtual void		Resize();
//STRIP001     virtual void        DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 
//STRIP001 	// SfxListener
//STRIP001 	virtual void		Notify( SfxBroadcaster& rBC, const SfxHint& rHint );
//STRIP001 
//STRIP001 						DECL_LINK( MenuSelectHdl, Menu* pMenu );
//STRIP001 						DECL_LINK( SelectObjectHdl, void* );
//STRIP001 						DECL_LINK( SelectTbxHdl, ToolBox* );
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001     static GalleryBrowserMode meInitMode;
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	static String		GetItemText( const GalleryTheme& rTheme, const SgaObject& rObj, ULONG nItemTextFlags );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 						GalleryBrowser2( GalleryBrowser* pParent, const ResId& rResId, Gallery* pGallery );
//STRIP001 						~GalleryBrowser2();
//STRIP001 
//STRIP001 	void				SelectTheme( const String& rThemeName );
//STRIP001     
//STRIP001     GalleryBrowserMode  GetMode() const { return meMode; }
//STRIP001     void                SetMode( GalleryBrowserMode eMode );
//STRIP001 
//STRIP001     Window*             GetViewWindow() const;
//STRIP001 
//STRIP001     void                Travel( GalleryBrowserTravel eTravel );
//STRIP001 
//STRIP001 	INetURLObject		GetURL() const;
//STRIP001 	String				GetFilterName() const;
//STRIP001 	Graphic				GetGraphic() const;
//STRIP001 	BOOL				GetVCDrawModel( FmFormModel& rModel ) const;
//STRIP001 	BOOL				IsLinkage() const;
//STRIP001 
//STRIP001 	sal_Int8			AcceptDrop( DropTargetHelper& rTarget, const AcceptDropEvent& rEvt );
//STRIP001 	sal_Int8			ExecuteDrop( DropTargetHelper& rTarget, const ExecuteDropEvent& rEvt );
//STRIP001     void                StartDrag( Window* pWindow, const Point* pDragPoint = NULL );
//STRIP001     void                TogglePreview( Window* pWindow, const Point* pPreviewPoint = NULL );
//STRIP001     void                ShowContextMenu( Window* pWindow, const Point* pContextPoint = NULL );
//STRIP001     BOOL                KeyInput( const KeyEvent& rEvt, Window* pWindow );
//STRIP001 };

}//end of namespace binfilter
#endif
