/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: galtheme.hxx,v $
 *
 *  $Revision: 1.4 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 05:53:35 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_GALTHEME_HXX_
#define _SVX_GALTHEME_HXX_

#define ENABLE_BYTESTRING_STREAM_OPERATORS

// auto strip #include <tools/debug.hxx>
#include <tools/urlobj.hxx>
#include <vcl/salctype.hxx>
// auto strip #include <svtools/brdcst.hxx>
// auto strip #include <svtools/lstner.hxx>
// auto strip #include <svtools/transfer.hxx>
// auto strip #include <so3/svstor.hxx>
#include "galobj.hxx"
// auto strip #include "galmisc.hxx"
// auto strip #include "gallery1.hxx"
namespace binfilter {

// -----------------
// - GalleryObject -
// -----------------

struct GalleryObject
{
	INetURLObject	aURL;
	sal_uInt32		nOffset;
	SgaObjKind		eObjKind;
	BOOL			bDummy;
};

DECLARE_LIST( GalleryObjectList, GalleryObject* )//STRIP008 DECLARE_LIST( GalleryObjectList, GalleryObject* );

// -----------------
// - GalDragParams -
// -----------------

struct GalDragParams
{
	Region		aDragRegion;
	ULONG		nDragObjPos;
	String		aThemeName;
	String		aFileName;
	SgaObjKind	eObjKind;
};

// ----------------
// - GalleryTheme -
// ----------------

class Gallery;
class GalleryProgress;

//STRIP001 class GalleryTheme : public SfxBroadcaster
//STRIP001 {
//STRIP001 	friend class Gallery;
//STRIP001 	friend class GalleryThemeCacheEntry;
//STRIP001 
//STRIP001 private:
//STRIP001 
//STRIP001 	GalleryObjectList			aObjectList;
//STRIP001 	String						aImportName;
//STRIP001 	SvStorageRef				aSvDrawStorageRef;
//STRIP001 	Gallery*					pParent;
//STRIP001 	GalleryThemeEntry*			pThm;
//STRIP001 	ULONG						mnLockCount;
//STRIP001 	ULONG						nDragPos;
//STRIP001 	BOOL						bDragging;
//STRIP001 	BOOL						bAbortActualize;
//STRIP001 
//STRIP001 	void						ImplCreateSvDrawStorage();
//STRIP001 	SgaObject*					ImplReadSgaObject( GalleryObject* pEntry );
//STRIP001 	BOOL						ImplWriteSgaObject( const SgaObject& rObj, ULONG nPos, GalleryObject* pExistentEntry );
//STRIP001 	void						ImplRead();
//STRIP001 	void						ImplWrite();
//STRIP001 	const GalleryObject*		ImplGetGalleryObject( ULONG nPos ) const { return aObjectList.GetObject( nPos ); }
//STRIP001 	INetURLObject				ImplGetURL( const GalleryObject* pObject ) const;
//STRIP001     INetURLObject               ImplCreateUniqueURL( SgaObjKind eObjKind, ULONG nFormat = CVT_UNKNOWN );
//STRIP001 	void						ImplSetModified( BOOL bModified ) { pThm->SetModified( bModified ); }
//STRIP001 	void						ImplBroadcast( ULONG nUpdatePos );
//STRIP001 
//STRIP001 								GalleryTheme();
//STRIP001 								GalleryTheme( Gallery* pGallery, GalleryThemeEntry* pThemeEntry );
//STRIP001 								~GalleryTheme();
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	static GalleryThemeEntry*	CreateThemeEntry( const INetURLObject& rURL, BOOL bReadOnly );
//STRIP001 	
//STRIP001 	const ULONG					GetObjectCount() const { return aObjectList.Count(); }
//STRIP001 
//STRIP001 	SgaObject*					AcquireObject( ULONG nPos );
//STRIP001 	void						ReleaseObject( SgaObject* pObj );
//STRIP001 
//STRIP001 	BOOL						InsertObject( const SgaObject& rObj, ULONG nPos = LIST_APPEND );
//STRIP001 	BOOL						RemoveObject( ULONG nPos );
//STRIP001 	BOOL						ChangeObjectPos( ULONG nOldPos, ULONG nNewPos );
//STRIP001 
//STRIP001 	const String&				GetName() const	{ return IsImported() ? aImportName : pThm->GetThemeName(); }
//STRIP001 	const String&				GetRealName() const { return pThm->GetThemeName(); }
//STRIP001 	const String&				GetImportName() const { return aImportName; }
//STRIP001 	void						SetImportName(const String& rImportName) { aImportName = rImportName; }
//STRIP001 
//STRIP001 	const INetURLObject&		GetThmURL() const { return pThm->GetThmURL(); }
//STRIP001 	const INetURLObject&		GetSdgURL() const { return pThm->GetSdgURL(); }
//STRIP001 	const INetURLObject&		GetSdvURL() const { return pThm->GetSdvURL(); }
//STRIP001 
//STRIP001 	UINT32						GetId() const { return pThm->GetId(); }
//STRIP001 	void						SetId( UINT32 nNewId, BOOL bResetThemeName ) { pThm->SetId( nNewId, bResetThemeName ); }
//STRIP001 
//STRIP001 	void						SetDragging( BOOL bSet ) { bDragging = bSet; }
//STRIP001 	BOOL						IsDragging() const { return bDragging; }
//STRIP001 
//STRIP001 	void						LockBroadcaster() { mnLockCount++; }
//STRIP001 	void						UnlockBroadcaster( ULONG nUpdatePos = 0 );
//STRIP001 	BOOL						IsBroadcasterLocked() const { return mnLockCount > 0; }
//STRIP001 
//STRIP001 	void						SetDragPos( ULONG nPos ) { nDragPos = nPos; }
//STRIP001 	ULONG						GetDragPos() const { return nDragPos; }
//STRIP001 
//STRIP001 	BOOL						IsThemeNameFromResource() const { return pThm->IsNameFromResource(); }
//STRIP001 
//STRIP001 	BOOL						IsImported() const { return pThm->IsImported(); }
//STRIP001 	BOOL						IsReadOnly() const { return pThm->IsReadOnly(); }
//STRIP001 	BOOL						IsDefault() const { return pThm->IsDefault(); }
//STRIP001 	BOOL						IsModified() const { return pThm->IsModified(); }
//STRIP001 
//STRIP001 	void						Actualize( const Link& rActualizeLink, GalleryProgress* pProgress = NULL );
//STRIP001 	void						AbortActualize() { bAbortActualize = TRUE; }
//STRIP001 
//STRIP001 	Gallery*					GetParent() const { return pParent; }
//STRIP001 	SvStorageRef				GetSvDrawStorage() const { return aSvDrawStorageRef; }
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	SgaObjKind					GetObjectKind( ULONG nPos ) const 
//STRIP001 								{
//STRIP001 									DBG_ASSERT( nPos < GetObjectCount(), "Position out of range" );
//STRIP001 									return ImplGetGalleryObject( nPos )->eObjKind; 
//STRIP001 								}
//STRIP001 
//STRIP001 
//STRIP001 	const INetURLObject&		GetObjectURL( ULONG nPos ) const 
//STRIP001 								{
//STRIP001 									DBG_ASSERT( nPos < GetObjectCount(), "Position out of range" );
//STRIP001 									return ImplGetGalleryObject( nPos )->aURL; 
//STRIP001 								}
//STRIP001 	
//STRIP001 	BOOL						GetThumb( ULONG nPos, Bitmap& rBmp, BOOL bProgress = FALSE );
//STRIP001 
//STRIP001 	BOOL						GetGraphic( ULONG nPos, Graphic& rGraphic, BOOL bProgress = FALSE );
//STRIP001 	BOOL						InsertGraphic( const Graphic& rGraphic, ULONG nInsertPos = LIST_APPEND );
//STRIP001 	
//STRIP001 	BOOL						GetModel( ULONG nPos, FmFormModel& rModel, BOOL bProgress = FALSE );
//STRIP001 	BOOL						InsertModel( const FmFormModel& rModel, ULONG nInsertPos = LIST_APPEND );
//STRIP001 
//STRIP001 	BOOL						GetModelStream( ULONG nPos, SotStorageStreamRef& rModelStreamRef, BOOL bProgress = FALSE );
//STRIP001 	BOOL						InsertModelStream( const SotStorageStreamRef& rModelStream, ULONG nInsertPos = LIST_APPEND );
//STRIP001 
//STRIP001 	BOOL						GetURL( ULONG nPos, INetURLObject& rURL, BOOL bProgress = FALSE );
//STRIP001 	BOOL						InsertURL( const INetURLObject& rURL, ULONG nInsertPos = LIST_APPEND );
//STRIP001     BOOL                        InsertFileOrDirURL( const INetURLObject& rFileOrDirURL, ULONG nInsertPos = LIST_APPEND );
//STRIP001 
//STRIP001 	BOOL						InsertTransferable( const ::com::sun::star::uno::Reference< ::com::sun::star::datatransfer::XTransferable >& rxTransferable, ULONG nInsertPos );
//STRIP001 
//STRIP001 	void						CopyToClipboard( Window* pWindow, ULONG nPos );
//STRIP001 	void						StartDrag( Window* pWindow, ULONG nPos );
//STRIP001 
//STRIP001 public:
//STRIP001 
//STRIP001 	SvStream&					WriteData( SvStream& rOut ) const;
//STRIP001 	SvStream&					ReadData( SvStream& rIn );
//STRIP001 };

//STRIP001 SvStream& operator<<( SvStream& rOut, const GalleryTheme& rTheme );
//STRIP001 SvStream& operator>>( SvStream& rIn, GalleryTheme& rTheme );

}//end of namespace binfilter
#endif
