/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sw_docglos.cxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/08 08:37:04 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/


#pragma hdrstop

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif
#ifndef _ERRHDL_HXX
#include <errhdl.hxx>
#endif

#ifndef _DOC_HXX
#include <doc.hxx>
#endif
// auto strip #ifndef _SHELLIO_HXX
// auto strip #include <shellio.hxx>
// auto strip #endif
// auto strip #ifndef _PAM_HXX
// auto strip #include <pam.hxx>
// auto strip #endif
// auto strip #ifndef _SWUNDO_HXX
// auto strip #include <swundo.hxx>
// auto strip #endif
// auto strip #ifndef _NDTXT_HXX
// auto strip #include <ndtxt.hxx>
// auto strip #endif
// auto strip #ifndef _ACORRECT_HXX
// auto strip #include <acorrect.hxx>
// auto strip #endif
// auto strip #ifndef _CRSRSH_HXX
// auto strip #include <crsrsh.hxx>
// auto strip #endif
namespace binfilter {

/* -----------------22.07.99 11:47-------------------
	Description: inserts an AutoText block
 --------------------------------------------------*/
/*N*/ BOOL SwDoc::InsertGlossary( SwTextBlocks& rBlock, const String& rEntry,
/*N*/ 							SwPaM& rPaM, SwCrsrShell* pShell )
/*N*/ {
/*?*/ 	DBG_BF_ASSERT(0, "STRIP"); return FALSE;//STRIP001 BOOL bRet = FALSE;
//STRIP001 /*?*/ 	USHORT nIdx = rBlock.GetIndex( rEntry );
//STRIP001 /*?*/ 	if( (USHORT) -1 != nIdx )
//STRIP001 /*?*/ 	{
//STRIP001 /*?*/ 		// Bug #70238# ask the TextOnly-Flag before BeginGetDoc, because
//STRIP001 /*?*/ 		//				the method closed the Storage!
//STRIP001 /*?*/ 		BOOL bSav_IsInsGlossary = bInsOnlyTxtGlssry;
//STRIP001 /*?*/ 		bInsOnlyTxtGlssry = rBlock.IsOnlyTextBlock( nIdx );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 		if( rBlock.BeginGetDoc( nIdx ) )
//STRIP001 /*?*/ 		{
//STRIP001 /*?*/ 			SwDoc* pGDoc = rBlock.GetDoc();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			// alle FixFelder aktualisieren. Dann aber auch mit der
//STRIP001 /*?*/ 			// richtigen DocInfo!
//STRIP001 /*?*/ 			pGDoc->SetInfo( *GetInfo() );
//STRIP001 /*?*/ 			pGDoc->SetFixFields();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			//StartAllAction();
//STRIP001 /*?*/ 			LockExpFlds();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			SwNodeIndex aStt( pGDoc->GetNodes().GetEndOfExtras(), 1 );
//STRIP001 /*?*/ 			SwCntntNode* pCntntNd = pGDoc->GetNodes().GoNext( &aStt );
//STRIP001 /*?*/ 			const SwTableNode* pTblNd = pCntntNd->FindTableNode();
//STRIP001 /*?*/ 			SwPaM aCpyPam( pTblNd ? *(SwNode*)pTblNd : *(SwNode*)pCntntNd );
//STRIP001 /*?*/ 			aCpyPam.SetMark();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			// dann bis zum Ende vom Nodes Array
//STRIP001 /*?*/ 			aCpyPam.GetPoint()->nNode = pGDoc->GetNodes().GetEndOfContent().GetIndex()-1;
//STRIP001 /*?*/ 			pCntntNd = aCpyPam.GetCntntNode();
//STRIP001 /*?*/ 			aCpyPam.GetPoint()->nContent.Assign( pCntntNd, pCntntNd->Len() );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				// steht nur eine Tabelle im Autotext? Dann kopiere ggfs.
//STRIP001 /*?*/ 				// Tabelle in Tabelle
//STRIP001 /*?*/ 			BOOL bChkTblInTbl = pTblNd &&
//STRIP001 /*?*/ 								!aCpyPam.GetPoint()->nContent.GetIndex() &&
//STRIP001 /*?*/ 								pTblNd->EndOfSectionIndex() + 1 ==
//STRIP001 /*?*/ 								aCpyPam.GetPoint()->nNode.GetIndex();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			StartUndo( UNDO_INSGLOSSARY );
//STRIP001 /*?*/ 			SwPaM *_pStartCrsr = &rPaM, *__pStartCrsr = _pStartCrsr;
//STRIP001 /*?*/ 			do {
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				const SwTxtNode* pTNd;
//STRIP001 /*?*/ 				SwPosition& rInsPos = *_pStartCrsr->GetPoint();
//STRIP001 /*?*/ 				SwStartNode* pBoxSttNd = (SwStartNode*)rInsPos.nNode.GetNode().
//STRIP001 /*?*/ 											FindTableBoxStartNode();
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 				// nur wenn die Box keinen Inhalt hat
//STRIP001 /*?*/ 				if( bChkTblInTbl && pBoxSttNd &&
//STRIP001 /*?*/ 					2 == pBoxSttNd->EndOfSectionIndex() - pBoxSttNd->GetIndex()
//STRIP001 /*?*/ 					&& 0 != ( pTNd = GetNodes()[ pBoxSttNd->GetIndex() + 1]
//STRIP001 /*?*/ 						->GetTxtNode() ) && !pTNd->GetTxt().Len() )
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					CopyTblInTbl( pTblNd->GetTable(),
//STRIP001 /*?*/ 										pBoxSttNd->FindTableNode()->GetTable(),
//STRIP001 /*?*/ 										SwNodeIndex( *pBoxSttNd ));
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 				else
//STRIP001 /*?*/ 				{
//STRIP001 /*?*/ 					if( pBoxSttNd && 2 == pBoxSttNd->EndOfSectionIndex() -
//STRIP001 /*?*/ 										  pBoxSttNd->GetIndex() &&
//STRIP001 /*?*/ 						aCpyPam.GetPoint()->nNode != aCpyPam.GetMark()->nNode )
//STRIP001 /*?*/ 					{
//STRIP001 /*?*/ 						// es wird mehr als 1 Node in die akt. Box kopiert.
//STRIP001 /*?*/ 						// Dann muessen die BoxAttribute aber entfernt werden.
//STRIP001 /*?*/ 						ClearBoxNumAttrs( rInsPos.nNode );
//STRIP001 /*?*/ 					}
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					SwDontExpandItem aACD;
//STRIP001 /*?*/ 					aACD.SaveDontExpandItems( rInsPos );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					pGDoc->Copy( aCpyPam, rInsPos );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 					aACD.RestoreDontExpandItems( rInsPos );
//STRIP001 /*?*/ 					if( pShell )
//STRIP001 /*?*/ 						pShell->SaveTblBoxCntnt( &rInsPos );
//STRIP001 /*?*/ 				}
//STRIP001 /*?*/ 			} while( (_pStartCrsr=(SwPaM *)_pStartCrsr->GetNext()) !=
//STRIP001 /*?*/ 						__pStartCrsr );
//STRIP001 /*?*/ 			EndUndo( UNDO_INSGLOSSARY );
//STRIP001 /*?*/ 
//STRIP001 /*?*/ 			UnlockExpFlds();
//STRIP001 /*?*/ 			if( !IsExpFldsLocked() )
//STRIP001 /*?*/ 				UpdateExpFlds();
//STRIP001 /*?*/ 			bRet = TRUE;
//STRIP001 /*?*/ 		}
//STRIP001 /*?*/ 		bInsOnlyTxtGlssry = bSav_IsInsGlossary;
//STRIP001 /*?*/ 	}
//STRIP001 /*?*/ 	rBlock.EndGetDoc();
//STRIP001 /*?*/ 	return bRet;
/*N*/ }


}
