/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: sw_navipi.cxx,v $
 *
 *  $Revision: 1.6 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 07:04:37 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/



#pragma hdrstop

#define NAVIPI_CXX

#include <string> // HACK: prevent conflict between STLPORT and Workshop headers

// auto strip #ifndef _LIST_HXX
// auto strip #include <tools/list.hxx>
// auto strip #endif
// auto strip #ifndef _URLBMK_HXX
// auto strip #include <svtools/urlbmk.hxx>
// auto strip #endif
// auto strip #ifndef _SFXSTRITEM_HXX
// auto strip #include <svtools/stritem.hxx>
// auto strip #endif
// auto strip #ifndef _FILTER_HXX
// auto strip #include <svtools/filter.hxx>
// auto strip #endif
// auto strip #ifndef SVTOOLS_URIHELPER_HXX
// auto strip #include <svtools/urihelper.hxx>
// auto strip #endif
// auto strip #ifndef _SOT_FORMATS_HXX
// auto strip #include <sot/formats.hxx>
// auto strip #endif
// auto strip #ifndef _FILELIST_HXX
// auto strip #include <sot/filelist.hxx>
// auto strip #endif
// auto strip #ifndef _SFXEVENT_HXX
// auto strip #include <bf_sfx2/event.hxx>
// auto strip #endif
// auto strip #ifndef _SFXIMGMGR_HXX
// auto strip #include <bf_sfx2/imgmgr.hxx>
// auto strip #endif
#ifndef _SFXDISPATCH_HXX
#include <bf_sfx2/dispatch.hxx>
#endif
// auto strip #ifndef _SFXDOCKWIN_HXX
// auto strip #include <bf_sfx2/dockwin.hxx>
// auto strip #endif
// auto strip #ifndef _SFXVIEWFRM_HXX
// auto strip #include <bf_sfx2/viewfrm.hxx>
// auto strip #endif

// auto strip #ifndef _SWTYPES_HXX
// auto strip #include <swtypes.hxx>	// fuer Pathfinder
// auto strip #endif
// auto strip #ifndef _ERRHDL_HXX
// auto strip #include <errhdl.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif
#ifndef _VIEW_HXX
#include <view.hxx>
#endif
// auto strip #ifndef _NAVICFG_HXX
// auto strip #include <navicfg.hxx>
// auto strip #endif

#ifndef _HORIORNT_HXX
#include <horiornt.hxx>
#endif

// auto strip #ifndef _WRTSH_HXX
// auto strip #include <wrtsh.hxx>
// auto strip #endif
// auto strip #ifndef _DOCSH_HXX
// auto strip #include <docsh.hxx>
// auto strip #endif
// auto strip #ifndef _SWMODULE_HXX
// auto strip #include <swmodule.hxx>
// auto strip #endif
// auto strip #ifndef _ACTCTRL_HXX
// auto strip #include <actctrl.hxx>
// auto strip #endif
// auto strip #ifndef _BOOKMRK_HXX
// auto strip #include <bookmrk.hxx>
// auto strip #endif
#ifndef _NAVIPI_HXX
#include <navipi.hxx>
#endif
// auto strip #ifndef _CONTENT_HXX
// auto strip #include <content.hxx>
// auto strip #endif
// auto strip #ifndef _WORKCTRL_HXX
// auto strip #include <workctrl.hxx>
// auto strip #endif
// auto strip #ifndef _SECTION_HXX
// auto strip #include <section.hxx>
// auto strip #endif
// auto strip #ifndef _EDTWIN_HXX
// auto strip #include <edtwin.hxx>
// auto strip #endif

#ifndef _CMDID_H
#include <cmdid.h>
#endif
#ifndef _HELPID_H
#include <helpid.h>
#endif
#ifndef _RIBBAR_HRC
#include <ribbar.hrc>
#endif
#ifndef _NAVIPI_HRC
#include <navipi.hrc>
#endif
#ifndef _UTLUI_HRC
#include <utlui.hrc>
#endif
#include "so3/staticbaseurl.hxx"
namespace binfilter {

#define C2S(cChar) UniString::CreateFromAscii(cChar)

static const sal_Unicode cPrefix = '_';

#define PAGE_CHANGE_TIMEOUT 1000 //Timeout fuer Seitenwechsel

#define JUMP_TYPE_TBL 0
#define JUMP_TYPE_FRM 1
#define JUMP_TYPE_GRF 2
#define JUMP_TYPE_REG 3
#define JUMP_TYPE_BKM 4

// Version fuer Konfiguration

#define NAVI_VERSION0	0
#define NAVI_VERSION1   1
#define NAVI_VERSION2   2 // bIsGlobalActive

#define NAVI_CONFIG_VERSION NAVI_VERSION2

/*N*/ SFX_IMPL_CHILDWINDOW_CONTEXT( SwNavigationChild, SID_NAVIGATOR, SwView )

/*------------------------------------------------------------------------
	Bechreibung: Steuerzeichen aus dem Outline-Entry filtern
------------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::CleanEntry( String& rEntry )
//STRIP001 {
//STRIP001 	USHORT i = rEntry.Len();
//STRIP001 	if( i )
//STRIP001 		for( sal_Unicode* pStr = rEntry.GetBufferAccess(); i; --i, ++pStr )
//STRIP001 			if( *pStr == 10 || *pStr == 9 )
//STRIP001 				*pStr = 0x20;
//STRIP001 }
/*------------------------------------------------------------------------
 Beschreibung:	Ausfuehrung der Drag-Operation
				mit und ohne Childs
------------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::MoveOutline(USHORT nSource, USHORT nTarget,
//STRIP001 													BOOL bWithChilds)
//STRIP001 {
//STRIP001     SwView *pView = GetCreateView();
//STRIP001 	SwWrtShell &rSh = pView->GetWrtShell();
//STRIP001 	if(nTarget < nSource || nTarget == USHRT_MAX)
//STRIP001 		nTarget ++;
//STRIP001 	if ( rSh.IsOutlineMovable( nSource ))
//STRIP001 	{
//STRIP001 
//STRIP001 		short nMove = nTarget-nSource; //( nDir<0 ) ? 1 : 0 ;
//STRIP001 		rSh.GotoOutline(nSource);
//STRIP001 		if (bWithChilds)
//STRIP001 			rSh.MakeOutlineSel(nSource, nSource, TRUE);
//STRIP001 		// Die selektierten Children zaehlen bei der Bewegung vorwaerts nicht mit
//STRIP001 		USHORT nLastOutlinePos = rSh.GetOutlinePos(MAXLEVEL);
//STRIP001 		if(bWithChilds && nMove > 1 &&
//STRIP001 				nLastOutlinePos < nTarget)
//STRIP001 		{
//STRIP001 			if(!rSh.IsCrsrPtAtEnd())
//STRIP001 				rSh.SwapPam();
//STRIP001 			nMove -= nLastOutlinePos - nSource;
//STRIP001 		}
//STRIP001 		if(!bWithChilds || nMove < 1 || nLastOutlinePos < nTarget )
//STRIP001 			rSh.MoveOutlinePara( nMove );
//STRIP001 		rSh.ClearMark();
//STRIP001 		rSh.GotoOutline( nSource + nMove);
//STRIP001 		FillBox();
//STRIP001 	}
//STRIP001 
//STRIP001 }
/*------------------------------------------------------------------------
 Beschreibung:	Erzeugen des automatischen Namens des unbenannten Merkers
------------------------------------------------------------------------*/

//STRIP001 inline String &MakeAutoName(String &rToChange, USHORT i)
//STRIP001 {
//STRIP001 	rToChange = cPrefix;
//STRIP001 	rToChange += String::CreateFromInt32( i );
//STRIP001 	return rToChange;
//STRIP001 }


/*------------------------------------------------------------------------
 Beschreibung:	Nach Goto einen Status Rahmenselektion aufheben
------------------------------------------------------------------------*/


//STRIP001 void lcl_UnSelectFrm(SwWrtShell *pSh)
//STRIP001 {
//STRIP001 	if (pSh->IsFrmSelected())
//STRIP001 	{
//STRIP001 		pSh->UnSelectFrm();
//STRIP001 		pSh->LeaveSelFrmMode();
//STRIP001 	}
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:	Select der Documentanzeige
------------------------------------------------------------------------*/


//STRIP001 IMPL_LINK( SwNavigationPI, DocListBoxSelectHdl, ListBox *, pBox )
//STRIP001 {
//STRIP001 	int nEntryIdx = pBox->GetSelectEntryPos();
//STRIP001 	SwView *pView ;
//STRIP001 	pView = SwModule::GetFirstView();
//STRIP001 	while (nEntryIdx-- && pView)
//STRIP001 	{
//STRIP001 		pView = SwModule::GetNextView(pView);
//STRIP001 	}
//STRIP001 	if(!pView)
//STRIP001 	{
//STRIP001 		nEntryIdx == 0 ?
//STRIP001 			aContentTree.ShowHiddenShell():
//STRIP001 				aContentTree.ShowActualView();
//STRIP001 
//STRIP001 
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aContentTree.SetConstantShell(pView->GetWrtShellPtr());
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }
/*------------------------------------------------------------------------
 Beschreibung:	Select der Typenlistbox
------------------------------------------------------------------------*/
/*

IMPL_LINK( SwNavigationPI, TypeListBoxSelectHdl, ListBox *, pBox )
{
	USHORT nEntryIdx = pBox->GetSelectEntryPos();
	USHORT nCount =  pBox->GetEntryCount();
	if(nEntryIdx == nCount - 1)
	{
		if(!bPageCtrlsVisible)
		{
			bPageCtrlsVisible = TRUE;
			aContentToolBox.ShowItem( FN_PAGENUMBER );
			aContentToolBox.HideItem( FN_UP );
			aContentToolBox.HideItem( FN_DOWN );
		}
	}
	else
	{
		if(bPageCtrlsVisible)
		{
			aContentToolBox.HideItem( FN_PAGENUMBER );
			aContentToolBox.ShowItem( FN_UP );
			aContentToolBox.ShowItem( FN_DOWN );
			bPageCtrlsVisible = FALSE;
		}
	}

	pConfig->SetSelectedPos( nEntryIdx );
	return 0;
}

/*------------------------------------------------------------------------
 Beschreibung:	Fuellen der ListBox fuer Outline Sicht oder Dokumente
				Der PI wird auf volle Groesse gesetzt
------------------------------------------------------------------------*/


//STRIP001 void SwNavigationPI::FillBox()
//STRIP001 {
//STRIP001 	if(pContentWrtShell)
//STRIP001 	{
//STRIP001 		aContentTree.SetHiddenShell( pContentWrtShell );
//STRIP001 		aContentTree.Display(  FALSE );
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001         SwView *pView = GetCreateView();
//STRIP001 		if(!pView)
//STRIP001 		{
//STRIP001 			aContentTree.SetActiveShell(0);
//STRIP001 		}
//STRIP001 		else if( pView != pActContView)
//STRIP001 		{
//STRIP001 			SwWrtShell* pWrtShell = pView->GetWrtShellPtr();
//STRIP001 			aContentTree.SetActiveShell(pWrtShell);
//STRIP001 		}
//STRIP001 		else
//STRIP001 			aContentTree.Display( TRUE );
//STRIP001 		pActContView = pView;
//STRIP001 	}
//STRIP001 }


//STRIP001 void SwNavigationPI::UsePage(SwWrtShell *pSh)
//STRIP001 {
//STRIP001 	if (!pSh)
//STRIP001 	{
//STRIP001         SwView *pView = GetCreateView();
//STRIP001 		pSh = pView ? &pView->GetWrtShell() : 0;
//STRIP001 		GetPageEdit().SetValue(1);
//STRIP001 	}
//STRIP001 	if (pSh)
//STRIP001 	{
//STRIP001 		const USHORT nPageCnt = pSh->GetPageCnt();
//STRIP001 		USHORT nPhyPage, nVirPage;
//STRIP001 		pSh->GetPageNum(nPhyPage, nVirPage);
//STRIP001 
//STRIP001 		GetPageEdit().SetMax(nPageCnt);
//STRIP001 		GetPageEdit().SetLast(nPageCnt);
//STRIP001 		GetPageEdit().SetValue(nPhyPage);
//STRIP001 	}
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:	SelectHandler der Toolboxen
------------------------------------------------------------------------*/


//STRIP001 IMPL_LINK( SwNavigationPI, ToolBoxSelectHdl, ToolBox *, pBox )
//STRIP001 {
//STRIP001 	const USHORT nId = pBox->GetCurItemId();
//STRIP001     SwView *pView = GetCreateView();
//STRIP001 	if (!pView)
//STRIP001 		return 1;
//STRIP001 	SwWrtShell &rSh = pView->GetWrtShell();
//STRIP001 	//MouseModifier fuer Outline-Move besorgen
//STRIP001 
//STRIP001 	//Standard: Unterebenen werden mitgenommen
//STRIP001 	// mit Ctrl Unterebenen nicht mitnehmen
//STRIP001 	BOOL bOutlineWithChilds  = ( KEY_MOD1 != pBox->GetModifier());
//STRIP001 	int nFuncId = 0;
//STRIP001     BOOL bFocusToDoc = FALSE;
//STRIP001 	switch (nId)
//STRIP001 	{
//STRIP001 		case FN_UP:
//STRIP001 		case FN_DOWN:
//STRIP001 			pView->MoveNavigation(FN_DOWN == nId);
//STRIP001 		break;
//STRIP001 		case FN_SHOW_ROOT:
//STRIP001 		{
//STRIP001 			aContentTree.ToggleToRoot();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_SHOW_CONTENT_BOX:
//STRIP001 		case FN_SELECT_CONTENT:
//STRIP001 		if(pContextWin->GetFloatingWindow())
//STRIP001 		{
//STRIP001 			if(_IsZoomedIn() )
//STRIP001 			{
//STRIP001 				_ZoomOut();
//STRIP001 			}
//STRIP001 			else
//STRIP001 			{
//STRIP001 				_ZoomIn();
//STRIP001 			}
//STRIP001 		}
//STRIP001 		return TRUE;
//STRIP001 		//break;
//STRIP001 		// Funktionen, die eine direkte Aktion ausloesen
//STRIP001 
//STRIP001 		case FN_SELECT_FOOTER:
//STRIP001 		{
//STRIP001 			rSh.MoveCrsr();
//STRIP001 			const USHORT eType = rSh.GetFrmType(0,FALSE);
//STRIP001 			if (eType & FRMTYPE_FOOTER)
//STRIP001 			{
//STRIP001 				if (rSh.EndPg())
//STRIP001 					nFuncId = FN_END_OF_PAGE;
//STRIP001 			}
//STRIP001 			else if (rSh.GotoFooterTxt())
//STRIP001 				nFuncId = FN_TO_FOOTER;
//STRIP001             bFocusToDoc = TRUE;
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_SELECT_HEADER:
//STRIP001 		{
//STRIP001 			rSh.MoveCrsr();
//STRIP001 			const USHORT eType = rSh.GetFrmType(0,FALSE);
//STRIP001 			if (eType & FRMTYPE_HEADER)
//STRIP001 			{
//STRIP001 				if (rSh.SttPg())
//STRIP001 					nFuncId = FN_START_OF_PAGE;
//STRIP001 			}
//STRIP001 			else if (rSh.GotoHeaderTxt())
//STRIP001 				nFuncId = FN_TO_HEADER;
//STRIP001             bFocusToDoc = TRUE;
//STRIP001         }
//STRIP001 		break;
//STRIP001 		case FN_SELECT_FOOTNOTE:
//STRIP001 		{
//STRIP001 			rSh.MoveCrsr();
//STRIP001 			const USHORT eFrmType = rSh.GetFrmType(0,FALSE);
//STRIP001 				// aus Fussnote zum Anker springen
//STRIP001 			if (eFrmType & FRMTYPE_FOOTNOTE)
//STRIP001 			{
//STRIP001 				if (rSh.GotoFtnAnchor())
//STRIP001 					nFuncId = FN_FOOTNOTE_TO_ANCHOR;
//STRIP001 			}
//STRIP001 				// andernfalls zuerst zum Fussnotentext springen; geht
//STRIP001 				// dies nicht, zur naechten Fussnote; geht auch dies
//STRIP001 				// nicht, zur vorhergehenden Fussnote
//STRIP001 			else
//STRIP001 			{
//STRIP001 				if (rSh.GotoFtnTxt())
//STRIP001 					nFuncId = FN_FOOTNOTE_TO_ANCHOR;
//STRIP001 				else if (rSh.GotoNextFtnAnchor())
//STRIP001 					nFuncId = FN_NEXT_FOOTNOTE;
//STRIP001 				else if (rSh.GotoPrevFtnAnchor())
//STRIP001 					nFuncId = FN_PREV_FOOTNOTE;
//STRIP001 			}
//STRIP001             bFocusToDoc = TRUE;
//STRIP001         }
//STRIP001 		break;
//STRIP001 
//STRIP001 		case FN_SELECT_SET_AUTO_BOOKMARK:
//STRIP001 			MakeMark();
//STRIP001 		break;
//STRIP001 		case FN_ITEM_DOWN:
//STRIP001 		case FN_ITEM_UP:
//STRIP001 		case FN_ITEM_LEFT:
//STRIP001 		case FN_ITEM_RIGHT:
//STRIP001 		case FN_GLOBAL_EDIT:
//STRIP001 		{
//STRIP001 			if(IsGlobalMode())
//STRIP001 				aGlobalTree.ExecCommand(nId);
//STRIP001 			else
//STRIP001 				aContentTree.ExecCommand(nId, bOutlineWithChilds);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GLOBAL_SWITCH:
//STRIP001 		{
//STRIP001 			ToggleTree();
//STRIP001 			pConfig->SetGlobalActive(IsGlobalMode());
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GLOBAL_SAVE_CONTENT:
//STRIP001 		{
//STRIP001 			BOOL bSave = rSh.IsGlblDocSaveLinks();
//STRIP001 			rSh.SetGlblDocSaveLinks( !bSave );
//STRIP001 			pBox->CheckItem(FN_GLOBAL_SAVE_CONTENT, !bSave );
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_CREATE_NAVIGATION:
//STRIP001 		{
//STRIP001             CreateNavigationTool(pBox->GetItemRect(FN_CREATE_NAVIGATION), TRUE);
//STRIP001         }
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	if (nFuncId)
//STRIP001 	{
//STRIP001 		lcl_UnSelectFrm(&rSh);
//STRIP001 	}
//STRIP001     if(bFocusToDoc)
//STRIP001         pView->GetEditWin().GrabFocus();
//STRIP001 	return TRUE;
//STRIP001 }
/*------------------------------------------------------------------------
 Beschreibung:	ClickHandler der Toolboxen
------------------------------------------------------------------------*/


//STRIP001 IMPL_LINK( SwNavigationPI, ToolBoxClickHdl, ToolBox *, pBox )
//STRIP001 {
//STRIP001 	const USHORT nId = pBox->GetCurItemId();
//STRIP001 	switch (nId)
//STRIP001 	{
//STRIP001 		case FN_DROP_REGION:
//STRIP001 		{
//STRIP001 			PopupMenu *pMenu = new PopupMenu;
//STRIP001 			for (USHORT i = 0; i <= REGION_MODE_EMBEDDED; i++)
//STRIP001 			{
//STRIP001 				pMenu->InsertItem( i + 1, aContextArr[i] );
//STRIP001 				pMenu->SetHelpId(i + 1, HID_NAVI_DRAG_HYP + i);
//STRIP001 					/*HID_NAVI_DRAG_HYP
//STRIP001 					HID_NAVI_DRAG_LINK
//STRIP001 					HID_NAVI_DRAG_COPY  */
//STRIP001 			}
//STRIP001 			pMenu->CheckItem( nRegionMode + 1 );
//STRIP001 			pMenu->SetSelectHdl(LINK(this, SwNavigationPI, MenuSelectHdl));
//STRIP001 			pMenu->Execute( pBox,
//STRIP001 					pBox->GetItemRect(FN_DROP_REGION).BottomLeft());
//STRIP001 			pBox->EndSelection();
//STRIP001 			delete pMenu;
//STRIP001 			pBox->Invalidate();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_OUTLINE_LEVEL:
//STRIP001 		{
//STRIP001 			PopupMenu *pMenu = new PopupMenu;
//STRIP001 			for (USHORT i = 101; i <= 100 + MAXLEVEL; i++)
//STRIP001 			{
//STRIP001 				pMenu->InsertItem( i, String::CreateFromInt32(i - 100) );
//STRIP001 				pMenu->SetHelpId( i, HID_NAVI_OUTLINES );
//STRIP001 			}
//STRIP001 			pMenu->CheckItem( aContentTree.GetOutlineLevel() + 100 );
//STRIP001 			pMenu->SetSelectHdl(LINK(this, SwNavigationPI, MenuSelectHdl));
//STRIP001 			pMenu->Execute(	pBox,
//STRIP001 					pBox->GetItemRect(FN_OUTLINE_LEVEL).BottomLeft());
//STRIP001 			delete pMenu;
//STRIP001 			pBox->EndSelection();
//STRIP001 			pBox->Invalidate();
//STRIP001 		}
//STRIP001 		break;
//STRIP001 		case FN_GLOBAL_UPDATE:
//STRIP001 		case FN_GLOBAL_OPEN:
//STRIP001 		{
//STRIP001 			aGlobalTree.TbxMenuHdl(nId, pBox);
//STRIP001 		}
//STRIP001 		break;
//STRIP001 	}
//STRIP001 
//STRIP001 	return TRUE;
//STRIP001 }
/* -----------------------------19.09.00 15:16--------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 SwNavHelpToolBox::SwNavHelpToolBox(SwNavigationPI* pParent, const ResId &rResId) :
//STRIP001 			SwHelpToolBox(pParent, rResId)
//STRIP001 {}
/*-----------------19.06.97 09:09-------------------

--------------------------------------------------*/
//STRIP001 void SwNavHelpToolBox::MouseButtonDown(const MouseEvent &rEvt)
//STRIP001 {
//STRIP001 	if(rEvt.GetButtons() == MOUSE_LEFT &&
//STRIP001 			FN_CREATE_NAVIGATION == GetItemId(rEvt.GetPosPixel()))
//STRIP001 	{
//STRIP001         ((SwNavigationPI*)GetParent())->CreateNavigationTool(GetItemRect(FN_CREATE_NAVIGATION), FALSE);
//STRIP001     }
//STRIP001 	else
//STRIP001 		SwHelpToolBox::MouseButtonDown(rEvt);
//STRIP001 }
/* -----------------------------12.03.2002 16:55------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 void SwNavigationPI::CreateNavigationTool(const Rectangle& rRect, BOOL bSetFocus)
//STRIP001 {
//STRIP001     SfxBindings& rBind = GetCreateView()->GetViewFrame()->GetBindings();
//STRIP001     rBind.ENTERREGISTRATIONS();
//STRIP001     SwScrollNaviPopup* pPopup = new
//STRIP001         SwScrollNaviPopup(FN_SCROLL_NAVIGATION,
//STRIP001                         rBind);
//STRIP001     rBind.LEAVEREGISTRATIONS();
//STRIP001 
//STRIP001     Rectangle aRect(rRect);
//STRIP001     Point aT1 = aRect.TopLeft();
//STRIP001     aT1 = pPopup->GetParent()->AbsoluteScreenToOutputPixel(aContentToolBox.OutputToAbsoluteScreenPixel(aT1));
//STRIP001     aRect.SetPos(aT1);
//STRIP001     pPopup->StartPopupMode(aRect, FLOATWIN_POPUPMODE_RIGHT|FLOATWIN_POPUPMODE_ALLOWTEAROFF);
//STRIP001     if(bSetFocus)
//STRIP001     {
//STRIP001         pPopup->EndPopupMode(FLOATWIN_POPUPMODEEND_TEAROFF);
//STRIP001         pPopup->GrabFocus();
//STRIP001     }
//STRIP001 }

/*-----------------19.06.97 10:12-------------------

--------------------------------------------------*/
//STRIP001 void  SwNavHelpToolBox::RequestHelp( const HelpEvent& rHEvt )
//STRIP001 {
//STRIP001 	USHORT nItemId = GetItemId(ScreenToOutputPixel(rHEvt.GetMousePosPixel()));
//STRIP001 	if( FN_UP == nItemId || FN_DOWN == nItemId )
//STRIP001 	{
//STRIP001 		SetItemText(nItemId, SwScrollNaviPopup::GetQuickHelpText((FN_DOWN == nItemId)));
//STRIP001 	}
//STRIP001 	SwHelpToolBox::RequestHelp(rHEvt);
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:	Action-Handler Edit; wechselt auf die Seite, wenn
				nicht Gliederungssicht angeschaltet ist.
------------------------------------------------------------------------*/


//STRIP001 IMPL_LINK( SwNavigationPI, EditAction, NumEditAction *, pEdit )
//STRIP001 {
//STRIP001     SwView *pView = GetCreateView();
//STRIP001 	if (pView)
//STRIP001 	{
//STRIP001 		if(aPageChgTimer.IsActive())
//STRIP001 			aPageChgTimer.Stop();
//STRIP001 		pCreateView->GetWrtShell().GotoPage((USHORT)pEdit->GetValue());
//STRIP001 		pCreateView->GetEditWin().GrabFocus();
//STRIP001 		pCreateView->GetViewFrame()->GetBindings().Invalidate(FN_STAT_PAGE);
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:	Falls die Seite eingestellt werden kann, wird hier
				das Maximum gesetzt.
------------------------------------------------------------------------*/


//STRIP001 IMPL_LINK( SwNavigationPI, EditGetFocus, NumEditAction *, pEdit )
//STRIP001 {
//STRIP001     SwView *pView = GetCreateView();
//STRIP001 	if (!pView)
//STRIP001 		return 0;
//STRIP001 	SwWrtShell &rSh = pView->GetWrtShell();
//STRIP001 
//STRIP001 	const USHORT nPageCnt = rSh.GetPageCnt();
//STRIP001 	pEdit->SetMax(nPageCnt);
//STRIP001 	pEdit->SetLast(nPageCnt);
//STRIP001 	return 0;
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 BOOL SwNavigationPI::Close()
//STRIP001 {
//STRIP001 	SfxViewFrame* pVFrame = pCreateView->GetViewFrame();
//STRIP001 	pVFrame->GetBindings().Invalidate(SID_NAVIGATOR);
//STRIP001 	pVFrame->GetDispatcher()->Execute(SID_NAVIGATOR);
//STRIP001 	return TRUE;
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:	Setzen einer automatischen Marke
------------------------------------------------------------------------*/


//STRIP001 void SwNavigationPI::MakeMark()
//STRIP001 {
//STRIP001     SwView *pView = GetCreateView();
//STRIP001 	if (!pView)
//STRIP001 		return;
//STRIP001 	SwWrtShell &rSh = pView->GetWrtShell();
//STRIP001 
//STRIP001 	const USHORT nBookCnt = rSh.GetBookmarkCnt();
//STRIP001 	USHORT nMarkCount = 0;
//STRIP001 	USHORT nFirstFound = MAX_MARKS;
//STRIP001 	for (USHORT nCount = 0; nCount < nBookCnt; ++nCount)
//STRIP001 	{
//STRIP001 		SwBookmark& rBkmk = rSh.GetBookmark( nCount );
//STRIP001 		if( rBkmk.IsMark() )
//STRIP001 		{
//STRIP001 			String aBookmark( rBkmk.GetName() );
//STRIP001 			aBookmark.Erase(0, 1);
//STRIP001 			nFirstFound = Min(nFirstFound, (USHORT)aBookmark.ToInt32());
//STRIP001 			++nMarkCount;
//STRIP001 		}
//STRIP001 	}
//STRIP001 		// maximale Anzahl Bookmarks vergeben
//STRIP001 	if (nAutoMarkIdx == MAX_MARKS)
//STRIP001 		nAutoMarkIdx = 1;
//STRIP001 		// erster freier neu vergeben
//STRIP001 	else if (nFirstFound != MAX_MARKS)
//STRIP001 		nAutoMarkIdx = Max(USHORT(1), USHORT(nFirstFound - 1));
//STRIP001 	else
//STRIP001 		++nAutoMarkIdx;
//STRIP001 
//STRIP001 	String aMark;
//STRIP001 	MakeAutoName(aMark,nAutoMarkIdx);
//STRIP001 	if (nMarkCount >= MAX_MARKS)
//STRIP001 		rSh.DelBookmark( aMark );
//STRIP001 	rSh.SetBookmark(KeyCode(), aMark, aEmptyStr, MARK);
//STRIP001 	SwView::SetActMark( nAutoMarkIdx );
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::GotoPage()
//STRIP001 {
//STRIP001 	if ( pContextWin->GetFloatingWindow() && pContextWin->GetFloatingWindow()->IsRollUp())
//STRIP001 		_ZoomIn();
//STRIP001 	if(IsGlobalMode())
//STRIP001 		ToggleTree();
//STRIP001 	UsePage(0);
//STRIP001 	GetPageEdit().GrabFocus();
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::_ZoomOut()
//STRIP001 {
//STRIP001 	if (_IsZoomedIn())
//STRIP001 	{
//STRIP001 		FloatingWindow* pFloat = pContextWin->GetFloatingWindow();
//STRIP001 		bIsZoomedIn = FALSE;
//STRIP001 		Size aSz(GetOutputSizePixel());
//STRIP001 		aSz.Height() = nZoomOut;
//STRIP001 		Size aMinOutSizePixel = ((SfxDockingWindow*)GetParent())->GetMinOutputSizePixel();
//STRIP001 		((SfxDockingWindow*)GetParent())->SetMinOutputSizePixel(Size(
//STRIP001 							aMinOutSizePixel.Width(),nZoomOutInit));
//STRIP001 		pFloat->SetOutputSizePixel(aSz);
//STRIP001 		FillBox();
//STRIP001 		if(IsGlobalMode())
//STRIP001 		{
//STRIP001 			aGlobalTree.Show();
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aContentTree.Show();
//STRIP001 			aDocListBox.Show();
//STRIP001 		}
//STRIP001 		SvLBoxEntry* pFirst = aContentTree.FirstSelected();
//STRIP001 		if(pFirst)
//STRIP001 			aContentTree.Select(pFirst, TRUE); // toolbox enablen
//STRIP001 		pConfig->SetSmall( FALSE );
//STRIP001 		aContentToolBox.CheckItem(FN_SHOW_CONTENT_BOX);
//STRIP001 	}
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::_ZoomIn()
//STRIP001 {
//STRIP001 	FloatingWindow* pFloat = pContextWin->GetFloatingWindow();
//STRIP001 	if (pFloat &&
//STRIP001 		(!_IsZoomedIn() || ( pContextWin->GetFloatingWindow()->IsRollUp())))
//STRIP001 	{
//STRIP001 		aContentTree.Hide();
//STRIP001 		aDocListBox.Hide();
//STRIP001 		aGlobalTree.Hide();
//STRIP001 		bIsZoomedIn = TRUE;
//STRIP001 		Size aSz(GetOutputSizePixel());
//STRIP001 		if( aSz.Height() > nZoomIn )
//STRIP001 			nZoomOut = ( short ) aSz.Height();
//STRIP001 
//STRIP001 		aSz.Height() = nZoomIn;
//STRIP001 		Size aMinOutSizePixel = ((SfxDockingWindow*)GetParent())->GetMinOutputSizePixel();
//STRIP001 		((SfxDockingWindow*)GetParent())->SetMinOutputSizePixel(Size(
//STRIP001 							aMinOutSizePixel.Width(), aSz.Height()));
//STRIP001 		pFloat->SetOutputSizePixel(aSz);
//STRIP001 		SvLBoxEntry* pFirst = aContentTree.FirstSelected();
//STRIP001 		if(pFirst)
//STRIP001 			aContentTree.Select(pFirst, TRUE); // toolbox enablen
//STRIP001 		pConfig->SetSmall( TRUE );
//STRIP001 		aContentToolBox.CheckItem(FN_SHOW_CONTENT_BOX, FALSE);
//STRIP001 	}
//STRIP001 }
/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::Resize()
//STRIP001 {
//STRIP001 	Window* pParent = GetParent();
//STRIP001 	FloatingWindow* pFloat =  ((DockingWindow*)pParent)->GetFloatingWindow();
//STRIP001 	Size aNewSize;
//STRIP001 	if( !_IsZoomedIn() )
//STRIP001 	{
//STRIP001         //change the minimum width depending on the dock status
//STRIP001         Size aMinOutSizePixel = ((SfxDockingWindow*)pParent)->GetMinOutputSizePixel();
//STRIP001         if( pFloat)
//STRIP001 		{
//STRIP001 			aNewSize = pFloat->GetOutputSizePixel();
//STRIP001             aMinOutSizePixel.Width() = nWishWidth;
//STRIP001             aMinOutSizePixel.Height() = _IsZoomedIn() ? nZoomIn : nZoomOutInit;
//STRIP001         }
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aNewSize = pParent->GetOutputSizePixel();
//STRIP001             aMinOutSizePixel.Width() = 0;
//STRIP001             aMinOutSizePixel.Height() = 0;
//STRIP001         }
//STRIP001         ((SfxDockingWindow*)GetParent())->SetMinOutputSizePixel(aMinOutSizePixel);
//STRIP001 
//STRIP001         const Point aPos = aContentTree.GetPosPixel();
//STRIP001 		Point aLBPos = aDocListBox.GetPosPixel();
//STRIP001 		long nDist = aPos.X();
//STRIP001 		aNewSize.Height() -= (aPos.Y() + aPos.X() + nDocLBIniHeight + nDist);
//STRIP001 		aNewSize.Width() -= 2 * nDist;
//STRIP001 		aLBPos.Y() = aPos.Y() + aNewSize.Height() + nDist;
//STRIP001 		aDocListBox.Show(!aGlobalTree.IsVisible() && aLBPos.Y() > aPos.Y() );
//STRIP001 
//STRIP001 		Size aDocLBSz = aDocListBox.GetSizePixel();
//STRIP001 		aDocLBSz.Width() = aNewSize.Width();
//STRIP001 		if(aNewSize.Height() < 0)
//STRIP001 			aDocLBSz.Height() = 0;
//STRIP001 		else
//STRIP001 			aDocLBSz.Height() = nDocLBIniHeight;
//STRIP001 		aContentTree.SetSizePixel(aNewSize);
//STRIP001 		// GlobalTree faengt weiter oben an und reicht bis ganz unten
//STRIP001 		aNewSize.Height() += (nDist + nDocLBIniHeight + aPos.Y() - aGlobalTree.GetPosPixel().Y());
//STRIP001 		aGlobalTree.SetSizePixel(aNewSize);
//STRIP001 		aDocListBox.SetPosSizePixel( aLBPos.X(), aLBPos.Y(),
//STRIP001 									 aDocLBSz.Width(), aDocLBSz.Height(),
//STRIP001 									  WINDOW_POSSIZE_X|WINDOW_POSSIZE_Y|WINDOW_POSSIZE_WIDTH);
//STRIP001 
//STRIP001 	}
//STRIP001 }


/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 SwNavigationPI::SwNavigationPI( SfxBindings* pBindings,
//STRIP001 								SfxChildWindowContext* pCw,
//STRIP001 								Window* pParent) :
//STRIP001 
//STRIP001 	Window( pParent, SW_RES(DLG_NAVIGATION_PI)),
//STRIP001 	SfxControllerItem( SID_DOCFULLNAME, *pBindings ),
//STRIP001 	aContentTree(this, SW_RES(TL_CONTENT)),
//STRIP001 	aGlobalTree(this, SW_RES(TL_GLOBAL)),
//STRIP001 	aContentToolBox(this, SW_RES(TB_CONTENT)),
//STRIP001 	aGlobalToolBox(this, SW_RES(TB_GLOBAL)),
//STRIP001 	aContentImageList(SW_RES(IL_CONTENT)),
//STRIP001     aContentImageListH(SW_RES(ILH_CONTENT)),
//STRIP001 	aDocListBox(this, SW_RES(LB_DOCS)),
//STRIP001 	nActMark(0),
//STRIP001 	nAutoMarkIdx(0),
//STRIP001 	rBindings(*pBindings),
//STRIP001 	bSmallMode(FALSE),
//STRIP001 	bIsZoomedIn(FALSE),
//STRIP001 	bPageCtrlsVisible(FALSE),
//STRIP001 	bGlobalMode(FALSE),
//STRIP001 	nRegionMode(REGION_MODE_NONE),
//STRIP001 	pxObjectShell(0),
//STRIP001 	pContentView(0),
//STRIP001 	pContentWrtShell(0),
//STRIP001 	pActContView(0),
//STRIP001 	pContextWin(pCw),
//STRIP001 	nWishWidth(0),
//STRIP001 	pConfig(SW_MOD()->GetNavigationConfig()),
//STRIP001     pCreateView(0)
//STRIP001 {
//STRIP001     GetCreateView();
//STRIP001     InitImageList();
//STRIP001 
//STRIP001 	aContentToolBox.SetHelpId(HID_NAVIGATOR_TOOLBOX );
//STRIP001 	aGlobalToolBox.SetHelpId(HID_NAVIGATOR_GLOBAL_TOOLBOX);
//STRIP001 	aDocListBox.SetHelpId(HID_NAVIGATOR_LISTBOX );
//STRIP001 
//STRIP001 	nDocLBIniHeight = aDocListBox.GetSizePixel().Height();
//STRIP001 	nZoomOutInit = nZoomOut = Resource::ReadShortRes();
//STRIP001 
//STRIP001 	//NumericField in die Toolbox einfuegen
//STRIP001 	NumEditAction* pEdit = new NumEditAction(
//STRIP001 					&aContentToolBox, SW_RES(NF_PAGE ));
//STRIP001 	pEdit->SetActionHdl(LINK(this, SwNavigationPI, EditAction));
//STRIP001 	pEdit->SetGetFocusHdl(LINK(this, SwNavigationPI, EditGetFocus));
//STRIP001 	pEdit->SetModifyHdl(LINK(this, SwNavigationPI, PageEditModifyHdl));
//STRIP001 
//STRIP001 	bPageCtrlsVisible = TRUE;
//STRIP001 
//STRIP001 //	Rectangle aFirstRect = aContentToolBox.GetItemRect(FN_SHOW_ROOT);
//STRIP001 //	USHORT nWidth = 2 * (USHORT)aFirstRect.Left();
//STRIP001 	//doppelte Separatoren sind nicht erlaubt, also muss
//STRIP001 	//die passende Groesse anders ermittelt werden
//STRIP001 	Rectangle aFirstRect = aContentToolBox.GetItemRect(FN_DROP_REGION);
//STRIP001 	Rectangle aSecondRect = aContentToolBox.GetItemRect(FN_ITEM_DOWN);
//STRIP001 	USHORT nWidth = USHORT(aSecondRect.Left() - aFirstRect.Left());
//STRIP001 
//STRIP001 	Size aItemWinSize( nWidth, aFirstRect.Bottom() - aFirstRect.Top() );
//STRIP001 	pEdit->SetSizePixel(aItemWinSize);
//STRIP001 	aContentToolBox.InsertWindow( FN_PAGENUMBER, pEdit, 0, 5);
//STRIP001 	//aContentToolBox.InsertSeparator(4);
//STRIP001 	aContentToolBox.SetHelpId(FN_PAGENUMBER, HID_NAVI_TBX16);
//STRIP001 	aContentToolBox.ShowItem( FN_PAGENUMBER );
//STRIP001 
//STRIP001 	for( USHORT i = 0; i <= REGION_MODE_EMBEDDED; i++  )
//STRIP001 	{
//STRIP001 		aContextArr[i] = SW_RESSTR(ST_HYPERLINK + i);
//STRIP001 		aStatusArr[i] = SW_RESSTR(ST_STATUS_FIRST + i);
//STRIP001 	}
//STRIP001 	aStatusArr[3] = SW_RESSTR(ST_ACTIVE_VIEW);
//STRIP001 	FreeResource();
//STRIP001 
//STRIP001 
//STRIP001 	const Size& rOutSize =  GetOutputSizePixel();
//STRIP001 
//STRIP001 	nZoomIn = (short)rOutSize.Height();
//STRIP001 	Point aBoxPos = aContentTree.GetPosPixel();
//STRIP001 
//STRIP001 	//Der linke und rechte Rand um die Toolboxen soll gleich sein
//STRIP001 	nWishWidth = aContentToolBox.CalcWindowSizePixel().Width();
//STRIP001 	nWishWidth += 2 * aContentToolBox.GetPosPixel().X();
//STRIP001 
//STRIP001     FloatingWindow* pFloat =  ((DockingWindow*)pParent)->GetFloatingWindow();
//STRIP001     Size aMinSize(pFloat ? nWishWidth : 0, pFloat ? nZoomOutInit : 0);
//STRIP001 	((SfxDockingWindow*)pParent)->SetMinOutputSizePixel(aMinSize);
//STRIP001 	SetOutputSizePixel( Size( nWishWidth, nZoomOutInit));
//STRIP001 	Size aTmpParentSize(((SfxDockingWindow*)pParent)->GetSizePixel());
//STRIP001 	if(aTmpParentSize.Width() < aMinSize.Width() ||
//STRIP001         aTmpParentSize.Height() < aMinSize.Height() &&
//STRIP001             ((SfxDockingWindow*)pParent)->GetFloatingWindow() &&
//STRIP001                 !((SfxDockingWindow*)pParent)->GetFloatingWindow()->IsRollUp())
//STRIP001 		((SfxDockingWindow*)pParent)->SetOutputSizePixel(aMinSize);
//STRIP001 
//STRIP001 	aContentTree.SetWindowBits( WB_HASBUTTONS|WB_HASBUTTONSATROOT|
//STRIP001 							WB_CLIPCHILDREN|WB_HSCROLL|WB_FORCE_MAKEVISIBLE );
//STRIP001     aContentTree.SetSpaceBetweenEntries(3);
//STRIP001 	aContentTree.SetSelectionMode( SINGLE_SELECTION );
//STRIP001 	aContentTree.SetDragDropMode( 	SV_DRAGDROP_CTRL_MOVE |
//STRIP001 									SV_DRAGDROP_CTRL_COPY |
//STRIP001 									SV_DRAGDROP_ENABLE_TOP );
//STRIP001 	aContentTree.EnableAsyncDrag(TRUE);
//STRIP001 	aContentTree.Show();
//STRIP001 	aContentToolBox.CheckItem(FN_SHOW_CONTENT_BOX, TRUE);
//STRIP001 
//STRIP001 // 	TreeListBox fuer Globaldokument
//STRIP001 	aGlobalTree.SetSelectionMode( MULTIPLE_SELECTION );
//STRIP001 	aGlobalTree.SetWindowBits( WB_HASBUTTONS|WB_HASBUTTONSATROOT|
//STRIP001 								WB_CLIPCHILDREN|WB_HSCROLL );
//STRIP001 	Size aGlblSize(aGlobalToolBox.CalcWindowSizePixel());
//STRIP001 	aGlobalToolBox.SetSizePixel(aGlblSize);
//STRIP001 
//STRIP001 //	Handler
//STRIP001 
//STRIP001 	Link aLk = LINK(this, SwNavigationPI, ToolBoxSelectHdl);
//STRIP001 	aContentToolBox.SetSelectHdl( aLk );
//STRIP001 	aGlobalToolBox.SetSelectHdl( aLk );
//STRIP001 	aDocListBox.SetSelectHdl(LINK(this, SwNavigationPI,
//STRIP001 													DocListBoxSelectHdl));
//STRIP001 	aContentToolBox.SetClickHdl( LINK(this, SwNavigationPI, ToolBoxClickHdl) );
//STRIP001 	aGlobalToolBox.SetClickHdl( LINK(this, SwNavigationPI, ToolBoxClickHdl) );
//STRIP001 	aGlobalToolBox.CheckItem(FN_GLOBAL_SWITCH, TRUE);
//STRIP001 
//STRIP001 	Font aFont(GetFont());
//STRIP001 	aFont.SetWeight(WEIGHT_NORMAL);
//STRIP001 	aContentTree.SetFont(aFont);
//STRIP001 	aGlobalTree.SetFont(aFont);
//STRIP001 	GetPageEdit().SetFont(aFont);
//STRIP001 
//STRIP001 	StartListening(*SFX_APP());
//STRIP001  if ( pCreateView )
//STRIP001     StartListening(*pCreateView);
//STRIP001     SfxImageManager* pImgMan = pBindings->GetImageManager();
//STRIP001 	pImgMan->RegisterToolBox(&aContentToolBox, SFX_TOOLBOX_CHANGEOUTSTYLE);
//STRIP001 	pImgMan->RegisterToolBox(&aGlobalToolBox, SFX_TOOLBOX_CHANGEOUTSTYLE);
//STRIP001 	if(IsGlobalDoc())
//STRIP001 	{
//STRIP001         SwView *pActView = GetCreateView();
//STRIP001 		aGlobalToolBox.CheckItem(FN_GLOBAL_SAVE_CONTENT,
//STRIP001 					pActView->GetWrtShellPtr()->IsGlblDocSaveLinks());
//STRIP001 		if(pConfig->IsGlobalActive())
//STRIP001 			ToggleTree();
//STRIP001     }
//STRIP001 	UsePage(0);
//STRIP001 	aPageChgTimer.SetTimeoutHdl(LINK(this, SwNavigationPI, ChangePageHdl));
//STRIP001 	aPageChgTimer.SetTimeout(PAGE_CHANGE_TIMEOUT);
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 SwNavigationPI::~SwNavigationPI()
//STRIP001 {
//STRIP001 	if(IsGlobalDoc() && !IsGlobalMode())
//STRIP001 	{
//STRIP001         SwView *pView = GetCreateView();
//STRIP001 		SwWrtShell &rSh = pView->GetWrtShell();
//STRIP001 		if( !rSh.IsAllProtect() )
//STRIP001 			pView->GetDocShell()->SetReadOnlyUI(FALSE);
//STRIP001 	}
//STRIP001 
//STRIP001 	EndListening(*SFX_APP());
//STRIP001 
//STRIP001     SfxImageManager* pImgMan = GetBindings().GetImageManager();
//STRIP001 	pImgMan->ReleaseToolBox(&aContentToolBox);
//STRIP001 	pImgMan->ReleaseToolBox(&aGlobalToolBox);
//STRIP001 	delete aContentToolBox.GetItemWindow(FN_PAGENUMBER);
//STRIP001 	delete aContentToolBox.GetItemWindow(FN_CONTENT_LB);
//STRIP001 	if(pxObjectShell)
//STRIP001 	{
//STRIP001 		if(pxObjectShell->Is())
//STRIP001 			(*pxObjectShell)->DoClose();
//STRIP001 		delete pxObjectShell;
//STRIP001 	}
//STRIP001 
//STRIP001 }
/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::StateChanged( USHORT nSID, SfxItemState eState,
//STRIP001 											const SfxPoolItem* pState )
//STRIP001 {
//STRIP001 	if(nSID == SID_DOCFULLNAME)
//STRIP001 	{
//STRIP001         SwView *pActView = GetCreateView();
//STRIP001 		if(pActView)
//STRIP001 		{
//STRIP001 			SwWrtShell* pWrtShell = pActView->GetWrtShellPtr();
//STRIP001 			aContentTree.SetActiveShell(pWrtShell);
//STRIP001 			BOOL bGlobal = IsGlobalDoc();
//STRIP001 			aContentToolBox.EnableItem(FN_GLOBAL_SWITCH, bGlobal);
//STRIP001 			if(!bGlobal && IsGlobalMode() ||
//STRIP001 					!IsGlobalMode() && pConfig->IsGlobalActive())
//STRIP001 			{
//STRIP001 				ToggleTree();
//STRIP001 			}
//STRIP001 			if(bGlobal)
//STRIP001 			{
//STRIP001 				aGlobalToolBox.CheckItem(FN_GLOBAL_SAVE_CONTENT, pWrtShell->IsGlblDocSaveLinks());
//STRIP001 			}
//STRIP001 		}
//STRIP001 		else
//STRIP001 		{
//STRIP001 			aContentTree.SetActiveShell(0);
//STRIP001 		}
//STRIP001 		UpdateListBox();
//STRIP001 	}
//STRIP001 }

/*------------------------------------------------------------------------
	Bechreibung: NumericField aus der Toolbox holen
------------------------------------------------------------------------*/

//STRIP001 NumEditAction& SwNavigationPI::GetPageEdit()
//STRIP001 {
//STRIP001 	return *(NumEditAction*)aContentToolBox.GetItemWindow(FN_PAGENUMBER);
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/
/*

ListBox& SwNavigationPI::GetTypeSelBox()
{
	DBG_ASSERT(aContentToolBox.GetItemWindow(FN_CONTENT_LB),
								"ItemWindow nicht vorhanden")
	return *(ListBox*)aContentToolBox.GetItemWindow(FN_CONTENT_LB);

}*/
/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 SfxChildAlignment SwNavigationPI::CheckAlignment
//STRIP001 	(
//STRIP001 		SfxChildAlignment eActAlign,
//STRIP001 		SfxChildAlignment eAlign
//STRIP001 	)
//STRIP001 {
//STRIP001 SfxChildAlignment eRetAlign;
//STRIP001 
//STRIP001 	if(_IsZoomedIn())
//STRIP001 		eRetAlign = SFX_ALIGN_NOALIGNMENT;
//STRIP001 	else
//STRIP001 		switch (eAlign)
//STRIP001 		{
//STRIP001 			case SFX_ALIGN_BOTTOM:
//STRIP001 			case SFX_ALIGN_LOWESTBOTTOM:
//STRIP001 			case SFX_ALIGN_HIGHESTBOTTOM:
//STRIP001 				eRetAlign = eActAlign;
//STRIP001 				break;
//STRIP001 
//STRIP001 			case SFX_ALIGN_TOP:
//STRIP001 			case SFX_ALIGN_HIGHESTTOP:
//STRIP001 			case SFX_ALIGN_LOWESTTOP:
//STRIP001 			case SFX_ALIGN_LEFT:
//STRIP001 			case SFX_ALIGN_RIGHT:
//STRIP001 			case SFX_ALIGN_FIRSTLEFT:
//STRIP001 			case SFX_ALIGN_LASTLEFT:
//STRIP001 			case SFX_ALIGN_FIRSTRIGHT:
//STRIP001 			case SFX_ALIGN_LASTRIGHT:
//STRIP001 				eRetAlign = eAlign;
//STRIP001 				break;
//STRIP001 
//STRIP001 			default:
//STRIP001 				eRetAlign = eAlign;
//STRIP001 				break;
//STRIP001 		}
//STRIP001 	return eRetAlign;
//STRIP001 
//STRIP001 }

/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 BOOL SwNavigationPI::IsInDrag() const
//STRIP001 {
//STRIP001 	return aContentTree.IsInternalDrag() || aContentTree.IsInDrag();
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung: 	Benachrichtigung bei geaenderter DocInfo
 --------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::Notify( SfxBroadcaster& rBrdc, const SfxHint& rHint )
//STRIP001 {
//STRIP001     if(&rBrdc == pCreateView)
//STRIP001     {
//STRIP001         if(rHint.ISA(SfxSimpleHint) && ((SfxSimpleHint&)rHint).GetId() == SFX_HINT_DYING)
//STRIP001         {
//STRIP001             pCreateView = 0;
//STRIP001         }
//STRIP001     }
//STRIP001     else
//STRIP001     {
//STRIP001         if(rHint.ISA(SfxEventHint))
//STRIP001         {
//STRIP001             if( pxObjectShell &&
//STRIP001                         ((SfxEventHint&) rHint).GetEventId() == SFX_EVENT_CLOSEAPP)
//STRIP001             {
//STRIP001                 DELETEZ(pxObjectShell);
//STRIP001             }
//STRIP001             else if(((SfxEventHint&) rHint).GetEventId() == SFX_EVENT_OPENDOC)
//STRIP001             {
//STRIP001 
//STRIP001                 SwView *pActView = GetCreateView();
//STRIP001                 if(pActView)
//STRIP001                 {
//STRIP001                     SwWrtShell* pWrtShell = pActView->GetWrtShellPtr();
//STRIP001                     aContentTree.SetActiveShell(pWrtShell);
//STRIP001                     if(aGlobalTree.IsVisible())
//STRIP001                     {
//STRIP001                         if(aGlobalTree.Update())
//STRIP001                             aGlobalTree.Display();
//STRIP001                         else
//STRIP001                         // wenn kein Update notwendig, dann zumindest painten
//STRIP001                         // wg. der roten Eintraege fuer broken links
//STRIP001                             aGlobalTree.Invalidate();
//STRIP001                     }
//STRIP001                 }
//STRIP001             }
//STRIP001         }
//STRIP001     }
//STRIP001 }

/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 IMPL_LINK( SwNavigationPI, MenuSelectHdl, Menu *, pMenu )
//STRIP001 {
//STRIP001 	USHORT nMenuId = pMenu->GetCurItemId();
//STRIP001 	if(nMenuId != USHRT_MAX)
//STRIP001 	{
//STRIP001 		if(nMenuId < 100)
//STRIP001 			SetRegionDropMode( --nMenuId);
//STRIP001 		else
//STRIP001 			aContentTree.SetOutlineLevel(nMenuId - 100);
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }


/*--------------------------------------------------------------------
	Beschreibung:
 --------------------------------------------------------------------*/

//STRIP001 void SwNavigationPI::UpdateListBox()
//STRIP001 {
//STRIP001 	aDocListBox.SetUpdateMode(FALSE);
//STRIP001 	aDocListBox.Clear();
//STRIP001     SwView *pActView = GetCreateView();
//STRIP001 	BOOL bDisable = pActView == 0;
//STRIP001 	SwView *pView = SwModule::GetFirstView();
//STRIP001 	USHORT nCount = 0;
//STRIP001 	USHORT nAct = 0;
//STRIP001 	USHORT nConstPos = 0;
//STRIP001 	const SwView* pConstView = aContentTree.IsConstantView() &&
//STRIP001 								aContentTree.GetActiveWrtShell() ?
//STRIP001 									&aContentTree.GetActiveWrtShell()->GetView():
//STRIP001 										0;
//STRIP001 	while (pView)
//STRIP001 	{
//STRIP001 		String sEntry = pView->GetDocShell()->GetTitle();
//STRIP001 		sEntry += C2S(" (");
//STRIP001 		if (pView == pActView)
//STRIP001 		{
//STRIP001 			nAct = nCount;
//STRIP001 			sEntry += aStatusArr[ST_ACTIVE - ST_STATUS_FIRST];
//STRIP001 		}
//STRIP001 		else
//STRIP001 			sEntry += aStatusArr[ST_INACTIVE - ST_STATUS_FIRST];
//STRIP001 		sEntry += ')';
//STRIP001 		aDocListBox.InsertEntry(sEntry);
//STRIP001 
//STRIP001 
//STRIP001 		if (pConstView && pView == pConstView)
//STRIP001 			nConstPos = nCount;
//STRIP001 
//STRIP001 		pView = SwModule::GetNextView(pView);
//STRIP001 		nCount++;
//STRIP001 	}
//STRIP001 	aDocListBox.InsertEntry(aStatusArr[3]); //"Aktives Fenster"
//STRIP001 	nCount++;
//STRIP001 
//STRIP001 	if(aContentTree.GetHiddenWrtShell())
//STRIP001 	{
//STRIP001 		String sEntry = aContentTree.GetHiddenWrtShell()->GetView().
//STRIP001 										GetDocShell()->GetTitle();
//STRIP001 		sEntry += C2S(" (");
//STRIP001 		sEntry += aStatusArr[ST_HIDDEN - ST_STATUS_FIRST];
//STRIP001 		sEntry += ')';
//STRIP001 		aDocListBox.InsertEntry(sEntry);
//STRIP001 		bDisable = FALSE;
//STRIP001 	}
//STRIP001 	if(aContentTree.IsActiveView())
//STRIP001 	{
//STRIP001 		//entweder den Namen des akt. Docs oder "Aktives Dokument"
//STRIP001 		USHORT nTmp = pActView ? nAct : --nCount;
//STRIP001 		aDocListBox.SelectEntryPos( nTmp );
//STRIP001 	}
//STRIP001 	else if(aContentTree.IsHiddenView())
//STRIP001 	{
//STRIP001 		aDocListBox.SelectEntryPos(nCount);
//STRIP001 	}
//STRIP001 	else
//STRIP001 		aDocListBox.SelectEntryPos(nConstPos);
//STRIP001 
//STRIP001 	aDocListBox.Enable( !bDisable );
//STRIP001 	aDocListBox.SetUpdateMode(TRUE);
//STRIP001 }

/*-----------------16.06.97 15:05-------------------

--------------------------------------------------*/

/*------------------------------------------------------------------------
	Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 IMPL_LINK(SwNavigationPI, DoneLink, SfxPoolItem *, pItem)
//STRIP001 {
//STRIP001 	const SfxViewFrameItem* pFrameItem = PTR_CAST(SfxViewFrameItem, pItem );
//STRIP001 	if( pFrameItem )
//STRIP001 	{
//STRIP001 		SfxViewFrame* pFrame =  pFrameItem->GetFrame();
//STRIP001 		if(pFrame)
//STRIP001 		{
//STRIP001 			aContentTree.Clear();
//STRIP001 			pContentView = PTR_CAST(SwView, pFrame->GetViewShell());
//STRIP001 			DBG_ASSERT(pContentView, "keine SwView")
//STRIP001 			if(pContentView)
//STRIP001 				pContentWrtShell = pContentView->GetWrtShellPtr();
//STRIP001 			else
//STRIP001 				pContentWrtShell = 0;
//STRIP001 			pxObjectShell = new SfxObjectShellLock(pFrame->GetObjectShell());
//STRIP001 			FillBox();
//STRIP001 			aContentTree.Update();
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return 0;
//STRIP001 }

//STRIP001 String SwNavigationPI::CreateDropFileName( TransferableDataHelper& rData )
//STRIP001 {
//STRIP001 	String sFileName;
//STRIP001 	ULONG nFmt;
//STRIP001 	if( rData.HasFormat( nFmt = FORMAT_FILE_LIST ))
//STRIP001 	{
//STRIP001 		FileList aFileList;
//STRIP001 		rData.GetFileList( nFmt, aFileList );
//STRIP001 		sFileName = aFileList.GetFile( 0 );
//STRIP001 	}
//STRIP001 	else if( rData.HasFormat( nFmt = FORMAT_STRING ) ||
//STRIP001 	 		 rData.HasFormat( nFmt = FORMAT_FILE ) ||
//STRIP001 			 rData.HasFormat( nFmt = SOT_FORMATSTR_ID_FILENAME ))
//STRIP001 		rData.GetString( nFmt, sFileName );
//STRIP001 	else if( rData.HasFormat( nFmt = SOT_FORMATSTR_ID_SOLK ) ||
//STRIP001  		  	 rData.HasFormat( nFmt = SOT_FORMATSTR_ID_NETSCAPE_BOOKMARK )||
//STRIP001  		  	 rData.HasFormat( nFmt = SOT_FORMATSTR_ID_FILECONTENT ) ||
//STRIP001  		  	 rData.HasFormat( nFmt = SOT_FORMATSTR_ID_FILEGRPDESCRIPTOR ) ||
//STRIP001  		  	 rData.HasFormat( nFmt = SOT_FORMATSTR_ID_UNIFORMRESOURCELOCATOR ))
//STRIP001 	{
//STRIP001 		INetBookmark aBkmk( aEmptyStr, aEmptyStr );
//STRIP001 		rData.GetINetBookmark( nFmt, aBkmk );
//STRIP001 		sFileName = aBkmk.GetURL();
//STRIP001 	}
//STRIP001 	if( sFileName.Len() )
//STRIP001 		sFileName = so3::StaticBaseUrl::SmartRelToAbs( sFileName );
//STRIP001 	return sFileName;
//STRIP001 }

/*------------------------------------------------------------------------
	Beschreibung:
------------------------------------------------------------------------*/

//STRIP001 sal_Int8 SwNavigationPI::AcceptDrop( const AcceptDropEvent& rEvt )
//STRIP001 {
//STRIP001 	return ( !aContentTree.IsInDrag() &&
//STRIP001 		( aContentTree.IsDropFormatSupported( FORMAT_FILE ) ||
//STRIP001 		  aContentTree.IsDropFormatSupported( FORMAT_STRING ) ||
//STRIP001 		  aContentTree.IsDropFormatSupported( SOT_FORMATSTR_ID_SOLK ) ||
//STRIP001  		  aContentTree.IsDropFormatSupported( SOT_FORMATSTR_ID_NETSCAPE_BOOKMARK )||
//STRIP001  		  aContentTree.IsDropFormatSupported( SOT_FORMATSTR_ID_FILECONTENT ) ||
//STRIP001  		  aContentTree.IsDropFormatSupported( SOT_FORMATSTR_ID_FILEGRPDESCRIPTOR ) ||
//STRIP001  		  aContentTree.IsDropFormatSupported( SOT_FORMATSTR_ID_UNIFORMRESOURCELOCATOR ) ||
//STRIP001  		  aContentTree.IsDropFormatSupported( SOT_FORMATSTR_ID_FILENAME )))
//STRIP001 		? DND_ACTION_COPY
//STRIP001 		: DND_ACTION_NONE;
//STRIP001 }

//STRIP001 sal_Int8 SwNavigationPI::ExecuteDrop( const ExecuteDropEvent& rEvt )
//STRIP001 {
//STRIP001 	TransferableDataHelper aData( rEvt.maDropEvent.Transferable );
//STRIP001 	sal_Int8 nRet = DND_ACTION_NONE;
//STRIP001 	String sFileName;
//STRIP001 	if( !aContentTree.IsInDrag() &&
//STRIP001 		0 != (sFileName = SwNavigationPI::CreateDropFileName( aData )).Len() )
//STRIP001 	{
//STRIP001 		GraphicDescriptor aDesc( sFileName );
//STRIP001 		if( !aDesc.Detect() )	// keine Grafiken annehmen
//STRIP001 		{
//STRIP001 			if( STRING_NOTFOUND == sFileName.Search('#')
//STRIP001 				&& (!sContentFileName.Len() || sContentFileName != sFileName ))
//STRIP001 			{
//STRIP001 				nRet = rEvt.mnAction;
//STRIP001 				sFileName.EraseTrailingChars( char(0) );
//STRIP001 				sContentFileName = sFileName;
//STRIP001 				if(pxObjectShell)
//STRIP001 				{
//STRIP001 					aContentTree.SetHiddenShell( 0 );
//STRIP001 					(*pxObjectShell)->DoClose();
//STRIP001 					DELETEZ( pxObjectShell);
//STRIP001 				}
//STRIP001 				SfxStringItem aFileItem(SID_FILE_NAME, sFileName );
//STRIP001 				String sOptions = C2S("HRC");
//STRIP001 				SfxStringItem aOptionsItem( SID_OPTIONS, sOptions );
//STRIP001 				SfxLinkItem aLink( SID_DONELINK,
//STRIP001 									LINK( this, SwNavigationPI, DoneLink ) );
//STRIP001 				GetActiveView()->GetViewFrame()->GetDispatcher()->Execute(
//STRIP001 							SID_OPENDOC, SFX_CALLMODE_ASYNCHRON,
//STRIP001 							&aFileItem, &aOptionsItem, &aLink, 0L );
//STRIP001 			}
//STRIP001 		}
//STRIP001 	}
//STRIP001 	return nRet;
//STRIP001 }

/*-----------------27.11.96 13.00-------------------

--------------------------------------------------*/

//STRIP001 void SwNavigationPI::SetRegionDropMode(USHORT nNewMode)
//STRIP001 {
//STRIP001 	nRegionMode = nNewMode;
//STRIP001 	pConfig->SetRegionMode( nRegionMode );
//STRIP001 
//STRIP001 	USHORT nId = FN_DROP_REGION;
//STRIP001 	if(nRegionMode == REGION_MODE_LINK)
//STRIP001 		nId = FN_DROP_REGION_LINK;
//STRIP001 	else if(nRegionMode == REGION_MODE_EMBEDDED)
//STRIP001 		nId = FN_DROP_REGION_COPY;
//STRIP001 
//STRIP001     ImageList& rImgLst = aContentToolBox.GetDisplayBackground().GetColor().IsDark()
//STRIP001 				? aContentImageListH : aContentImageList;
//STRIP001 
//STRIP001     aContentToolBox.SetItemImage( FN_DROP_REGION,
//STRIP001                                     rImgLst.GetImage(nId));
//STRIP001 }


/*-----------------12.06.97 09:47-------------------

--------------------------------------------------*/

//STRIP001 BOOL	SwNavigationPI::ToggleTree()
//STRIP001 {
//STRIP001 	BOOL bRet = TRUE;
//STRIP001 	BOOL bGlobalDoc = IsGlobalDoc();
//STRIP001 	if(!IsGlobalMode() && bGlobalDoc)
//STRIP001 	{
//STRIP001 		SetUpdateMode(FALSE);
//STRIP001 		if(_IsZoomedIn())
//STRIP001 			_ZoomOut();
//STRIP001 		aGlobalTree.Show();
//STRIP001 		aGlobalToolBox.Show();
//STRIP001 		aContentTree.Hide();
//STRIP001 		aContentToolBox.Hide();
//STRIP001 		aDocListBox.Hide();
//STRIP001 		SetGlobalMode(TRUE);
//STRIP001 		SetUpdateMode(TRUE);
//STRIP001 	}
//STRIP001 	else
//STRIP001 	{
//STRIP001 		aGlobalTree.Hide();
//STRIP001 		aGlobalToolBox.Hide();
//STRIP001 		if(!_IsZoomedIn())
//STRIP001 		{
//STRIP001 			aContentTree.Show();
//STRIP001 			aContentToolBox.Show();
//STRIP001 			aDocListBox.Show();
//STRIP001 		}
//STRIP001 		bRet = FALSE;
//STRIP001 		SetGlobalMode(FALSE);
//STRIP001 	}
//STRIP001     return bRet;
//STRIP001 }

/*-----------------13.06.97 09:42-------------------

--------------------------------------------------*/
//STRIP001 BOOL 	SwNavigationPI::IsGlobalDoc() const
//STRIP001 {
//STRIP001 	BOOL bRet = FALSE;
//STRIP001     SwView *pView = GetCreateView();
//STRIP001 	if(pView)
//STRIP001 	{
//STRIP001 		SwWrtShell &rSh = pView->GetWrtShell();
//STRIP001 		bRet = rSh.IsGlobalDoc();
//STRIP001 	}
//STRIP001 	return bRet;
//STRIP001 }
/* -----------------26.10.98 08:10-------------------
 *
 * --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwNavigationPI, ChangePageHdl, Timer*, EMPTYARG )
//STRIP001 {
//STRIP001 	EditAction(&GetPageEdit());
//STRIP001 	GetPageEdit().GrabFocus();
//STRIP001 	return 0;
//STRIP001 }
/* -----------------26.10.98 08:14-------------------
 *
 * --------------------------------------------------*/
//STRIP001 IMPL_LINK( SwNavigationPI, PageEditModifyHdl, Edit*, EMPTYARG )
//STRIP001 {
//STRIP001 	if(aPageChgTimer.IsActive())
//STRIP001 		aPageChgTimer.Stop();
//STRIP001 	aPageChgTimer.Start();
//STRIP001 	return 0;
//STRIP001 }

/* -----------------------------23.04.01 07:34--------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 SwView*  SwNavigationPI::GetCreateView() const
//STRIP001 {
//STRIP001     if(!pCreateView)
//STRIP001     {
//STRIP001         SwView* pView = SwModule::GetFirstView();
//STRIP001         while(pView)
//STRIP001         {
//STRIP001             if(&pView->GetViewFrame()->GetBindings() == &rBindings)
//STRIP001             {
//STRIP001                 ((SwNavigationPI*)this)->pCreateView = pView;
//STRIP001                 ((SwNavigationPI*)this)->StartListening(*pCreateView);
//STRIP001                 break;
//STRIP001             }
//STRIP001             pView = SwModule::GetNextView(pView);
//STRIP001         }
//STRIP001     }
//STRIP001     return pCreateView;
//STRIP001 }


/*------------------------------------------------------------------------
 Beschreibung:
------------------------------------------------------------------------*/

/*N*/ SwNavigationChild::SwNavigationChild( Window* pParent,
/*N*/ 						USHORT nId,
/*N*/ 						SfxBindings* pBindings,
/*N*/ 						SfxChildWinInfo* pInfo )
/*N*/ 	: SfxChildWindowContext( nId )
/*N*/ {
DBG_BF_ASSERT(0, "STRIP"); //STRIP001 	SwNavigationPI* pNavi  = new SwNavigationPI( pBindings, this, pParent );
//STRIP001 	SetWindow( pNavi );
//STRIP001 	pBindings->Invalidate(SID_NAVIGATOR);
//STRIP001 	String sExtra = pInfo->aExtraString;
//STRIP001 
//STRIP001 	SwNavigationConfig* pNaviConfig = SW_MOD()->GetNavigationConfig();
//STRIP001 
//STRIP001 	USHORT nRootType = pNaviConfig->GetRootType();
//STRIP001 	if( nRootType < CONTENT_TYPE_MAX )
//STRIP001 	{
//STRIP001 		pNavi->aContentTree.SetRootType(nRootType);
//STRIP001 		pNavi->aContentToolBox.CheckItem(FN_SHOW_ROOT, TRUE);
//STRIP001 	}
//STRIP001 	pNavi->aContentTree.SetOutlineLevel(pNaviConfig->GetOutlineLevel());
//STRIP001 	pNavi->SetRegionDropMode(pNaviConfig->GetRegionMode());
//STRIP001 
//STRIP001 	if(GetFloatingWindow() && pNaviConfig->IsSmall())
//STRIP001 	{
//STRIP001 		pNavi->_ZoomIn();
//STRIP001 	}
/*N*/ }
/* -----------------------------06.05.2002 10:06------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 void SwNavigationPI::DataChanged( const DataChangedEvent& rDCEvt )
//STRIP001 {
//STRIP001     Window::DataChanged( rDCEvt );
//STRIP001     if ( (rDCEvt.GetType() == DATACHANGED_SETTINGS) &&
//STRIP001          (rDCEvt.GetFlags() & SETTINGS_STYLE) )
//STRIP001     {
//STRIP001         InitImageList();
//STRIP001         const StyleSettings& rStyleSettings = Application::GetSettings().GetStyleSettings();
//STRIP001         Color aBgColor = rStyleSettings.GetFaceColor();
//STRIP001         Wallpaper aBack( aBgColor );
//STRIP001         SetBackground( aBack );
//STRIP001     }
//STRIP001 }
/* -----------------------------06.05.2002 10:07------------------------------

 ---------------------------------------------------------------------------*/
//STRIP001 void SwNavigationPI::InitImageList()
//STRIP001 {
//STRIP001     ImageList& rImgLst = aContentToolBox.GetDisplayBackground().GetColor().IsDark() ?
//STRIP001                 aContentImageListH : aContentImageList;
//STRIP001     for(USHORT k = 0; k < aContentToolBox.GetItemCount(); k++)
//STRIP001 			aContentToolBox.SetItemImage(aContentToolBox.GetItemId(k),
//STRIP001                     rImgLst.GetImage(aContentToolBox.GetItemId(k)));
//STRIP001 
//STRIP001 	for( k = 0; k < aGlobalToolBox.GetItemCount(); k++)
//STRIP001 			aGlobalToolBox.SetItemImage(aGlobalToolBox.GetItemId(k),
//STRIP001                     rImgLst.GetImage(aGlobalToolBox.GetItemId(k)));
//STRIP001 
//STRIP001     USHORT nId = FN_DROP_REGION;
//STRIP001 	if(nRegionMode == REGION_MODE_LINK)
//STRIP001 		nId = FN_DROP_REGION_LINK;
//STRIP001 	else if(nRegionMode == REGION_MODE_EMBEDDED)
//STRIP001 		nId = FN_DROP_REGION_COPY;
//STRIP001     aContentToolBox.SetItemImage( FN_DROP_REGION,
//STRIP001                                     rImgLst.GetImage(nId));
//STRIP001 }

}
