/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: dinfdlg.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 12:12:24 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SFX_DINFDLG_HXX
#define _SFX_DINFDLG_HXX

#ifndef _SV_EDIT_HXX //autogen wg. Edit
#include <vcl/edit.hxx>
#endif
#ifndef _SV_FIELD_HXX //autogen wg. NumericField
#include <vcl/field.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen wg. FixedText, FixedInfo
#include <svtools/stdctrl.hxx>
#endif
#ifndef _SFXSTRITEM_HXX //autogen wg. SfxStringItem
#include <svtools/stritem.hxx>
#endif
#ifndef _SVEDIT_HXX //autogen wg. MultiLineEdit
#include <svtools/svmedit.hxx>
#endif

#include <bf_sfx2/tabdlg.hxx>
#include <bf_sfx2/docinf.hxx>
namespace binfilter {

// class SfxDocumentInfoItem ---------------------------------------------

class SfxDocumentInfoItem : public SfxStringItem
{
private:
	SfxDocumentInfo         aDocInfo;
	FASTBOOL                bHasTemplate;
	FASTBOOL                bOwnFormat;

public:
	TYPEINFO();
	SfxDocumentInfoItem();
//STRIP001 	SfxDocumentInfoItem( const String &rFileName, const SfxDocumentInfo &, BOOL );
//STRIP001 	SfxDocumentInfoItem( const String &rFileName, const SfxDocumentInfo & );
//STRIP001 	SfxDocumentInfoItem( const SfxDocumentInfoItem& );
//STRIP001 	virtual ~SfxDocumentInfoItem();

//STRIP001 	BOOL                    IsOwnFormat() const;

//STRIP001 	void                    SetTemplate( BOOL b ) { bHasTemplate = b; }
//STRIP001 	FASTBOOL                HasTemplate() const { return bHasTemplate; }
//STRIP001 	void					SetDeleteUserData( BOOL bSet );
//STRIP001 	BOOL					IsDeleteUserData() const;

//STRIP001 	SfxDocumentInfo&        operator()() { return aDocInfo; }
//STRIP001 	const SfxDocumentInfo&  operator()() const { return aDocInfo; }
//STRIP001 	SfxDocumentInfo&        GetDocInfo() { return aDocInfo; }
//STRIP001 	const SfxDocumentInfo&  GetDocInfo() const { return aDocInfo; }

//STRIP001 	virtual SfxPoolItem*    Clone( SfxItemPool* pPool = NULL ) const;
//STRIP001 	virtual int             operator==( const SfxPoolItem& ) const;
//STRIP001 	virtual	sal_Bool        	 QueryValue( ::com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 ) const;
//STRIP001 	virtual	sal_Bool			 PutValue( const ::com::sun::star::uno::Any& rVal, BYTE nMemberId = 0 );
};

// class SfxDocumentPage -------------------------------------------------

//STRIP001 class SfxDocumentPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedImage	aBmp1;
//STRIP001 	Edit		aNameED;
//STRIP001 
//STRIP001 	FixedLine 	aLine1FL;
//STRIP001 	FixedText 	aTypeFT;
//STRIP001 	FixedText 	aShowTypeFT;
//STRIP001 	CheckBox	aReadOnlyCB;
//STRIP001 	FixedText 	aFileFt;
//STRIP001 	FixedInfo 	aFileValFt;
//STRIP001 	FixedText 	aSizeFT;
//STRIP001 	FixedText 	aShowSizeFT;
//STRIP001 
//STRIP001 	FixedLine 	aLine2FL;
//STRIP001 	FixedText 	aCreateFt;
//STRIP001 	FixedInfo 	aCreateValFt;
//STRIP001 	FixedText 	aTimeLogFt;
//STRIP001 	FixedInfo 	aTimeLogValFt;
//STRIP001 	FixedText 	aChangeFt;
//STRIP001 	FixedInfo 	aChangeValFt;
//STRIP001 	FixedText 	aDocNoFt;
//STRIP001 	FixedInfo 	aDocNoValFt;
//STRIP001 	FixedText 	aPrintFt;
//STRIP001 	FixedInfo 	aPrintValFt;
//STRIP001 	PushButton  aDeleteBtn;
//STRIP001 	CheckBox	aUseUserDataCB;
//STRIP001 
//STRIP001 	FixedLine 	aLine3FL;
//STRIP001 	FixedText 	aTemplFt;
//STRIP001 	FixedInfo 	aTemplValFt;
//STRIP001 
//STRIP001 	String      aUnknownSize;
//STRIP001 	BOOL		bEnableUseUserData	: 1,
//STRIP001 				bHandleDelete		: 1;
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( DeleteHdl, PushButton * );
//STRIP001 #endif
//STRIP001 
//STRIP001 protected:
//STRIP001 	SfxDocumentPage( Window* pParent, const SfxItemSet& );
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void		Reset( const SfxItemSet& );
//STRIP001 
//STRIP001 public:
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& );
//STRIP001 
//STRIP001 	void				EnableUseUserData();
//STRIP001 };

// class SfxDocumentDescPage ---------------------------------------------

//STRIP001 class SfxDocumentDescPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	FixedText				aTitleFt;
//STRIP001 	Edit					aTitleEd;
//STRIP001 	FixedText				aThemaFt;
//STRIP001 	Edit					aThemaEd;
//STRIP001 	FixedText				aKeywordsFt;
//STRIP001 	Edit					aKeywordsEd;
//STRIP001 	FixedText				aCommentFt;
//STRIP001 	MultiLineEdit			aCommentEd;
//STRIP001 	SfxDocumentInfoItem*	pInfoItem;
//STRIP001 
//STRIP001 protected:
//STRIP001 	SfxDocumentDescPage( Window* pParent, const SfxItemSet& );
//STRIP001 
//STRIP001 	virtual BOOL        	FillItemSet( SfxItemSet& );
//STRIP001 	virtual void        	Reset( const SfxItemSet& );
//STRIP001 
//STRIP001 public:
//STRIP001 	static SfxTabPage*		Create( Window* pParent, const SfxItemSet& );
//STRIP001 };

// class SfxDocumentUserPage ---------------------------------------------

//STRIP001 class SfxDocumentUserPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 #if SUPD < 638
//STRIP001 	String					aShortcuts;
//STRIP001 #endif
//STRIP001 	BOOL					bLabelModified;
//STRIP001 
//STRIP001 	FixedText				aInfo1Ft;
//STRIP001 	Edit					aInfo1Ed;
//STRIP001 	FixedText				aInfo2Ft;
//STRIP001 	Edit					aInfo2Ed;
//STRIP001 	FixedText				aInfo3Ft;
//STRIP001 	Edit					aInfo3Ed;
//STRIP001 	FixedText				aInfo4Ft;
//STRIP001 	Edit					aInfo4Ed;
//STRIP001 	PushButton				aEditLabelBtn;
//STRIP001 	SfxDocumentInfoItem*	pInfoItem;
//STRIP001 
//STRIP001 #if _SOLAR__PRIVATE
//STRIP001 	DECL_LINK( EditLabelHdl, PushButton * );
//STRIP001 
//STRIP001 	String				GetLabelText_Impl( FixedText* pLabel );
//STRIP001 	void				SetLabelText_Impl( FixedText* pLabel, const String& rNewLabel );
//STRIP001 #endif
//STRIP001 
//STRIP001 protected:
//STRIP001 	SfxDocumentUserPage( Window* pParent, const SfxItemSet& );
//STRIP001 
//STRIP001 	virtual BOOL		FillItemSet( SfxItemSet& );
//STRIP001 	virtual void		Reset( const SfxItemSet& );
//STRIP001 
//STRIP001 public:
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& );
//STRIP001 };

// class SfxInternetPage -------------------------------------------------

class TargetList;

//STRIP001 class SfxInternetPage : public SfxTabPage
//STRIP001 {
//STRIP001 private:
//STRIP001 	RadioButton				aRBNoAutoUpdate;
//STRIP001 	RadioButton				aRBReloadUpdate;
//STRIP001 	RadioButton				aRBForwardUpdate;
//STRIP001 
//STRIP001 	FixedText				aFTEvery;
//STRIP001 	NumericField			aNFReload;
//STRIP001 	FixedText				aFTReloadSeconds;
//STRIP001 
//STRIP001 	FixedText				aFTAfter;
//STRIP001 	NumericField			aNFAfter;
//STRIP001 	FixedText				aFTAfterSeconds;
//STRIP001 	FixedText				aFTURL;
//STRIP001 	Edit					aEDForwardURL;
//STRIP001 	PushButton				aPBBrowseURL;
//STRIP001 	FixedText				aFTFrame;
//STRIP001 	ComboBox				aCBFrame;
//STRIP001 
//STRIP001 	String					aForwardErrorMessg;
//STRIP001 	SfxDocumentInfoItem*	pInfoItem;
//STRIP001 	enum STATE				{ S_Init, S_NoUpdate, S_Reload, S_Forward };
//STRIP001 							// S_Init is only valid as initial value
//STRIP001 	STATE					eState;
//STRIP001 
//STRIP001 	void					ChangeState( STATE eNewState );		// S_Init is not a valid value here
//STRIP001 																// also checks corresponding radiobutton
//STRIP001 	void					EnableNoUpdate( BOOL bEnable );
//STRIP001 	void					EnableReload( BOOL bEnable );
//STRIP001 	void					EnableForward( BOOL bEnable );
//STRIP001 
//STRIP001 	DECL_LINK( ClickHdlNoUpdate, Control* );
//STRIP001 	DECL_LINK( ClickHdlReload, Control* );
//STRIP001 	DECL_LINK( ClickHdlForward, Control* );
//STRIP001 	DECL_LINK( ClickHdlBrowseURL, PushButton* );
//STRIP001 
//STRIP001 protected:
//STRIP001 	SfxInternetPage( Window* pParent, const SfxItemSet& );
//STRIP001 
//STRIP001 	virtual BOOL			FillItemSet( SfxItemSet& );
//STRIP001 	virtual void			Reset( const SfxItemSet& );
//STRIP001 	virtual int				DeactivatePage( SfxItemSet* pSet = 0 );
//STRIP001 
//STRIP001 public:
//STRIP001 	static SfxTabPage*	Create( Window* pParent, const SfxItemSet& );
//STRIP001 };

// class SfxDocumentInfoDialog -------------------------------------------

//STRIP001 class SfxDocumentInfoDialog : public SfxTabDialog
//STRIP001 {
//STRIP001 protected:
//STRIP001 	virtual void	PageCreated( USHORT nId, SfxTabPage& rPage );
//STRIP001 
//STRIP001 public:
//STRIP001 	SfxDocumentInfoDialog(	Window* pParent, const SfxItemSet& );
//STRIP001 };

}//end of namespace binfilter
#endif

