/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: dlgctl3d.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:16:41 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_DLGCTL3D_HXX
#define _SVX_DLGCTL3D_HXX

// includes --------------------------------------------------------------

// auto strip #ifndef _TL_POLY_HXX
// auto strip #include <tools/poly.hxx>
// auto strip #endif

// auto strip #ifndef _SV_CTRL_HXX
// auto strip #include <vcl/ctrl.hxx>
// auto strip #endif

// auto strip #ifndef _B3D_B3DGEOM_HXX
// auto strip #include <goodies/b3dgeom.hxx>
// auto strip #endif

// auto strip #ifndef _B3D_B3DTRANS_HXX
// auto strip #include <goodies/b3dtrans.hxx>
// auto strip #endif

// auto strip #ifndef _B3D_MATRIL3D_HXX
// auto strip #include <goodies/matril3d.hxx>
// auto strip #endif

// auto strip #ifndef _B3D_B3DLIGHT_HXX
// auto strip #include <goodies/b3dlight.hxx>
// auto strip #endif

// auto strip #ifndef _SV_SCRBAR_HXX
// auto strip #include <vcl/scrbar.hxx>
// auto strip #endif

// auto strip #ifndef _SV_BUTTON_HXX
// auto strip #include <vcl/button.hxx>
// auto strip #endif

// auto strip #ifndef _SFXITEMSET_HXX //autogen
// auto strip #include <svtools/itemset.hxx>
// auto strip #endif
namespace binfilter {

//STRIP001 class Vector3D;
//STRIP001 class FmFormModel;
//STRIP001 class FmFormPage;
//STRIP001 class E3dView;
//STRIP001 class E3dPolyScene;
//STRIP001 class E3dObject;

/*************************************************************************
|*
|*	Control zur Darstellung einer 3D-Scene
|*
\************************************************************************/

//STRIP001 #define	PREVIEW_OBJECTTYPE_SPHERE			0x0000
//STRIP001 #define	PREVIEW_OBJECTTYPE_CUBE  			0x0001

//STRIP001 class Svx3DPreviewControl : public Control
//STRIP001 {
//STRIP001 protected:
//STRIP001 	FmFormModel*		pModel;
//STRIP001 	FmFormPage*			pFmPage;
//STRIP001 	E3dView*			p3DView;
//STRIP001 	E3dPolyScene*		pScene;
//STRIP001 	E3dObject*			p3DObj;
//STRIP001 	UINT16				nObjectType;
//STRIP001 
//STRIP001 	void				Construct();
//STRIP001 
//STRIP001 public:
//STRIP001 					Svx3DPreviewControl( Window* pParent, const ResId& rResId );
//STRIP001 					Svx3DPreviewControl( Window* pParent, WinBits nStyle = 0 );
//STRIP001 					~Svx3DPreviewControl();
//STRIP001 
//STRIP001 	virtual void 	Paint( const Rectangle& rRect );
//STRIP001 	virtual void 	MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void	Resize();
//STRIP001 
//STRIP001 	void			Reset();
//STRIP001 
//STRIP001 	void			SetObjectType( UINT16 nType );
//STRIP001 	UINT16			GetObjectType() const { return( nObjectType ); }
//STRIP001 
//STRIP001 	SfxItemSet		Get3DAttributes() const;
//STRIP001 	void			Set3DAttributes( const SfxItemSet& rAttr );
//STRIP001 
//STRIP001 	void			Set3DObject( const E3dObject* pObj );
//STRIP001 };

/*************************************************************************
|*
|*	Control zur Darstellung und Auswahl der Eckpunkte (und Mittelpunkt)
|*	eines Objekts
|*
\************************************************************************/
//STRIP001 class SvxRectCtl3D : public Control
//STRIP001 {
//STRIP001 protected:
//STRIP001 	long		nBW; // BorderWidth
//STRIP001 	long		nBH; // BorderHeight
//STRIP001 	USHORT		nRadius;
//STRIP001 	Size		aSize;
//STRIP001 	short		nActPoint;
//STRIP001 	short		nOldPoint;
//STRIP001 	short 		nDist;
//STRIP001 	Point		aPointArray[20];
//STRIP001 	Point 		aPolyPoints1[4];
//STRIP001 	Point 		aPolyPoints2[4];
//STRIP001 	Point 		aPolyPoints3[4];
//STRIP001 	Polygon 	aPoly1;
//STRIP001 	Polygon 	aPoly2;
//STRIP001 	Polygon 	aPoly3;
//STRIP001 
//STRIP001 	Vector3D	PointNumToVector( short nPoint );
//STRIP001 	short 		VectorToPointNum( Vector3D aVect );
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxRectCtl3D( Window* pParent,
//STRIP001 				  const ResId& rResId,
//STRIP001 				  USHORT nBorderW = 200,
//STRIP001 				  USHORT nBorderH = 200,
//STRIP001 				  USHORT nCircle = 80 );
//STRIP001 	~SvxRectCtl3D();
//STRIP001 
//STRIP001 	virtual void Paint( const Rectangle& rRect );
//STRIP001 	virtual void MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 
//STRIP001 	void		Reset();
//STRIP001 	Vector3D	GetVector();
//STRIP001 	void		SetPoint( Vector3D aVect );
//STRIP001 };

/*************************************************************************
|*
|*	3D Preview Control
|*
\************************************************************************/

// Defines fuer NormalMode
//STRIP001 #define	PREVIEW_NORMAL_MODE_OBJECT			0x0000
//STRIP001 #define	PREVIEW_NORMAL_MODE_FLAT			0x0001
//STRIP001 #define	PREVIEW_NORMAL_MODE_SPHERE			0x0002

// Defines fuer ShadeMode
//STRIP001 #define	PREVIEW_SHADEMODE_FLAT				0x0000
//STRIP001 #define	PREVIEW_SHADEMODE_PHONG				0x0001
//STRIP001 #define	PREVIEW_SHADEMODE_GOURAUD			0x0002
//STRIP001 #define	PREVIEW_SHADEMODE_DRAFT				0x0003

//STRIP001 class SvxPreviewCtl3D : public Control
//STRIP001 {
//STRIP001 protected:
//STRIP001 	// Geometrie des Objektes
//STRIP001 	B3dGeometry				aGeometry;
//STRIP001 
//STRIP001 	// Kameraset
//STRIP001 	B3dCamera				aCameraSet;
//STRIP001 	double					fDistance;
//STRIP001 	double					fDeviceSize;
//STRIP001 
//STRIP001 	// Rotation der Geometrie (bei Cube)
//STRIP001 	double					fRotateX;
//STRIP001 	double					fRotateY;
//STRIP001 	double					fRotateZ;
//STRIP001 
//STRIP001 	// Farben des Objektes
//STRIP001 	B3dMaterial				aObjectMaterial;
//STRIP001 
//STRIP001 	// Lichtquellen
//STRIP001 	B3dLightGroup			aLights;
//STRIP001 
//STRIP001 	// Segmentierung, wird bei Kugel verwendet
//STRIP001 	UINT16					nHorSegs;
//STRIP001 	UINT16					nVerSegs;
//STRIP001 
//STRIP001 	// Modus fuer Normalen
//STRIP001 	UINT16					nNormalMode;
//STRIP001 
//STRIP001 	// Zeichenmodus
//STRIP001 	UINT16					nShadeMode;
//STRIP001 
//STRIP001 	// Art der Geometrie, Cube oder Sphere
//STRIP001 	BOOL					bGeometryCube;
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxPreviewCtl3D( Window* pParent, const ResId& rResId);
//STRIP001 	SvxPreviewCtl3D( Window* pParent, WinBits nStyle = 0);
//STRIP001 	~SvxPreviewCtl3D();
//STRIP001 
//STRIP001 	// Zeichenmethode
//STRIP001 	virtual void Paint( const Rectangle& rRect );
//STRIP001 	void DrawGeometryClip(Base3D* pBase3D);
//STRIP001 	virtual void DrawGeometry(Base3D* pBase3D);
//STRIP001 
//STRIP001 	// Art der Geometrie setzen
//STRIP001 	void SetGeometry(BOOL bGeomCube);
//STRIP001 
//STRIP001 	// Rotation setzen
//STRIP001 	void SetRotation(double fRotX, double fRotY, double fRotZ);
//STRIP001 	void GetRotation(double& rRotX, double& rRotY, double& rRotZ);
//STRIP001 
//STRIP001 	// Zugriffsfunktionen Materialien
//STRIP001 	void SetMaterial(Color rNew,
//STRIP001 		Base3DMaterialValue=Base3DMaterialAmbient);
//STRIP001 	Color GetMaterial(Base3DMaterialValue=Base3DMaterialAmbient);
//STRIP001 	void SetShininess(UINT16 nNew);
//STRIP001 	UINT16 GetShininess();
//STRIP001 
//STRIP001 	// Lichtquellen setzen
//STRIP001 	void SetLightGroup(B3dLightGroup* pNew=0L);
//STRIP001 	B3dLightGroup* GetLightGroup() { return &aLights; }
//STRIP001 
//STRIP001 	// View-Einstellungen
//STRIP001 	void SetUserDistance(double fNew);
//STRIP001 	double GetUserDistance() { return fDistance; }
//STRIP001 	void SetDeviceSize(double fNew);
//STRIP001 	double GetDeviceSize() { return fDeviceSize; }
//STRIP001 
//STRIP001 	// Zugriffsfunktionen Segmentierung
//STRIP001 	UINT16 GetHorizontalSegments() { return nHorSegs; }
//STRIP001 	UINT16 GetVerticalSegments() { return nVerSegs; }
//STRIP001 	void SetHorizontalSegments(UINT16 nNew);
//STRIP001 	void SetVerticalSegments(UINT16 nNew);
//STRIP001 	void SetSegments(UINT16 nNewHor, UINT16 nNewVer);
//STRIP001 
//STRIP001 	// Zugriff Normalenmodus
//STRIP001 	UINT16 GetNormalMode() { return nNormalMode; }
//STRIP001 	void SetNormalMode(UINT16 nNew);
//STRIP001 
//STRIP001 	// Zugriff auf ShadeMode
//STRIP001 	UINT16 GetShadeMode() { return nShadeMode; }
//STRIP001 	void SetShadeMode(UINT16 nNew);
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	// Geometrieerzeugung
//STRIP001 	void CreateGeometry();
//STRIP001 
//STRIP001 	// Lokale Parameter Initialisieren
//STRIP001 	void Init();
//STRIP001 };

/*************************************************************************
|*
|*	3D Light Preview Control
|*
\************************************************************************/

//STRIP001 class SvxLightPrevievCtl3D : public SvxPreviewCtl3D
//STRIP001 {
//STRIP001 private:
//STRIP001 	// Geometrie eines Lichtobjektes
//STRIP001 	B3dGeometry			aLightGeometry;
//STRIP001 
//STRIP001 	Base3DLightNumber	eSelectedLight;
//STRIP001 
//STRIP001 	// Werte fuer Rendering
//STRIP001 	double				fObjectRadius;
//STRIP001 	double				fDistanceToObject;
//STRIP001 	double				fScaleSizeSelected;
//STRIP001 	double				fLampSize;
//STRIP001 
//STRIP001 	// Callback bei interaktiven Aenderungen
//STRIP001 	Link				aChangeCallback;
//STRIP001 	Link				aSelectionChangeCallback;
//STRIP001 
//STRIP001 	// Sichern der Interaktion
//STRIP001 	double				fSaveActionStartHor;
//STRIP001 	double				fSaveActionStartVer;
//STRIP001 	double				fSaveActionStartRotZ;
//STRIP001 	Point				aActionStartPoint;
//STRIP001 
//STRIP001 	// Mindestentfernung fuer Interaktionsstart
//STRIP001 	INT32				nInteractionStartDistance;
//STRIP001 
//STRIP001 	// Maus-Status
//STRIP001 	unsigned			bMouseMoved						: 1;
//STRIP001 	unsigned			bGeometrySelected				: 1;
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxLightPrevievCtl3D( Window* pParent, const ResId& rResId);
//STRIP001 	SvxLightPrevievCtl3D( Window* pParent, WinBits nStyle = 0);
//STRIP001 	~SvxLightPrevievCtl3D();
//STRIP001 
//STRIP001 	void SelectLight(Base3DLightNumber=Base3DLightNone);
//STRIP001 	Base3DLightNumber GetSelectedLight() { return eSelectedLight; }
//STRIP001 
//STRIP001 	void SelectGeometry();
//STRIP001 	BOOL IsGeometrySelected() { return bGeometrySelected; }
//STRIP001 
//STRIP001 	void SetObjectRadius(double fNew);
//STRIP001 	double GetObjectRadius() { return fObjectRadius; }
//STRIP001 
//STRIP001 	void SetDistanceToObject(double fNew);
//STRIP001 	double GetDistanceToObject() { return fDistanceToObject; }
//STRIP001 
//STRIP001 	void SetScaleSizeSelected(double fNew);
//STRIP001 	double GetScaleSizeSelected() { return fScaleSizeSelected; }
//STRIP001 
//STRIP001 	void SetLampSize(double fNew);
//STRIP001 	double GetLampSize() { return fLampSize; }
//STRIP001 
//STRIP001 	// Zeichenmethode
//STRIP001 	virtual void DrawGeometry(Base3D* pBase3D);
//STRIP001 	void DrawLightGeometry(Base3DLightNumber eLightNum, Base3D* pBase3D);
//STRIP001 
//STRIP001 	// Selektion gueltig
//STRIP001 	BOOL IsSelectionValid();
//STRIP001 
//STRIP001 	// Selektierte Lampe Position in Polarkoordinaten holen/setzen
//STRIP001 	// dabei geht Hor:[0..360.0[ und Ver:[-90..90] Grad
//STRIP001 	void GetPosition(double& rHor, double& rVer);
//STRIP001 	void SetPosition(double fHor, double fVer);
//STRIP001 
//STRIP001 	// Callback eintragen
//STRIP001 	void SetChangeCallback(Link aNew) { aChangeCallback = aNew; }
//STRIP001 	void SetSelectionChangeCallback(Link aNew) { aSelectionChangeCallback = aNew; }
//STRIP001 
//STRIP001 	// Interaktion
//STRIP001 	virtual void		MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void		Tracking( const TrackingEvent& rTEvt );
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	// Geometrieerzeugung Lampe
//STRIP001 	void CreateLightGeometry();
//STRIP001 
//STRIP001 	// Selektion einer Lampe
//STRIP001 	void TrySelection(Point aPosPixel);
//STRIP001 
//STRIP001 	// Lokale Parameter Initialisieren
//STRIP001 	void Init();
//STRIP001 };

/*************************************************************************
|*
|*	3D Light Control
|*
\************************************************************************/

//STRIP001 class SvxLightCtl3D : public Control
//STRIP001 {
//STRIP001 private:
//STRIP001 	// Lokale Controls
//STRIP001 	SvxLightPrevievCtl3D	aLightControl;
//STRIP001 	ScrollBar				aHorScroller;
//STRIP001 	ScrollBar				aVerScroller;
//STRIP001 	PushButton				aSwitcher;
//STRIP001 	Vector3D				aVector;
//STRIP001 
//STRIP001 // Callback bei interaktiven Aenderungen
//STRIP001 	Link					aUserInteractiveChangeCallback;
//STRIP001 	Link					aUserSelectionChangeCallback;
//STRIP001 
//STRIP001 	// Flags
//STRIP001 	unsigned				bVectorValid					: 1;
//STRIP001 	unsigned				bSphereUsed						: 1;
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxLightCtl3D( Window* pParent, const ResId& rResId);
//STRIP001 	SvxLightCtl3D( Window* pParent, WinBits nStyle = 0);
//STRIP001 	~SvxLightCtl3D();
//STRIP001 
//STRIP001 	// Altes Interface
//STRIP001 	void SetVector(const Vector3D& rNew);
//STRIP001 	const Vector3D& GetVector();
//STRIP001 	BOOL GetVectorValid() { return bVectorValid; }
//STRIP001 
//STRIP001 	// Reagiere auf Groessenaenderungen
//STRIP001 	virtual void		Resize();
//STRIP001 	void NewLayout();
//STRIP001 
//STRIP001 	// Selektion auf Gueltigkeit pruefen
//STRIP001 	void CheckSelection();
//STRIP001 
//STRIP001 	// Um weitere Einstellungen nach Aussen zu bringen...
//STRIP001 	SvxLightPrevievCtl3D& GetPreviewControl() { return aLightControl; }
//STRIP001 
//STRIP001 	// User Callback eintragen
//STRIP001 	void SetUserInteractiveChangeCallback(Link aNew)
//STRIP001 		{ aUserInteractiveChangeCallback = aNew; }
//STRIP001 	void SetUserSelectionChangeCallback(Link aNew)
//STRIP001 		{ aUserSelectionChangeCallback = aNew; }
//STRIP001 
//STRIP001 	virtual void KeyInput( const KeyEvent& rKEvt );
//STRIP001     virtual void GetFocus();
//STRIP001     virtual void LoseFocus();
//STRIP001 
//STRIP001 	// ...um Kompatibel zu bleiben, kann spaeter wieder raus
//STRIP001 	//DECL_LINK( InteractiveChange, void*);
//STRIP001 	//DECL_LINK( SelectionChange, void*);
//STRIP001 
//STRIP001 protected:
//STRIP001 
//STRIP001 	DECL_LINK( InternalInteractiveChange, void*);
//STRIP001 	DECL_LINK( InternalSelectionChange, void*);
//STRIP001 	DECL_LINK( ScrollBarMove, void*);
//STRIP001 	DECL_LINK( ButtonPress, void*);
//STRIP001 
//STRIP001 	// Lokale Parameter Initialisieren
//STRIP001 	void Init();
//STRIP001 
//STRIP001 	void move( double fDeltaHor, double fDeltaVer );
//STRIP001 };

}//end of namespace binfilter
#endif // _SCH_DLGCTL3D_HXX

