/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: float3d.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:26:02 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/

#ifndef _SVX_FLOAT3D_HXX
#define _SVX_FLOAT3D_HXX

#ifndef _SFXCTRLITEM_HXX //autogen
#include <bf_sfx2/ctrlitem.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _FIELD_HXX //autogen
#include <vcl/field.hxx>
#endif
#ifndef _SFXDOCKWIN_HXX //autogen
#include <bf_sfx2/dockwin.hxx>
#endif
#ifndef _IMAGEBTN_HXX //autogen
#include <vcl/imagebtn.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
#ifndef _STDCTRL_HXX //autogen
#include <svtools/stdctrl.hxx>
#endif

#include <bf_svx/f3dchild.hxx>
#include <bf_svx/dlgctl3d.hxx>
#include <bf_svx/dlgctrl.hxx>
#include <bf_svx/svdmodel.hxx>
class VirtualDevice;
namespace binfilter {

enum ViewType3D
{
	VIEWTYPE_FAVORITES = 1,
	VIEWTYPE_GEO,
	VIEWTYPE_REPRESENTATION,
	VIEWTYPE_LIGHT,
	VIEWTYPE_TEXTURE,
	VIEWTYPE_MATERIAL
};

class SdrModel;
class B3dLightGroup;

class FmFormModel;
class FmFormPage;
class E3dView;
class SdrPageView;
class SvxConvertTo3DItem;

//------------------------------------------------------------------------
struct Svx3DWinImpl;

//STRIP001 class Svx3DWin : public SfxDockingWindow
//STRIP001 {
//STRIP001 	friend class		Svx3DChildWindow;
//STRIP001 	friend class		Svx3DCtrlItem;
//STRIP001 
//STRIP001 private:
//STRIP001 	ImageButton			aBtnFavorites;
//STRIP001 	ImageButton			aBtnGeo;
//STRIP001 	ImageButton			aBtnRepresentation;
//STRIP001 	ImageButton			aBtnLight;
//STRIP001 	ImageButton			aBtnTexture;
//STRIP001 	ImageButton			aBtnMaterial;
//STRIP001 	ImageButton			aBtnUpdate;
//STRIP001 	ImageButton			aBtnAssign;
//STRIP001 
//STRIP001 // Favoriten
//STRIP001     FixedLine           aFLFavorites;
//STRIP001 	ValueSet			aCtlFavorites;
//STRIP001 	ImageButton			aBtnOnly3D;
//STRIP001 	ImageButton			aBtnAllAttributes;
//STRIP001 
//STRIP001 // Geometrie
//STRIP001 	FixedText			aFtPercentDiagonal;
//STRIP001 	MetricField			aMtrPercentDiagonal;
//STRIP001 	FixedText			aFtBackscale;
//STRIP001 	MetricField			aMtrBackscale;
//STRIP001 	FixedText			aFtEndAngle;
//STRIP001 	MetricField			aMtrEndAngle;
//STRIP001 	FixedText			aFtDepth;
//STRIP001 	MetricField			aMtrDepth;
//STRIP001     FixedLine           aFLGeometrie;
//STRIP001 
//STRIP001 	FixedText			aFtHorizontal;
//STRIP001 	NumericField		aNumHorizontal;
//STRIP001 	FixedText			aFtVertical;
//STRIP001 	NumericField		aNumVertical;
//STRIP001     FixedLine           aFLSegments;
//STRIP001 
//STRIP001 	ImageButton			aBtnNormalsObj;
//STRIP001 	ImageButton			aBtnNormalsFlat;
//STRIP001 	ImageButton			aBtnNormalsSphere;
//STRIP001 	ImageButton			aBtnNormalsInvert;
//STRIP001 	ImageButton			aBtnTwoSidedLighting;
//STRIP001     FixedLine           aFLNormals;
//STRIP001 
//STRIP001 	ImageButton			aBtnDoubleSided;
//STRIP001 
//STRIP001 // Darstellung
//STRIP001 	FixedText			aFtShademode;
//STRIP001 	ListBox				aLbShademode;
//STRIP001 	ImageButton			aBtnShadow3d;
//STRIP001 	FixedText			aFtSlant;
//STRIP001 	MetricField			aMtrSlant;
//STRIP001     FixedLine           aFLShadow;
//STRIP001 	FixedText			aFtDistance;
//STRIP001 	MetricField			aMtrDistance;
//STRIP001 	FixedText			aFtFocalLeng;
//STRIP001 	MetricField			aMtrFocalLength;
//STRIP001     FixedLine           aFLCamera;
//STRIP001     FixedLine           aFLRepresentation;
//STRIP001 
//STRIP001 // Beleuchtung
//STRIP001 	ImageButton			aBtnLight1;
//STRIP001 	ImageButton			aBtnLight2;
//STRIP001 	ImageButton			aBtnLight3;
//STRIP001 	ImageButton			aBtnLight4;
//STRIP001 	ImageButton			aBtnLight5;
//STRIP001 	ImageButton			aBtnLight6;
//STRIP001 	ImageButton			aBtnLight7;
//STRIP001 	ImageButton			aBtnLight8;
//STRIP001 	ColorLB				aLbLight1;
//STRIP001 	ColorLB				aLbLight2;
//STRIP001 	ColorLB				aLbLight3;
//STRIP001 	ColorLB				aLbLight4;
//STRIP001 	ColorLB				aLbLight5;
//STRIP001 	ColorLB				aLbLight6;
//STRIP001 	ColorLB				aLbLight7;
//STRIP001 	ColorLB				aLbLight8;
//STRIP001 
//STRIP001 	ImageButton			aBtnLightColor;
//STRIP001     FixedText           aFTLightsource;
//STRIP001 
//STRIP001 	// #99694# Keyboard shortcuts activate the next control, so the
//STRIP001 	// order needed to be changed here
//STRIP001     FixedText           aFTAmbientlight;	// Text label
//STRIP001 	ColorLB				aLbAmbientlight;	// ListBox
//STRIP001 	ImageButton			aBtnAmbientColor;	// color button
//STRIP001     
//STRIP001 	FixedLine           aFLLight;
//STRIP001 
//STRIP001 // Texturen
//STRIP001 	FixedText			aFtTexKind;
//STRIP001 	ImageButton			aBtnTexLuminance;
//STRIP001 	ImageButton			aBtnTexColor;
//STRIP001 	FixedText			aFtTexMode;
//STRIP001 	ImageButton			aBtnTexReplace;
//STRIP001 	ImageButton			aBtnTexModulate;
//STRIP001 	ImageButton			aBtnTexBlend;
//STRIP001 	FixedText			aFtTexProjectionX;
//STRIP001 	ImageButton			aBtnTexObjectX;
//STRIP001 	ImageButton			aBtnTexParallelX;
//STRIP001 	ImageButton			aBtnTexCircleX;
//STRIP001 	FixedText			aFtTexProjectionY;
//STRIP001 	ImageButton			aBtnTexObjectY;
//STRIP001 	ImageButton			aBtnTexParallelY;
//STRIP001 	ImageButton			aBtnTexCircleY;
//STRIP001 	FixedText			aFtTexFilter;
//STRIP001 	ImageButton			aBtnTexFilter;
//STRIP001     FixedLine           aFLTexture;
//STRIP001 
//STRIP001 // Material
//STRIP001 	//ValueSet			aCtlMaterial;
//STRIP001 // Materialeditor
//STRIP001 	FixedText			aFtMatFavorites;
//STRIP001 	ListBox  			aLbMatFavorites;
//STRIP001 	FixedText			aFtMatColor;
//STRIP001 	ColorLB				aLbMatColor;
//STRIP001 	ImageButton			aBtnMatColor;
//STRIP001 	FixedText			aFtMatEmission;
//STRIP001 	ColorLB				aLbMatEmission;
//STRIP001 	ImageButton			aBtnEmissionColor;
//STRIP001 	FixedText			aFtMatSpecular;
//STRIP001 	ColorLB				aLbMatSpecular;
//STRIP001 	ImageButton			aBtnSpecularColor;
//STRIP001 	FixedText			aFtMatSpecularIntensity;
//STRIP001 	MetricField			aMtrMatSpecularIntensity;
//STRIP001     FixedLine           aFLMatSpecular;
//STRIP001     FixedLine           aFLMaterial;
//STRIP001 
//STRIP001 	//ImageButton			aBtnMatFavorites;
//STRIP001 	//ImageButton			aBtnMatEditor;
//STRIP001 
//STRIP001 // Unterer Teil
//STRIP001 	ImageButton			aBtnConvertTo3D;
//STRIP001 	ImageButton			aBtnLatheObject;
//STRIP001 	ImageButton			aBtnPerspective;
//STRIP001 	//SvxPreviewCtl3D		aCtlPreview;
//STRIP001 	Svx3DPreviewControl	aCtlPreview;
//STRIP001 	SvxLightCtl3D		aCtlLightPreview; // <-- Probleme mit Select/Change-Hdl, wenn ueberladen
//STRIP001 	//SvxLightPrevievCtl3D	aCtlLightPreview;
//STRIP001 
//STRIP001 // der Rest ...
//STRIP001 	B3dLightGroup*		pLightGroup;
//STRIP001 	Image				aImgLightOn;
//STRIP001 	Image				aImgLightOff;
//STRIP001 //	Image				aImgLightOnSelected;
//STRIP001 //	Image				aImgLightOffSelected;
//STRIP001 	BOOL				bUpdate;
//STRIP001 	ViewType3D			eViewType;
//STRIP001 	Size				aSize;
//STRIP001 
//STRIP001 	// Model, Page, View etc. fuer Favoriten
//STRIP001 	FmFormModel*		pModel;
//STRIP001 	FmFormPage*			pFmPage;
//STRIP001 	VirtualDevice*		pVDev;
//STRIP001 	E3dView*			p3DView;
//STRIP001 	List*				pFavorSetList;
//STRIP001 	List*				pMatFavSetList;
//STRIP001 
//STRIP001 	SfxBindings*				pBindings;
//STRIP001 	Svx3DCtrlItem*				pControllerItem;
//STRIP001 
//STRIP001 	SvxConvertTo3DItem*			pConvertTo3DItem;
//STRIP001 	SvxConvertTo3DItem*			pConvertTo3DLatheItem;
//STRIP001 
//STRIP001 	Svx3DWinImpl*		mpImpl;
//STRIP001 //	SfxItemPool*		pPool;
//STRIP001 	SfxMapUnit          ePoolUnit;
//STRIP001 	FieldUnit           eFUnit;
//STRIP001 
//STRIP001 	// ItemSet used to remember set 2d attributes
//STRIP001 	SfxItemSet*			mpRemember2DAttributes;
//STRIP001 
//STRIP001 	BOOL				bOnly3DChanged;
//STRIP001 
//STRIP001 	//------------------------------------
//STRIP001 
//STRIP001 	DECL_LINK( ClickViewTypeHdl, void * );
//STRIP001 	DECL_LINK( ClickUpdateHdl, void * );
//STRIP001 	DECL_LINK( ClickAssignHdl, void * );
//STRIP001 	DECL_LINK( ClickHdl, PushButton * );
//STRIP001 	DECL_LINK( ClickColorHdl, PushButton * );
//STRIP001 	DECL_LINK( SelectHdl, void * );
//STRIP001 	DECL_LINK( ModifyHdl, void * );
//STRIP001 	DECL_LINK( ClickLightHdl, PushButton * );
//STRIP001 
//STRIP001 	DECL_LINK( ClickFavoriteHdl, void * );
//STRIP001 	//DECL_LINK( ClickMatFavHdl, void * );
//STRIP001 	DECL_LINK( DoubleClickHdl, void * );
//STRIP001 
//STRIP001 	DECL_LINK( ChangeLightCallbackHdl, void * );
//STRIP001 	DECL_LINK( ChangeSelectionCallbackHdl, void * );
//STRIP001 
//STRIP001 
//STRIP001 	void			Construct();
//STRIP001 	void			Reset();
//STRIP001 
//STRIP001 	BOOL			LBSelectColor( ColorLB* pLb, const Color& rColor );
//STRIP001 	USHORT			GetLightSource( const PushButton* pBtn = NULL );
//STRIP001 	ColorLB*		GetLbByButton( const PushButton* pBtn = NULL );
//STRIP001     
//STRIP001 	bool			GetUILightState( ImageButton& aBtn ) const;
//STRIP001 	void			SetUILightState( ImageButton& aBtn, bool bState );
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void	Resize();
//STRIP001 
//STRIP001 public:
//STRIP001 			Svx3DWin( SfxBindings* pBindings, SfxChildWindow *pCW,
//STRIP001 						Window* pParent );
//STRIP001 			~Svx3DWin();
//STRIP001 
//STRIP001 	void	InitColorLB( const SdrModel* pDoc );
//STRIP001 	BOOL	IsUpdateMode() const { return bUpdate; }
//STRIP001 
//STRIP001 	void	Update( SfxItemSet& rSet );
//STRIP001 	void	GetAttr( SfxItemSet& rSet );
//STRIP001 
//STRIP001 	void UpdatePreview(); // nach oben (private)
//STRIP001 	void DocumentReload(); // #83951#
//STRIP001 };

/*************************************************************************
|*
|* ControllerItem fuer 3D-Window (Floating/Docking)
|*
\************************************************************************/

//STRIP001 class Svx3DCtrlItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	Svx3DWin* p3DWin;
//STRIP001 
//STRIP001  protected:
//STRIP001 	virtual void StateChanged( USHORT nSId, SfxItemState eState,
//STRIP001 								const SfxPoolItem* pState );
//STRIP001 
//STRIP001  public:
//STRIP001 	Svx3DCtrlItem( USHORT, Svx3DWin*, SfxBindings* );
//STRIP001 };

/*************************************************************************
|*
|* ControllerItem fuer Status eines Slots
|* (SID_CONVERT_TO_3D, SID_CONVERT_TO_3D_LATHE_FAST)
|*
\************************************************************************/

//STRIP001 class SvxConvertTo3DItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	BOOL						bState;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void StateChanged(UINT16 nSId, SfxItemState eState, const SfxPoolItem* pState);
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxConvertTo3DItem(UINT16 nId, SfxBindings* pBindings);
//STRIP001 	BOOL GetState() const { return bState; }
//STRIP001 };

}//end of namespace binfilter
#endif		// _SVX_FLOAT3D_HXX

