/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: fontwork.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:31:28 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_FONTWORK_HXX
#define _SVX_FONTWORK_HXX

// include ---------------------------------------------------------------

#ifndef _TOOLBOX_HXX //autogen
#include <vcl/toolbox.hxx>
#endif
#ifndef _FIXED_HXX //autogen
#include <vcl/fixed.hxx>
#endif
#ifndef _VALUESET_HXX //autogen
#include <svtools/valueset.hxx>
#endif
#ifndef _SFXDOCKWIN_HXX //autogen
#include <bf_sfx2/dockwin.hxx>
#endif
#ifndef _SFXCTRLITEM_HXX //autogen
#include <bf_sfx2/ctrlitem.hxx>
#endif
#ifndef _XENUM_HXX
#include <bf_svx/xenum.hxx>
#endif
#ifndef _SVX_DLG_CTRL_HXX
#include <bf_svx/dlgctrl.hxx>
#endif
namespace binfilter {

// forward ---------------------------------------------------------------

//STRIP001 class SdrView;
//STRIP001 class SdrPageView;
//STRIP001 class SdrObject;

//STRIP001 class XFormTextAdjustItem;
//STRIP001 class XFormTextDistanceItem;
//STRIP001 class XFormTextStartItem;
//STRIP001 class XFormTextMirrorItem;
//STRIP001 class XFormTextStdFormItem;
//STRIP001 class XFormTextHideFormItem;
//STRIP001 class XFormTextOutlineItem;
//STRIP001 class XFormTextShadowItem;
//STRIP001 class XFormTextShadowColorItem;
//STRIP001 class XFormTextShadowXValItem;
//STRIP001 class XFormTextShadowYValItem;

/*************************************************************************
|*
|* ControllerItem fuer Fontwork
|*
\************************************************************************/

//STRIP001 class SvxFontWorkDialog;

//STRIP001 class SvxFontWorkControllerItem : public SfxControllerItem
//STRIP001 {
//STRIP001 	SvxFontWorkDialog  &rFontWorkDlg;
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void StateChanged(USHORT nSID, SfxItemState eState,
//STRIP001 							  const SfxPoolItem* pState);
//STRIP001 
//STRIP001 public:
//STRIP001 	SvxFontWorkControllerItem(USHORT nId, SvxFontWorkDialog&, SfxBindings&);
//STRIP001 };

/*************************************************************************
|*
|* Ableitung vom SfxChildWindow als "Behaelter" fuer Fontwork-Dialog
|*
\************************************************************************/

class SvxFontWorkChildWindow : public SfxChildWindow
{
 public:
	SvxFontWorkChildWindow(Window*, USHORT, SfxBindings*, SfxChildWinInfo*);
	SFX_DECL_CHILDWINDOW(SvxFontWorkChildWindow);
};

/*************************************************************************
|*
|* Floating Window zur Attributierung von Texteffekten
|*
\************************************************************************/

//STRIP001 class SvxFontWorkDialog : public SfxDockingWindow
//STRIP001 {
//STRIP001  #define CONTROLLER_COUNT 12
//STRIP001 
//STRIP001 	SvxFontWorkControllerItem* pCtrlItems[CONTROLLER_COUNT];
//STRIP001 
//STRIP001 	ValueSet		aFormSet;
//STRIP001 
//STRIP001 	ToolBox			aTbxStyle;
//STRIP001 	ToolBox			aTbxAdjust;
//STRIP001 
//STRIP001 	FixedImage		aFbDistance;
//STRIP001 	MetricField		aMtrFldDistance;
//STRIP001 	FixedImage		aFbTextStart;
//STRIP001 	MetricField		aMtrFldTextStart;
//STRIP001 
//STRIP001 	ToolBox			aTbxShadow;
//STRIP001 
//STRIP001 	FixedImage		aFbShadowX;
//STRIP001 	MetricField		aMtrFldShadowX;
//STRIP001 	FixedImage		aFbShadowY;
//STRIP001 	MetricField		aMtrFldShadowY;
//STRIP001 
//STRIP001 	ColorLB			aShadowColorLB;
//STRIP001 
//STRIP001 	SfxBindings&	rBindings;
//STRIP001 	Timer			aInputTimer;
//STRIP001 	BOOL			bUserZoomedIn;
//STRIP001 
//STRIP001 	USHORT			nLastStyleTbxId;
//STRIP001 	USHORT			nLastAdjustTbxId;
//STRIP001 	USHORT			nLastShadowTbxId;
//STRIP001 	long			nSaveShadowX;
//STRIP001 	long			nSaveShadowY;
//STRIP001 	long			nSaveShadowAngle;
//STRIP001 	long			nSaveShadowSize;
//STRIP001 
//STRIP001 	ImageList		maImageList;
//STRIP001 	ImageList		maImageListH;
//STRIP001 
//STRIP001 	const XColorTable* pColorTable;
//STRIP001 
//STRIP001 #ifdef _SVX_FONTWORK_CXX
//STRIP001  friend class SvxFontWorkChildWindow;
//STRIP001  friend class SvxFontWorkControllerItem;
//STRIP001 
//STRIP001 	DECL_LINK( SelectStyleHdl_Impl, void * );
//STRIP001 	DECL_LINK( SelectAdjustHdl_Impl, void * );
//STRIP001 	DECL_LINK( SelectShadowHdl_Impl, void * );
//STRIP001 
//STRIP001 	DECL_LINK( ModifyInputHdl_Impl, void * );
//STRIP001 	DECL_LINK( InputTimoutHdl_Impl, void * );
//STRIP001 
//STRIP001 	DECL_LINK( FormSelectHdl_Impl, void * );
//STRIP001 	DECL_LINK( ColorSelectHdl_Impl, void * );
//STRIP001 
//STRIP001 
//STRIP001 	void SetStyle_Impl(const XFormTextStyleItem*);
//STRIP001 	void SetAdjust_Impl(const XFormTextAdjustItem*);
//STRIP001 	void SetDistance_Impl(const XFormTextDistanceItem*);
//STRIP001 	void SetStart_Impl(const XFormTextStartItem*);
//STRIP001 	void SetMirror_Impl(const XFormTextMirrorItem*);
//STRIP001 	void SetStdForm_Impl(const XFormTextStdFormItem*);
//STRIP001 	void SetShowForm_Impl(const XFormTextHideFormItem*);
//STRIP001 	void SetOutline_Impl(const XFormTextOutlineItem*);
//STRIP001 	void SetShadow_Impl(const XFormTextShadowItem*,
//STRIP001 						BOOL bRestoreValues = FALSE);
//STRIP001 	void SetShadowColor_Impl(const XFormTextShadowColorItem*);
//STRIP001 	void SetShadowXVal_Impl(const XFormTextShadowXValItem*);
//STRIP001 	void SetShadowYVal_Impl(const XFormTextShadowYValItem*);
//STRIP001 #endif
//STRIP001 
//STRIP001 	virtual void DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001 	void ApplyImageList();
//STRIP001 
//STRIP001  protected:
//STRIP001 	virtual void	Zoom();
//STRIP001 	virtual SfxChildAlignment CheckAlignment( SfxChildAlignment eActAlign,
//STRIP001 											  SfxChildAlignment eAlign );
//STRIP001 
//STRIP001  public:
//STRIP001 	SvxFontWorkDialog(	SfxBindings *pBindinx,
//STRIP001 						SfxChildWindow *pCW,
//STRIP001 						Window* pParent,
//STRIP001 						const ResId& rResId );
//STRIP001 	~SvxFontWorkDialog();
//STRIP001 
//STRIP001 	void SetColorTable(const XColorTable* pTable);
//STRIP001 	void SetActive(BOOL bActivate = TRUE);
//STRIP001 
//STRIP001 	void CreateStdFormObj(SdrView& rView, SdrPageView& rPV,
//STRIP001 						  const SfxItemSet& rAttr, SdrObject& rOldObj,
//STRIP001 						  XFormTextStdForm eForm);
//STRIP001 };

}//end of namespace binfilter
#endif		// _SVX_FONTWORK_HXX

