/*************************************************************************
 *
 *  OpenOffice.org - a multi-platform office productivity suite
 *
 *  $RCSfile: frmsel.hxx,v $
 *
 *  $Revision: 1.5 $
 *
 *  last change: $Author: rt $ $Date: 2005/09/09 13:33:02 $
 *
 *  The Contents of this file are made available subject to
 *  the terms of GNU Lesser General Public License Version 2.1.
 *
 *
 *    GNU Lesser General Public License Version 2.1
 *    =============================================
 *    Copyright 2005 by Sun Microsystems, Inc.
 *    901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *    This library is free software; you can redistribute it and/or
 *    modify it under the terms of the GNU Lesser General Public
 *    License version 2.1, as published by the Free Software Foundation.
 *
 *    This library is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *    Lesser General Public License for more details.
 *
 *    You should have received a copy of the GNU Lesser General Public
 *    License along with this library; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *    MA  02111-1307  USA
 *
 ************************************************************************/
#ifndef _SVX_FRMSEL_HXX
#define _SVX_FRMSEL_HXX

// include ---------------------------------------------------------------

#ifndef _LINK_HXX //autogen
#include <tools/link.hxx>
#endif
#ifndef _WINDOW_HXX //autogen
#include <vcl/ctrl.hxx>
#endif
#ifndef _COLOR_HXX //autogen
#include <tools/color.hxx>
#endif
#ifndef _SV_BITMAP_HXX
#include <vcl/bitmap.hxx>
#endif
// auto strip #ifndef SVX_LINKLINE_HXX
// auto strip #include <bf_svx/linelink.hxx>
// auto strip #endif
namespace binfilter {

// -----------------------------------------------------------------------

	/*-----------------------------------------------------------*\

		Diese Klasse stellt das von Word bekannte Bedienelement
		fuer die Rahmeneinstellung zur Verfuegung.
		Dem Ctor kann dabei uebergeben werden, ob der Rahmen
		einer Tabelle oder eines Absatzes eingestellt werden soll.

	\*-----------------------------------------------------------*/

// enum ------------------------------------------------------------------

//STRIP001 enum SvxFrameSelectorType
//STRIP001 {
//STRIP001 	SVX_FRMSELTYPE_TABLE = 0,
//STRIP001 	SVX_FRMSELTYPE_PARAGRAPH
//STRIP001 };
//STRIP001 enum SvxFrameSelectorLine
//STRIP001 {
//STRIP001 	SVX_FRMSELLINE_NONE = 0,
//STRIP001 	SVX_FRMSELLINE_LEFT,
//STRIP001 	SVX_FRMSELLINE_RIGHT,
//STRIP001 	SVX_FRMSELLINE_TOP,
//STRIP001 	SVX_FRMSELLINE_BOTTOM,
//STRIP001 	SVX_FRMSELLINE_HOR,
//STRIP001 	SVX_FRMSELLINE_VER
//STRIP001 };
//STRIP001 enum SvxFrameLineState
//STRIP001 {
//STRIP001 	SVX_FRMLINESTATE_SHOW = 0,
//STRIP001 	SVX_FRMLINESTATE_HIDE,
//STRIP001 	SVX_FRMLINESTATE_DONT_CARE
//STRIP001 };
//STRIP001 enum SvxFrameShadow
//STRIP001 {
//STRIP001     SVX_FRMSHADOW_NONE = 0,
//STRIP001     SVX_FRMSHADOW_BOT_RIGHT,
//STRIP001     SVX_FRMSHADOW_TOP_RIGHT,
//STRIP001     SVX_FRMSHADOW_BOT_LEFT,
//STRIP001     SVX_FRMSHADOW_TOP_LEFT
//STRIP001 };
//STRIP001 enum SvxSelArrowType
//STRIP001 {
//STRIP001 	SVX_SELARROWTYPE_LEFT = 0,
//STRIP001 	SVX_SELARROWTYPE_RIGHT,
//STRIP001 	SVX_SELARROWTYPE_UP,
//STRIP001 	SVX_SELARROWTYPE_DOWN
//STRIP001 };

// class SvxFrameLine -----------------------------------------------------

//STRIP001 class SvxFrameLine
//STRIP001 {
//STRIP001     friend class SvxFrameSelector;
//STRIP001 
//STRIP001 	Point				aStartPos;		// Stuetzpunkte
//STRIP001 	Point				aMidPos;
//STRIP001 	Point				aEndPos;
//STRIP001 	Color				aColor;			// Farbe
//STRIP001     SvxLineStruct       aStyle;       // interner Style
//STRIP001     SvxLineStruct       aCoreStyle;   // Core Style
//STRIP001     SvxFrameLineState   aState;       // sichtbar? Tristate?
//STRIP001 	BOOL				bIsSelected;	// selektiert?
//STRIP001 
//STRIP001 public:
//STRIP001                         SvxFrameLine();
//STRIP001 
//STRIP001     SvxLineStruct       GetStyle() const { return aCoreStyle; }
//STRIP001 	void				SetStyle( const SvxLineStruct& aStyle );
//STRIP001 	Color				GetColor() const { return aColor; }
//STRIP001 	void				SetColor( const Color& rColor )  { aColor = rColor; }
//STRIP001     SvxFrameLineState   GetState() const { return aState; }
//STRIP001 	void				SetState( SvxFrameLineState eState );
//STRIP001     const Point&        GetStartPos()const  {return aStartPos;}
//STRIP001     const Point&        GetEndPos()const  {return aEndPos;}
//STRIP001     Point&              GetStartPos() {return aStartPos;}
//STRIP001     Point&              GetEndPos() {return aEndPos;}
//STRIP001     BOOL                IsSelected() const {return bIsSelected;}
//STRIP001 
//STRIP001     static struct SvxLineStruct NO_LINE;        // darstellbare Linien-Styles:
//STRIP001 	static struct SvxLineStruct THIN_LINE;
//STRIP001 	static struct SvxLineStruct THICK_LINE;
//STRIP001 	static struct SvxLineStruct THIN_DOUBLE_LINE;
//STRIP001 	static struct SvxLineStruct THICK_DOUBLE_LINE;
//STRIP001 };

// class SvxFrameSelector ------------------------------------------------
//STRIP001 struct SvxFrameSelector_Impl;
//STRIP001 class SvxFrameSelectorAccessible_Impl;

//STRIP001 class SvxFrameSelector : public Control
//STRIP001 {
//STRIP001     friend SvxFrameSelectorAccessible_Impl;
//STRIP001 	friend SvxFrameSelector_Impl;
//STRIP001 
//STRIP001     SvxFrameShadow      eShadow;        // Schattenposition
//STRIP001     Color               aShadowCol;   // aktuelle Schattenfarbe
//STRIP001     BOOL                bIsClicked;
//STRIP001     Link                aSelectLink;
//STRIP001     SvxFrameSelector_Impl*  pImpl;
//STRIP001 
//STRIP001 #ifdef _SVX_FRMSEL_CXX
//STRIP001     void                InitBitmap_Impl();
//STRIP001 	void				DrawSelArrow_Impl( OutputDevice& rDev,
//STRIP001 										   Point aPos,
//STRIP001 										   Color aCol,
//STRIP001 										   SvxSelArrowType eType );
//STRIP001 	void				DrawContents_Impl( OutputDevice& rVirDev );
//STRIP001 	void				DrawFrameLine_Impl( OutputDevice& rVirDev,
//STRIP001 											Point from,
//STRIP001 											Point to,
//STRIP001 											BOOL bHor,
//STRIP001 											SvxLineStruct& dline,
//STRIP001 											SvxLineStruct& lt,
//STRIP001 											SvxLineStruct& lLine,
//STRIP001 											SvxLineStruct& lb,
//STRIP001 											SvxLineStruct& rt,
//STRIP001 											SvxLineStruct& rLine,
//STRIP001 											SvxLineStruct& rb );
//STRIP001 	void				LineClicked_Impl( SvxFrameLine& aLine,
//STRIP001 										  BOOL bShiftPressed,
//STRIP001 										  BOOL bDoubleClick );
//STRIP001     BOOL                IsAnyLineSelected_Impl() const;
//STRIP001     SvxFrameSelectorLine GetFirstSelLineForKey_Impl()const;
//STRIP001 #endif
//STRIP001 
//STRIP001 	inline const Color&	GetPaintColor( const Color& rNormalColor ) const;
//STRIP001 	const Color&		GetDisplayBackgroundColor( void ) const;
//STRIP001 	inline const Color&	GetDisplayBackgroundColor( const StyleSettings& rSettings ) const;
//STRIP001 	void				ToggleOneLine( SvxFrameLine& aCurLine );
//STRIP001 	void				ToggleAllSelectedLines();
//STRIP001 
//STRIP001 protected:
//STRIP001 	virtual void 		Paint( const Rectangle& rRect );
//STRIP001 	virtual void    	MouseButtonDown( const MouseEvent& rMEvt );
//STRIP001 	virtual void    	MouseButtonUp( const MouseEvent& rMEvt );
//STRIP001     virtual void        DataChanged( const DataChangedEvent& rDCEvt );
//STRIP001     virtual void        KeyInput( const KeyEvent& rKEvt );
//STRIP001     virtual void        GetFocus();
//STRIP001     virtual void        LoseFocus();
//STRIP001 
//STRIP001 public:
//STRIP001 						SvxFrameSelector( Window* pParent,
//STRIP001                                           const ResId& rResId);
//STRIP001                         ~SvxFrameSelector();
//STRIP001     void                Initialize(  SvxFrameSelectorType eType, BOOL bDontCare );
//STRIP001 
//STRIP001     SvxFrameLine&       GetLine(SvxFrameSelectorLine eWhich);
//STRIP001 
//STRIP001 	void 				ShowLines();
//STRIP001 	void				HideLines();
//STRIP001 	void				SelectLine( SvxFrameSelectorLine eNewLine,
//STRIP001 									BOOL bSet = TRUE );
//STRIP001 
//STRIP001     SvxFrameShadow      GetShadowPos() const { return eShadow;}
//STRIP001     void                SetShadowPos( SvxFrameShadow eShadowPos ) { eShadow = eShadowPos;}
//STRIP001     Color               GetShadowColor() const {return aShadowCol;}
//STRIP001     void                SetShadowColor( const Color& aColor ) { aShadowCol = aColor; }
//STRIP001 
//STRIP001 	void				SetCurLineColor( const Color& aColor );
//STRIP001     void                SetCurLineStyle( const SvxLineStruct& rStyle );
//STRIP001 
//STRIP001 	void				SetSelectLink(const Link& rLnk) {aSelectLink = rLnk;}
//STRIP001 
//STRIP001 	BOOL				IsDirty() const { return bIsClicked; }
//STRIP001 	BOOL				IsAnyLineSet() const;
//STRIP001 
//STRIP001     virtual ::com::sun::star::uno::Reference< ::com::sun::star::accessibility::XAccessible > CreateAccessible();
//STRIP001 };

}//end of namespace binfilter
#endif

